/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	test.c
 *
 *	@brief	Windows iTRONT[rXR[̃eXgvO.
 *
 *	@author	V 閾
 */
//#include <stdio.h> 
#include "win_itron.h"

#ifndef	NULL
#define	NULL	0
#endif

#include	"kprintf.h"
#define		DEBUG_PRINT								kprintf
#define		TESTCHECK( _no, _fnc, _result, _okcd )	kprintf( "TEST %02d: %s (%s = %d)\n", _no, (_result == _okcd ? "OK" : "NG"), _fnc, _result )


static void	wait_test_end( ID tskId );
static TASK	tsk_test( VP_INT stacd );
static TASK	sem_test( VP_INT stacd );
static TASK	flg_test( VP_INT stacd );
static TASK	mbx_test( VP_INT stacd );
static TASK	dtq_test( VP_INT stacd );
static TASK	mtx_test( VP_INT stacd );
static TASK	mbf_test( VP_INT stacd );
static TASK	por_test( VP_INT stacd );
static TASK	mpf_test( VP_INT stacd );
static TASK	mpl_test( VP_INT stacd );
static TASK	cyc_test( VP_INT stacd );
static TASK	alm_test( VP_INT stacd );
static TASK	int_test( VP_INT stacd );

#ifdef __ITRON3__
static DLYTIME		T100ms;
static DLYTIME		T1s;
#else
static RELTIM		T100ms;
static RELTIM		T1s;
#endif


/****************************************************************************/
/*!
 *	@brief	TvAvP[V.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	startup_target( void )
{
	#ifdef __ITRON3__
	static const T_CTSK	tsk_ctsk = { NULL, TA_HLNG, tsk_test, 10, 0 };
	static const T_CTSK	sem_ctsk = { NULL, TA_HLNG, sem_test, 10, 0 };
	static const T_CTSK	flg_ctsk = { NULL, TA_HLNG, flg_test, 10, 0 };
	static const T_CTSK	mbx_ctsk = { NULL, TA_HLNG, mbx_test, 10, 0 };
	static const T_CTSK	dtq_ctsk = { NULL, TA_HLNG, dtq_test, 10, 0 };
	static const T_CTSK	mtx_ctsk = { NULL, TA_HLNG, mtx_test, 10, 0 };
	static const T_CTSK	mbf_ctsk = { NULL, TA_HLNG, mbf_test, 10, 0 };
	static const T_CTSK	por_ctsk = { NULL, TA_HLNG, por_test, 10, 0 };
	static const T_CTSK	mpf_ctsk = { NULL, TA_HLNG, mpf_test, 10, 0 };
	static const T_CTSK	mpl_ctsk = { NULL, TA_HLNG, mpl_test, 10, 0 };
	static const T_CTSK	cyc_ctsk = { NULL, TA_HLNG, cyc_test, 10, 0 };
	static const T_CTSK	alm_ctsk = { NULL, TA_HLNG, alm_test, 10, 0 };
	static const T_CTSK	int_ctsk = { NULL, TA_HLNG, int_test, 10, 0 };
	#else
	static const T_CTSK	tsk_ctsk = { TA_HLNG, NULL, tsk_test, 10, 0, NULL };
	static const T_CTSK	sem_ctsk = { TA_HLNG, NULL, sem_test, 10, 0, NULL };
	static const T_CTSK	flg_ctsk = { TA_HLNG, NULL, flg_test, 10, 0, NULL };
	static const T_CTSK	mbx_ctsk = { TA_HLNG, NULL, mbx_test, 10, 0, NULL };
	static const T_CTSK	dtq_ctsk = { TA_HLNG, NULL, dtq_test, 10, 0, NULL };
	static const T_CTSK	mtx_ctsk = { TA_HLNG, NULL, mtx_test, 10, 0, NULL };
	static const T_CTSK	mbf_ctsk = { TA_HLNG, NULL, mbf_test, 10, 0, NULL };
	static const T_CTSK	por_ctsk = { TA_HLNG, NULL, por_test, 10, 0, NULL };
	static const T_CTSK	mpf_ctsk = { TA_HLNG, NULL, mpf_test, 10, 0, NULL };
	static const T_CTSK	mpl_ctsk = { TA_HLNG, NULL, mpl_test, 10, 0, NULL };
	static const T_CTSK	cyc_ctsk = { TA_HLNG, NULL, cyc_test, 10, 0, NULL };
	static const T_CTSK	alm_ctsk = { TA_HLNG, NULL, alm_test, 10, 0, NULL };
	static const T_CTSK	int_ctsk = { TA_HLNG, NULL, int_test, 10, 0, NULL };
	#endif

	ER		result;
	int		i;
	SYSTIME	systime;
	systime.utime = 0;
	systime.ltime = 0;

	#ifdef __ITRON3__
	T100ms = 100;
	T1s    = 1000;
	#else
	T100ms.utime = 0;
	T100ms.ltime = 100;
	T1s.utime    = 0;
	T1s.ltime    = 1000;
	#endif

	result = set_tim( &systime ),	DEBUG_PRINT( "set_tim = %d\n", result );
	for( i = 0; i < 5; i++ ){
		dly_tsk( T1s );
		result = get_tim( &systime ),	DEBUG_PRINT( "get_tim = %d now time = %d %d\n", result, systime.utime, systime.ltime );
	}

	cre_tsk(  10, &tsk_ctsk ), sta_tsk(  10, 0 ), wait_test_end(  10 );
	cre_tsk(  20, &sem_ctsk ), sta_tsk(  20, 0 ), wait_test_end(  20 );
	cre_tsk(  30, &flg_ctsk ), sta_tsk(  30, 0 ), wait_test_end(  30 );
	cre_tsk(  40, &mbx_ctsk ), sta_tsk(  40, 0 ), wait_test_end(  40 );
	cre_tsk(  50, &dtq_ctsk ), sta_tsk(  50, 0 ), wait_test_end(  50 );
	cre_tsk(  60, &mtx_ctsk ), sta_tsk(  60, 0 ), wait_test_end(  60 );
	cre_tsk(  70, &mbf_ctsk ), sta_tsk(  70, 0 ), wait_test_end(  70 );
	cre_tsk(  80, &por_ctsk ), sta_tsk(  80, 0 ), wait_test_end(  80 );
	cre_tsk(  90, &mpf_ctsk ), sta_tsk(  90, 0 ), wait_test_end(  90 );
	cre_tsk( 100, &mpl_ctsk ), sta_tsk( 100, 0 ), wait_test_end( 100 );
	cre_tsk( 110, &cyc_ctsk ), sta_tsk( 110, 0 ), wait_test_end( 110 );
	cre_tsk( 120, &alm_ctsk ), sta_tsk( 120, 0 ), wait_test_end( 120 );
	cre_tsk( 130, &int_ctsk ), sta_tsk( 130, 0 ), wait_test_end( 130 );
}

static void	wait_test_end( ID tskId )
{
	T_RTSK	sts;
	ER		result;

	while( 1 ){
		#ifdef __ITRON3__
		result = ref_tsk( &sts, tskId );
		#else
		result = ref_tsk( tskId, &sts );
		#endif
		if( result != E_OK ){
			break;
		}
		if( sts.tskstat == TTS_DMT ){
			break;
		}
	}
}

/****************************************************************************/
// ^XÑeXg.
/****************************************************************************/
static void	tsk_check( ID id, char *str )
{
	ER result;
	T_RTSK rtsk;
	#ifndef __ITRON3__
	T_RTST rtst;
	#endif

	#ifdef __ITRON3__
	result = ref_tsk( &rtsk, id ),	DEBUG_PRINT( "%s : ref_tsk = %d ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "exinf = %d "  , rtsk.exinf   );
		DEBUG_PRINT( "tskpri = %d " , rtsk.tskpri  );
		DEBUG_PRINT( "tskstat = 0x%04X ", rtsk.tskstat );
		DEBUG_PRINT( "tskwait = 0x%04X ", rtsk.tskwait );
		DEBUG_PRINT( "wid = %d "    , rtsk.wid     );
		DEBUG_PRINT( "wupcnt = %d " , rtsk.wupcnt  );
		DEBUG_PRINT( "suscnt = %d " , rtsk.suscnt  );
		DEBUG_PRINT( "tskatr = %d " , rtsk.tskatr  );
		DEBUG_PRINT( "task = %d "   , rtsk.task    );
		DEBUG_PRINT( "itskpri = %d ", rtsk.itskpri );
		DEBUG_PRINT( "stksz = %d\n" , rtsk.stksz   );
	}
	#else
	result = ref_tsk( id, &rtsk ),	DEBUG_PRINT( "%s : ref_tsk = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "tskstat = 0x%04X ", rtsk.tskstat );
		DEBUG_PRINT( "tskpri = %d " , rtsk.tskpri  );
		DEBUG_PRINT( "tskbpri = %d ", rtsk.tskbpri );
		DEBUG_PRINT( "tskwait = 0x%04X ", rtsk.tskwait );
		DEBUG_PRINT( "wobjid = %d " , rtsk.wobjid  );
		DEBUG_PRINT( "lefttmo = %d ", rtsk.lefttmo );
		DEBUG_PRINT( "actcnt = %d " , rtsk.actcnt  );
		DEBUG_PRINT( "wupcnt = %d " , rtsk.wupcnt  );
		DEBUG_PRINT( "suscnt = %d\n", rtsk.suscnt  );
	}
	result = ref_tst( id, &rtst ),	DEBUG_PRINT( "%s : ref_tst = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "tskstat = 0x%04X ", rtst.tskstat );
		DEBUG_PRINT( "tskwait = %d\n"   , rtst.tskwait );
	}
	#endif
}
static TASK	tsk_test1( VP_INT stacd )
{
	DEBUG_PRINT( "tsk_test1( %d )\n", stacd );

	ext_tsk();
}

static TASK	tsk_test2( VP_INT stacd )
{
	ER result;

	DEBUG_PRINT( "tsk_test2( %d )\n", stacd );

	result = tslp_tsk( 100 ),	TESTCHECK( 30, "tslp_tsk" , result, E_TMOUT );	tsk_check( 0, "tsk_test2" );

	result = slp_tsk(),			TESTCHECK( 31, "slp_tsk" , result, E_OK );		tsk_check( 0, "tsk_test2" );

	result = dly_tsk( T1s ),	TESTCHECK( 32, "dly_tsk" , result, E_OK );		tsk_check( 0, "tsk_test2" );

	exd_tsk();
}

static TASK	tsk_test3( VP_INT stacd )
{
	ER result;
	#ifndef __ITRON3__
	PRI pri;
	#endif

	DEBUG_PRINT( "tsk_test3( %d )\n", stacd );

	#ifdef __ITRON3__
	tsk_check( 0, "tsk_test3" );
	result = chg_pri( 0, 40 ),		TESTCHECK( 34, "chg_pri" , result, E_OK  );
	tsk_check( 0, "tsk_test3" );
	#else
	result = get_pri( 0, &pri ),	TESTCHECK( 33, "get_pri" , result, E_OK  ); DEBUG_PRINT( "pri = %d\n", pri );
	result = chg_pri( 0, 40 ),		TESTCHECK( 34, "chg_pri" , result, E_OK  );
	result = get_pri( 0, &pri ),	TESTCHECK( 35, "get_pri" , result, E_OK  ); DEBUG_PRINT( "pri = %d\n", pri );
	result = get_pri( 0, NULL ),	TESTCHECK( 36, "get_pri" , result, E_PAR );
	#endif

	result = slp_tsk(),				TESTCHECK( 37, "slp_tsk" , result, E_RLWAI );	tsk_check( 0, "tsk_test3" );

	slp_tsk();
}

static TASK		tsk_test( VP_INT stacd )
{
	ER result;

	#ifdef __ITRON3__
	static const T_CTSK	tsk0 = { NULL, TA_HLNG, NULL     , 20, 0 };
	static const T_CTSK	tsk1 = { NULL, TA_HLNG, tsk_test1,  0, 0 };
	static const T_CTSK	tsk2 = { NULL, TA_HLNG, tsk_test1, 20, 0 };
	static const T_CTSK	tsk3 = { NULL, TA_HLNG, tsk_test2, 20, 0 };
	static const T_CTSK	tsk4 = { NULL, TA_HLNG, tsk_test3, 30, 0 };
	#else
	static const T_CTSK	tsk0 = { TA_HLNG, NULL, NULL     , 20, 0, NULL };
	static const T_CTSK	tsk1 = { TA_HLNG, NULL, tsk_test1,  0, 0, NULL };
	static const T_CTSK	tsk2 = { TA_HLNG, NULL, tsk_test1, 20, 0, NULL };
	static const T_CTSK	tsk3 = { TA_HLNG, NULL, tsk_test2, 20, 0, NULL };
	static const T_CTSK	tsk4 = { TA_HLNG, (VP_INT)1, tsk_test3, 30, 0, NULL };
	#endif

	DEBUG_PRINT( "================ task test =================\n" );

	result = cre_tsk( 0, &tsk2 ),	TESTCHECK( 1, "cre_tsk" , result, E_ID  );
	result = cre_tsk( 1, NULL  ),	TESTCHECK( 2, "cre_tsk" , result, E_PAR );
	result = cre_tsk( 1, &tsk0 ),	TESTCHECK( 3, "cre_tsk" , result, E_PAR );
	result = cre_tsk( 1, &tsk1 ),	TESTCHECK( 4, "cre_tsk" , result, E_PAR );
	result = cre_tsk( 1, &tsk2 ),	TESTCHECK( 5, "cre_tsk" , result, E_OK  );
	result = cre_tsk( 1, &tsk2 ),	TESTCHECK( 6, "cre_tsk" , result, E_OBJ );
	result = cre_tsk( 2, &tsk3 ),	TESTCHECK( 7, "cre_tsk" , result, E_OK  );
	result = cre_tsk( 4, &tsk4 ),	TESTCHECK( 8, "cre_tsk" , result, E_OK  );
	#ifdef __ITRON4__
	result = acre_tsk( &tsk4 ),		TESTCHECK(  9, "acre_tsk" , result, 3 );
	result = acre_tsk( NULL  ),		TESTCHECK( 10, "acre_tsk" , result, E_PAR );
	#else
	result = cre_tsk( 3, &tsk4 );
	#endif

	result = del_tsk( 0 ),	TESTCHECK( 12, "del_tsk" , result, E_OBJ );
	result = del_tsk( 4 ),	TESTCHECK( 13, "del_tsk" , result, E_OK );
	result = del_tsk( 4 ),	TESTCHECK( 14, "del_tsk" , result, E_NOEXS );
	result = del_tsk( 5 ),	TESTCHECK( 15, "del_tsk" , result, E_NOEXS );

	tsk_check( 1, "tsk_test" );
	result = sta_tsk( 0, (VP_INT)10 ),	TESTCHECK( 16, "sta_tsk" , result, E_OBJ );
	result = sta_tsk( 1, (VP_INT)10 ),	TESTCHECK( 17, "sta_tsk" , result, E_OK  );
	#ifdef __ITRON4__
	result = act_tsk( 0 ),	TESTCHECK( 18, "act_tsk" , result, E_OK );		tsk_check( 0, "tsk_test" );
	result = act_tsk( 0 ),	TESTCHECK( 19, "act_tsk" , result, E_QOVR );	tsk_check( 0, "tsk_test" );
	result = can_act( 0 ),	TESTCHECK( 20, "act_tsk" , result, 1 );			tsk_check( 0, "tsk_test" );

	result = act_tsk( 2 ),	TESTCHECK( 21, "act_tsk" , result, E_OK );
	result = iact_tsk( 3 ),	TESTCHECK( 22, "iact_tsk", result, E_OK );
	#else
	result = sta_tsk( 2, (VP_INT)20 );
	result = sta_tsk( 3, (VP_INT)30 );
	#endif

	dly_tsk( T100ms );
	dly_tsk( T100ms );
	tsk_check( 2, "tsk_test" );
	result = wup_tsk( 2 ),	TESTCHECK( 23, "wup_tsk" , result, E_OK );

	dly_tsk( T100ms );
	result = wup_tsk( 2 ),	TESTCHECK( 24, "wup_tsk" , result, E_OK );
	tsk_check( 2, "tsk_test" );

	result = rel_wai( 3 ),	TESTCHECK( 25, "rel_wai" , result, E_OK );
	tsk_check( 3, "tsk_test" );
	dly_tsk( T100ms );

	result = sus_tsk( 3 ),	TESTCHECK( 26, "sus_tsk" , result, E_OK );
	result = rsm_tsk( 3 ),	TESTCHECK( 27, "rsm_tsk" , result, E_OK );
	result = sus_tsk( 3 );
	result = sus_tsk( 3 );
	tsk_check( 3, "sus_tsk x 2" );
	result = rsm_tsk( 3 );
	tsk_check( 3, "rsm_tsk x 1" );
	result = rsm_tsk( 3 );
	tsk_check( 3, "rsm_tsk x 1" );
	dly_tsk( T100ms );
	result = sus_tsk( 3 );
	result = sus_tsk( 3 );
	tsk_check( 3, "sus_tsk x 2" );
	result = frsm_tsk( 3 ),	TESTCHECK( 28, "frsm_tsk" , result, E_OK );
	tsk_check( 3, "frsm_tsk x 1" );

	result = ter_tsk( 3 ),	TESTCHECK( 29, "ter_tsk" , result, E_OK );
	tsk_check( 3, "tsk_test" );

	dly_tsk( T1s );
	tsk_check( 1, "tsk_test" );
	dly_tsk( T100ms );
	tsk_check( 2, "tsk_test" );
	dly_tsk( T100ms );
	tsk_check( 3, "tsk_test" );
	dly_tsk( T100ms );

	DEBUG_PRINT( "\n\n" );
}

/****************************************************************************/
// Z}tH̃eXg.
/****************************************************************************/
static void	sem_check( ID id, char *str )
{
	ER result;
	T_RSEM rsem;

	#ifdef __ITRON3__
	result = ref_sem( &rsem, id ),	DEBUG_PRINT( "%s : ref_sem = %d ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "exinf  = %d ", rsem.exinf  );
		DEBUG_PRINT( "wtsk   = %d ", rsem.wtsk   );
		DEBUG_PRINT( "semcnt = %d ", rsem.semcnt );
	}
	DEBUG_PRINT( "\n" );
	#else
	result = ref_sem( id, &rsem ),	DEBUG_PRINT( "%s : ref_sem = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "wtskid = %d  ", rsem.wtskid );
		DEBUG_PRINT( "semcnt = %d  ", rsem.semcnt );
	}
	DEBUG_PRINT( "\n" );
	#endif
}

static TASK	sem_test1( VP_INT stacd )
{
	ER result;
	result = wai_sem( 1 ),	DEBUG_PRINT( "sem_test1 : wai_sem = %d\n", result );	sem_check( 1, "sem_test1" );
}

static TASK	sem_test2( VP_INT stacd )
{
	ER result;
	result = wai_sem( 1 ),	DEBUG_PRINT( "sem_test2 : wai_sem = %d\n", result );	sem_check( 1, "sem_test2" );
}

static TASK	sem_test3( VP_INT stacd )
{
	ER result;
	result = wai_sem( 1 ),	DEBUG_PRINT( "sem_test3 : wai_sem = %d\n", result );	sem_check( 1, "sem_test3" );
}

static TASK	sem_test( VP_INT stacd )
{
	ER result;

	#ifdef __ITRON3__
	static const T_CTSK	tsk1 = { NULL, TA_HLNG, sem_test1, 20, 0 };
	static const T_CTSK	tsk2 = { NULL, TA_HLNG, sem_test2, 10, 0 };
	static const T_CTSK	tsk3 = { NULL, TA_HLNG, sem_test3, 10, 0 };
	static const T_CSEM	sem0 = { NULL, TA_TFIFO, 2, 0 };
	static const T_CSEM	sem1 = { NULL, TA_TFIFO, 3, 2 };
	static const T_CSEM	sem2 = { NULL, TA_TPRI, 2, 2 };
	#else
	static const T_CTSK	tsk1 = { TA_HLNG, NULL, sem_test1, 20, 0, NULL };
	static const T_CTSK	tsk2 = { TA_HLNG, NULL, sem_test2, 10, 0, NULL };
	static const T_CTSK	tsk3 = { TA_HLNG, NULL, sem_test3, 10, 0, NULL };
	static const T_CSEM	sem0 = { TA_TFIFO, 2, 0 };
	static const T_CSEM	sem1 = { TA_TFIFO, 3, 2 };
	static const T_CSEM	sem2 = { TA_TFIFO, 2, 2 };
//	static const T_CSEM	sem2 = { TA_TPRI, 2, 2 };
	#endif

	DEBUG_PRINT( "================ semaphore test =================\n" );
	result = cre_sem( 0, &sem2 ),	TESTCHECK( 1, "cre_sem" , result, E_ID );
	result = cre_sem( 1, NULL  ),	TESTCHECK( 2, "cre_sem" , result, E_PAR );
	result = cre_sem( 1, &sem0 ),	TESTCHECK( 3, "cre_sem" , result, E_PAR );
	result = cre_sem( 1, &sem1 ),	TESTCHECK( 4, "cre_sem" , result, E_PAR );
	result = cre_sem( 1, &sem2 ),	TESTCHECK( 5, "cre_sem" , result, E_OK );
	result = cre_sem( 2, &sem2 ),	TESTCHECK( 6, "cre_sem" , result, E_OK );
	result = cre_sem( 4, &sem2 ),	TESTCHECK( 7, "cre_sem" , result, E_OK );
	#ifdef __ITRON4__
	result = acre_sem( &sem2 ),		TESTCHECK( 8, "acre_sem" , result, 3 );
	#endif

	result = del_sem( 0 ),	TESTCHECK(  9, "del_sem" , result, E_ID );
	result = del_sem( 4 ),	TESTCHECK( 10, "del_sem" , result, E_OK );
	result = del_sem( 4 ),	TESTCHECK( 11, "del_sem" , result, E_NOEXS );
	result = del_sem( 5 ),	TESTCHECK( 12, "del_sem" , result, E_NOEXS );
	#ifdef __ITRON4__
	result = del_sem( 3 ),	TESTCHECK( 13, "del_sem" , result, E_OK );
	#endif
	result = del_sem( 2 ),	TESTCHECK( 14, "del_sem" , result, E_OK );

	sem_check( 1, "sem_test" );
	result = wai_sem( 1 ),	TESTCHECK( 15, "wai_sem" , result, E_OK );		sem_check( 1, "sem_test" );
	result = pol_sem( 1 ),	TESTCHECK( 16, "pol_sem" , result, E_OK );		sem_check( 1, "sem_test" );
	result = pol_sem( 1 ),	TESTCHECK( 17, "pol_sem" , result, E_TMOUT );	sem_check( 1, "sem_test" );

	result = cre_tsk( 21, &tsk1 );
	result = cre_tsk( 22, &tsk2 );
	result = cre_tsk( 23, &tsk3 );
	result = sta_tsk( 21, 0 );
	dly_tsk( T100ms );
	result = sta_tsk( 22, 0 );
	dly_tsk( T100ms );
	result = sta_tsk( 23, 0 );

	result = twai_sem( 1, 1000 ),	TESTCHECK( 18, "twai_sem", result, E_TMOUT );	sem_check( 1, "sem_test" );
	result = sig_sem( 1 ),			TESTCHECK( 19, "sig_sem" , result, E_OK );		sem_check( 1, "sem_test" );
	result = sig_sem( 1 ),			TESTCHECK( 20, "sig_sem" , result, E_OK );		sem_check( 1, "sem_test" );
	result = sig_sem( 1 ),			TESTCHECK( 21, "sig_sem" , result, E_OK );		sem_check( 1, "sem_test" );

	dly_tsk( T1s );
	DEBUG_PRINT( "\n\n" );
}

/****************************************************************************/
// CxgtÕeXg.
/****************************************************************************/
static void	flg_check( ID id, char *str )
{
	ER result;
	T_RFLG rflg;

	#ifdef __ITRON3__
	result = ref_flg( &rflg, id ),	DEBUG_PRINT( "%s : ref_flg = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "exinf  = %d  ", rflg.exinf  );
		DEBUG_PRINT( "wtsk   = %d  ", rflg.wtsk   );
		DEBUG_PRINT( "flgptn = 0x%08X  ", rflg.flgptn );
	}
	DEBUG_PRINT( "\n" );
	#else
	result = ref_flg( id, &rflg ),	DEBUG_PRINT( "%s : ref_flg = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "wtskid = %d  ", rflg.wtskid );
		DEBUG_PRINT( "flgptn = 0x%08X  ", rflg.flgptn );
	}
	DEBUG_PRINT( "\n" );
	#endif
}

static TASK	flg_test1( VP_INT stacd )
{
	ER result;

	#ifdef __ITRON3__
	UINT	flgptn;
	result = wai_flg( &flgptn , 2, 0x02, TWF_ANDW ),		DEBUG_PRINT( "flg_test1 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 2, "flg_test1" );
	result = wai_flg( &flgptn , 3, 0x02, TWF_ANDW ),		DEBUG_PRINT( "flg_test1 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 3, "flg_test1" );
	result = pol_flg( &flgptn , 3, 0x02, TWF_ANDW ),		DEBUG_PRINT( "flg_test1 : pol_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 3, "flg_test1" );
	result = twai_flg( &flgptn , 3, 0x02, TWF_ANDW, 1000 ),	DEBUG_PRINT( "flg_test1 : twai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 3, "flg_test1" );
	result = wai_flg( &flgptn , 4, 0x01, TWF_ANDW ),		DEBUG_PRINT( "flg_test1 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 4, "flg_test1" );
	result = wai_flg( &flgptn , 1, 0x03, TWF_ORW ),			DEBUG_PRINT( "flg_test1 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 1, "flg_test1" );
	#else
	FLGPTN	flgptn;
	result = wai_flg( 2, 0x02, TWF_ANDW, &flgptn ),			DEBUG_PRINT( "flg_test1 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 2, "flg_test1" );
	result = wai_flg( 3, 0x02, TWF_ANDW, &flgptn ),			DEBUG_PRINT( "flg_test1 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 3, "flg_test1" );
	result = pol_flg( 3, 0x02, TWF_ANDW, &flgptn ),			DEBUG_PRINT( "flg_test1 : pol_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 3, "flg_test1" );
	result = twai_flg( 3, 0x02, TWF_ANDW, &flgptn, 1000 ),	DEBUG_PRINT( "flg_test1 : twai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 3, "flg_test1" );
	result = wai_flg( 4, 0x01, TWF_ANDW, &flgptn ),			DEBUG_PRINT( "flg_test1 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 4, "flg_test1" );
	result = wai_flg( 1, 0x03, TWF_ORW, &flgptn ),			DEBUG_PRINT( "flg_test1 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 1, "flg_test1" );
	#endif
}

static TASK	flg_test2( VP_INT stacd )
{
	ER result;

	#ifdef __ITRON3__
	UINT	flgptn;
	result = wai_flg( &flgptn , 2, 0x02, TWF_ANDW ),	DEBUG_PRINT( "flg_test2 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 2, "flg_test2" );
	result = wai_flg( &flgptn , 3, 0x02, TWF_ANDW ),	DEBUG_PRINT( "flg_test2 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 3, "flg_test2" );
	result = wai_flg( &flgptn , 4, 0x01, TWF_ANDW ),	DEBUG_PRINT( "flg_test2 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 4, "flg_test2" );
	#else
	FLGPTN	flgptn;
	result = wai_flg( 2, 0x02, TWF_ANDW, &flgptn ),		DEBUG_PRINT( "flg_test2 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 2, "flg_test2" );
	result = wai_flg( 3, 0x02, TWF_ANDW, &flgptn ),		DEBUG_PRINT( "flg_test2 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 3, "flg_test2" );
	result = wai_flg( 4, 0x01, TWF_ANDW, &flgptn ),		DEBUG_PRINT( "flg_test2 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 4, "flg_test2" );
	#endif
}

static TASK	flg_test3( VP_INT stacd )
{
	ER result;
	#ifdef __ITRON3__
	UINT	flgptn;
	result = wai_flg( &flgptn , 2, 0x02, TWF_ANDW ),			DEBUG_PRINT( "flg_test3 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 2, "flg_test3" );
	result = wai_flg( &flgptn , 3, 0x02, TWF_ANDW ),			DEBUG_PRINT( "flg_test3 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 3, "flg_test3" );
	result = wai_flg( &flgptn, 4, 0x01, TWF_ANDW | TWF_CLR ),	DEBUG_PRINT( "flg_test3 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 4, "flg_test3" );
	#else
	FLGPTN	flgptn;
	result = wai_flg( 2, 0x02, TWF_ANDW, &flgptn ),				DEBUG_PRINT( "flg_test3 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 2, "flg_test3" );
	result = wai_flg( 3, 0x02, TWF_ANDW, &flgptn ),				DEBUG_PRINT( "flg_test3 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 3, "flg_test3" );
	result = wai_flg( 4, 0x01, TWF_ANDW | TWF_CLR, &flgptn ),	DEBUG_PRINT( "flg_test3 : wai_flg = %d flgptn = 0x%08X\n", result, flgptn );	flg_check( 4, "flg_test3" );
	#endif
}

static TASK	flg_test( VP_INT stacd )
{
	ER result;

	#ifdef __ITRON3__
	static const T_CTSK	tsk1 = { NULL, TA_HLNG, flg_test1, 30, 0 };
	static const T_CTSK	tsk2 = { NULL, TA_HLNG, flg_test2, 20, 0 };
	static const T_CTSK	tsk3 = { NULL, TA_HLNG, flg_test3, 10, 0 };
	static const T_CFLG	flg1 = { NULL, TA_TFIFO | TA_WSGL, 0x00 };
	static const T_CFLG	flg2 = { NULL, TA_TFIFO | TA_WMUL, 0x02 };
	static const T_CFLG	flg3 = { NULL, TA_TFIFO | TA_WMUL | TA_CLR , 0x00 };
//	static const T_CFLG	flg3 = { NULL, TA_TPRI  | TA_WMUL | TA_CLR , 0x00 };
	#else
	static const T_CTSK	tsk1 = { TA_HLNG, NULL, flg_test1, 30, 0, NULL };
	static const T_CTSK	tsk2 = { TA_HLNG, NULL, flg_test2, 20, 0, NULL };
	static const T_CTSK	tsk3 = { TA_HLNG, NULL, flg_test3, 10, 0, NULL };
	static const T_CFLG	flg1 = { TA_TFIFO | TA_WSGL, 0x00 };
	static const T_CFLG	flg2 = { TA_TFIFO | TA_WMUL, 0x02 };
//	static const T_CFLG	flg3 = { TA_TFIFO | TA_WMUL | TA_CLR , 0x02 };
	static const T_CFLG	flg3 = { TA_TPRI | TA_WMUL | TA_CLR , 0x02 };
	#endif

	DEBUG_PRINT( "================ event flag test =================\n" );
	result = cre_flg( 0, &flg1 ),	TESTCHECK( 1, "cre_flg" , result, E_ID );
	result = cre_flg( 4, NULL ),	TESTCHECK( 2, "cre_flg" , result, E_PAR );
	result = cre_flg( 4, &flg1 ),	TESTCHECK( 3, "cre_flg" , result, E_OK );
	result = cre_flg( 4, &flg1 ),	TESTCHECK( 4, "cre_flg" , result, E_OBJ );
	result = cre_flg( 2, &flg2 ),	TESTCHECK( 5, "cre_flg" , result, E_OK );
	result = cre_flg( 3, &flg3 ),	TESTCHECK( 6, "cre_flg" , result, E_OK );
	#ifdef __ITRON4__
	result = acre_flg( &flg1 ),		TESTCHECK( 7, "acre_flg" , result, 1 );
	result = acre_flg( NULL ),		TESTCHECK( 8, "acre_flg" , result, E_PAR );
	#else
	result = cre_flg( 1, &flg1 );
	#endif

	flg_check( 3, "flg_test" );
	result = clr_flg( 3, ~0x02 ),	TESTCHECK( 9, "clr_flg" , result, E_OK );
	flg_check( 3, "flg_test" );

	result = cre_tsk( 31, &tsk1 );
	result = cre_tsk( 32, &tsk2 );
	result = cre_tsk( 33, &tsk3 );
	result = sta_tsk( 31, 0 );
	dly_tsk( T100ms );
	result = sta_tsk( 32, 0 );
	dly_tsk( T100ms );
	result = sta_tsk( 33, 0 );

	dly_tsk( T100ms );
	result = set_flg( 3, 0x02 ),	TESTCHECK( 10, "set_flg" , result, E_OK );

	dly_tsk( T100ms );
	result = set_flg( 3, 0x02 ),	TESTCHECK( 11, "set_flg" , result, E_OK );

	dly_tsk( T100ms );
	result = set_flg( 3, 0x02 ),	TESTCHECK( 12, "set_flg" , result, E_OK );

	dly_tsk( T100ms );
	result = set_flg( 4, 0x02 ),	TESTCHECK( 13, "set_flg" , result, E_OK );

	dly_tsk( T100ms );
	result = set_flg( 4, 0x01 ),	TESTCHECK( 14, "set_flg" , result, E_OK );

	dly_tsk( T100ms );
	result = set_flg( 4, 0x01 ),	TESTCHECK( 15, "set_flg" , result, E_OK );

	dly_tsk( T1s );
	result = set_flg( 1, 0x02 ),	TESTCHECK( 16, "set_flg" , result, E_OK );

	dly_tsk( T1s );
	DEBUG_PRINT( "\n\n" );
}

/****************************************************************************/
// [{bNX̃eXg.
/****************************************************************************/
typedef struct {
	T_MSG	hdr;
	unsigned char	data[2];
} T_MSGEX;

static void	mbx_check( ID id, char *str )
{
	ER result;
	T_RMBX rmbx;

	#ifdef __ITRON3__
	result = ref_mbx( &rmbx, id ),	DEBUG_PRINT( "%s : ref_mbx = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "exinf = %d  " , rmbx.exinf  );
		DEBUG_PRINT( "wtsk = %d  "  , rmbx.wtsk   );
		DEBUG_PRINT( "pk_msg = %d  ", rmbx.pk_msg );
		if( rmbx.pk_msg ){
			DEBUG_PRINT( "msgpri = %d  ", rmbx.pk_msg->msgpri );
			DEBUG_PRINT( "data = %d  "  , *((unsigned char *)((unsigned long)rmbx.pk_msg + sizeof(T_MSG))) );
		}
	}
	DEBUG_PRINT( "\n" );
	#else
	result = ref_mbx( id, &rmbx ),	DEBUG_PRINT( "%s : ref_mbx = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "wtskid = %d  ", rmbx.wtskid );
		DEBUG_PRINT( "pk_msg = %d  ", rmbx.pk_msg );
		if( rmbx.pk_msg ){
			DEBUG_PRINT( "msgpri = %d  ", rmbx.pk_msg->msgpri );
			DEBUG_PRINT( "data = %d  "  , *((unsigned char *)((unsigned long)rmbx.pk_msg + sizeof(T_MSG))) );
		}
	}
	DEBUG_PRINT( "\n" );
	#endif
}
static TASK	mbx_test1( VP_INT stacd )
{
	ER result;
	T_MSG *ptr;

	#ifdef __ITRON3__
	result = prcv_msg( &ptr, 1 ),		TESTCHECK( 17, "prcv_msg", result, E_TMOUT );	mbx_check( 1, "mbx_test1" );
	result = trcv_msg( &ptr, 1, 200 ),	TESTCHECK( 18, "trcv_msg", result, E_TMOUT );	mbx_check( 1, "mbx_test1" );
	result = rcv_msg(  &ptr, 1 ),		TESTCHECK( 19, "rcv_msg" , result, E_OK );		mbx_check( 1, "mbx_test1" );
	#else
	result = prcv_msg( 1, &ptr ),		TESTCHECK( 17, "prcv_msg", result, E_TMOUT );	mbx_check( 1, "mbx_test1" );
	result = trcv_msg( 1, &ptr, 200 ),	TESTCHECK( 18, "trcv_msg", result, E_TMOUT );	mbx_check( 1, "mbx_test1" );
	result = rcv_msg(  1, &ptr ),		TESTCHECK( 19, "rcv_msg" , result, E_OK );		mbx_check( 1, "mbx_test1" );
	#endif
	if( ptr ){
		DEBUG_PRINT( "msgpri = %d data = %d\n", ptr->msgpri, ((T_MSGEX *)ptr)->data[0] );
	}
	#ifdef __ITRON3__
	result = prcv_msg( &ptr, 2 ),		TESTCHECK( 20, "prcv_msg", result, E_OK );	mbx_check( 1, "mbx_test1" );
	#else
	result = prcv_msg( 2, &ptr ),		TESTCHECK( 20, "prcv_msg", result, E_OK );	mbx_check( 1, "mbx_test1" );
	#endif
	if( ptr ){
		DEBUG_PRINT( "msgpri = %d data = %d\n", ptr->msgpri, ((T_MSGEX *)ptr)->data[0] );
	}
	#ifdef __ITRON3__
	result = trcv_msg( &ptr, 2, 200 ),	TESTCHECK( 21, "trcv_msg", result, E_OK );	mbx_check( 1, "mbx_test1" );
	#else
	result = trcv_msg( 2, &ptr, 200 ),	TESTCHECK( 21, "trcv_msg", result, E_OK );	mbx_check( 1, "mbx_test1" );
	#endif
	if( ptr ){
		DEBUG_PRINT( "msgpri = %d data = %d\n", ptr->msgpri, ((T_MSGEX *)ptr)->data[0] );
	}
}

static TASK	mbx_test( VP_INT stacd )
{
	ER result;
	T_MSGEX msg[3];
	T_MSG *ptr;

	#ifdef __ITRON3__
	static const T_CTSK	tsk1 = { NULL, TA_HLNG, mbx_test1, 20, 0 };
	static const T_CMBX	mbx1 = { NULL, TA_TFIFO | TA_MFIFO };
	static const T_CMBX	mbx2 = { NULL, TA_TFIFO | TA_MPRI  };
	#else
	static const T_CTSK	tsk1 = { TA_HLNG, NULL, mbx_test1, 20, 0, NULL };
	static const T_CMBX	mbx0 = { TA_TFIFO | TA_MPRI , 0 };
	static const T_CMBX	mbx1 = { TA_TFIFO | TA_MFIFO, 0 };
	static const T_CMBX	mbx2 = { TA_TFIFO | TA_MPRI , 2 };
	#endif

	DEBUG_PRINT( "================ mail box test =================\n" );

	#ifdef __ITRON4__
	result = cre_mbx( 1, &mbx0 ),	TESTCHECK( 1, "cre_mbx" , result, E_PAR );
	#endif
	result = cre_mbx( 0, &mbx1 ),	TESTCHECK( 2, "cre_mbx" , result, E_ID );
	result = cre_mbx( 1, NULL  ),	TESTCHECK( 3, "cre_mbx" , result, E_PAR );
	result = cre_mbx( 1, &mbx1 ),	TESTCHECK( 4, "cre_mbx" , result, E_OK );
	result = cre_mbx( 1, &mbx1 ),	TESTCHECK( 5, "cre_mbx" , result, E_OBJ );
	result = cre_mbx( 2, &mbx2 ),	TESTCHECK( 6, "cre_mbx" , result, E_OK );
	result = cre_mbx( 4, &mbx1 ),	TESTCHECK( 7, "cre_mbx" , result, E_OK );
	#ifdef __ITRON4__
	result = acre_mbx( &mbx1 ),		TESTCHECK( 8, "acre_mbx" , result, 3 );
	result = acre_mbx( NULL  ),		TESTCHECK( 9, "acre_mbx" , result, E_PAR );
	#endif

	result = del_mbx( 0 ),	TESTCHECK( 10, "del_mbx" , result, E_ID );
	result = del_mbx( 4 ),	TESTCHECK( 11, "del_mbx" , result, E_OK );
	result = del_mbx( 4 ),	TESTCHECK( 12, "del_mbx" , result, E_NOEXS );
	result = del_mbx( 5 ),	TESTCHECK( 13, "del_mbx" , result, E_NOEXS );
	#ifdef __ITRON4__
	result = del_mbx( 3 ),	TESTCHECK( 14, "del_mbx" , result, E_OK );
	#endif

	mbx_check( 1, "mbx_test" );
	msg[0].hdr.msgpri = 1;
	msg[0].data[0]    = 10;
	result = snd_msg( 1, (T_MSG *)&msg[0] ),	TESTCHECK( 15, "snd_msg" , result, E_OK );		mbx_check( 1, "mbx_test" );
	#ifdef __ITRON3__
	result = rcv_msg( &ptr, 1 ),	TESTCHECK( 16, "rcv_msg" , result, E_OK );		mbx_check( 1, "mbx_test" );
	#else
	result = rcv_msg( 1, &ptr ),	TESTCHECK( 16, "rcv_msg" , result, E_OK );		mbx_check( 1, "mbx_test" );
	#endif
	if( ptr ){
		DEBUG_PRINT( "msgpri = %d data = %d\n", ptr->msgpri, ((T_MSGEX *)ptr)->data[0] );
	}

	msg[1].hdr.msgpri = 3;
	msg[1].data[0]    = 20;
	result = snd_msg( 2, (T_MSG *)&msg[1] );

	msg[2].hdr.msgpri = 2;
	msg[2].data[0]    = 30;
	result = snd_msg( 2, (T_MSG *)&msg[2] );

	result = cre_tsk( 41, &tsk1 );
	result = sta_tsk( 41, 0 );
	dly_tsk( T1s );
	mbx_check( 1, "mbx_test" );

	msg[0].hdr.msgpri = 1;
	msg[0].data[0]    = 20;
	result = snd_msg( 1, (T_MSG *)&msg[0] );
	mbx_check( 1, "mbx_test" );
	dly_tsk( T1s );


	DEBUG_PRINT( "\n\n" );
}

/****************************************************************************/
// f[^L[̃eXg.
/****************************************************************************/
#ifndef __ITRON3__
static void	dtq_check( ID id, char *str )
{
	ER result;
	T_RDTQ rdtq;

	result = ref_dtq( id, &rdtq ),	DEBUG_PRINT( "%s : ref_dtq = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "stskid = %d  " , rdtq.stskid  );
		DEBUG_PRINT( "rtskid = %d  " , rdtq.rtskid  );
		DEBUG_PRINT( "sdtqcnt = %d  ", rdtq.sdtqcnt );
	}
	DEBUG_PRINT( "\n" );
}
static TASK	dtq_test1( VP_INT stacd )
{
	ER result;
	VP_INT	val;

	result = prcv_dtq( 1, &val ),		TESTCHECK( 16, "prcv_dtq", result, E_TMOUT );	dtq_check( 1, "dtq_test1" );
	result = trcv_dtq( 1, &val, 200 ),	TESTCHECK( 17, "trcv_dtq", result, E_TMOUT );	dtq_check( 1, "dtq_test1" );
	result = rcv_dtq(  1, &val ),		TESTCHECK( 18, "rcv_dtq" , result, E_OK );		dtq_check( 1, "dtq_test1" );
	DEBUG_PRINT( "val = %d\n", val );

	result = snd_dtq(   1, (VP_INT)3 ),			TESTCHECK( 19, "snd_dtq", result, E_OK );		dtq_check( 1, "dtq_test1" );
	result = snd_dtq(   1, (VP_INT)4 ),			TESTCHECK( 20, "snd_dtq", result, E_OK );		dtq_check( 1, "dtq_test1" );
	result = psnd_dtq(  1, (VP_INT)5 ),			TESTCHECK( 21, "psnd_dtq", result, E_TMOUT );	dtq_check( 1, "dtq_test1" );
	result = ipsnd_dtq( 1, (VP_INT)6 ),			TESTCHECK( 22, "ipsnd_dtq", result, E_TMOUT );	dtq_check( 1, "dtq_test1" );
	result = tsnd_dtq(  1, (VP_INT)7, 200 ),	TESTCHECK( 23, "tsnd_dtq", result, E_TMOUT );	dtq_check( 1, "dtq_test1" );
	result = fsnd_dtq(  1, (VP_INT)8 ),			TESTCHECK( 24, "fsnd_dtq", result, E_OK );		dtq_check( 1, "dtq_test1" );
	result = ifsnd_dtq( 1, (VP_INT)9 ),			TESTCHECK( 25, "ifsnd_dtq", result, E_OK );		dtq_check( 1, "dtq_test1" );
	result = snd_dtq(   1, (VP_INT)10 ),		TESTCHECK( 26, "snd_dtq" , result, E_OK );		dtq_check( 1, "dtq_test1" );
	result = snd_dtq(   2, (VP_INT)100 ),		TESTCHECK( 27, "snd_dtq" , result, E_OK );		dtq_check( 2, "dtq_test1" );

}
#endif
static TASK	dtq_test( VP_INT stacd )
{
#ifndef __ITRON3__
	ER result;
	VP_INT	val;
	static const T_CTSK	tsk1 = { TA_HLNG, NULL, dtq_test1, 20, 0, NULL };
	static const T_CDTQ	dtq0 = { TA_TFIFO, 0, NULL };
	static const T_CDTQ	dtq1 = { TA_TFIFO, 2, NULL };

	DEBUG_PRINT( "================ data queue test =================\n" );

	result = cre_dtq( 0, &dtq1 ),	TESTCHECK(  1, "cre_dtq" , result, E_ID );
	result = cre_dtq( 1, NULL  ),	TESTCHECK(  2, "cre_dtq" , result, E_PAR );
	result = cre_dtq( 1, &dtq1 ),	TESTCHECK(  4, "cre_dtq" , result, E_OK );
	result = cre_dtq( 1, &dtq1 ),	TESTCHECK(  5, "cre_dtq" , result, E_OBJ );
	result = cre_dtq( 2, &dtq0 ),	TESTCHECK(  6, "cre_dtq" , result, E_OK );
	result = cre_dtq( 4, &dtq1 ),	TESTCHECK(  7, "cre_dtq" , result, E_OK );
	result = acre_dtq( &dtq1 ),		TESTCHECK(  8, "acre_dtq" , result, 3 );
	result = acre_dtq( NULL ),		TESTCHECK(  9, "acre_dtq" , result, E_PAR );

	result = del_dtq( 0 ),			TESTCHECK( 10, "del_dtq" , result, E_ID );
	result = del_dtq( 4 ),			TESTCHECK( 11, "del_dtq" , result, E_OK );
	result = del_dtq( 4 ),			TESTCHECK( 12, "del_dtq" , result, E_NOEXS );
	result = del_dtq( 5 ),			TESTCHECK( 13, "del_dtq" , result, E_NOEXS );

	dtq_check( 1, "dtq_test" );
	result = snd_dtq( 1, (VP_INT)1 ),	TESTCHECK( 14, "snd_dtq", result, E_OK );	dtq_check( 1, "dtq_test" );
	result = rcv_dtq( 1, &val ),		TESTCHECK( 15, "rcv_dtq", result, E_OK );	dtq_check( 1, "dtq_test" );
	DEBUG_PRINT( "val = %d\n", val );

	result = cre_tsk( 51, &tsk1 );
	result = sta_tsk( 51, 0 );

	dly_tsk( T1s );
	dtq_check( 1, "dtq_test" );
	result = snd_dtq( 1, (VP_INT)2 );

	dly_tsk( T1s );
	dtq_check( 1, "dtq_test" );
	result = rcv_dtq( 1, &val ),	dtq_check( 1, "dtq_test" );
	DEBUG_PRINT( "val = %d\n", val );

	result = rcv_dtq( 1, &val ),	dtq_check( 1, "dtq_test" );
	DEBUG_PRINT( "val = %d\n", val );

	result = rcv_dtq( 1, &val ),	dtq_check( 1, "dtq_test" );
	DEBUG_PRINT( "val = %d\n", val );

	dly_tsk( T1s );
	dtq_check( 1, "dtq_test" );
	result = rcv_dtq( 2, &val ),	dtq_check( 1, "dtq_test" );
	DEBUG_PRINT( "val = %d\n", val );

	DEBUG_PRINT( "\n\n" );
#endif
}

/****************************************************************************/
// ~[ebNX̃eXg.
/****************************************************************************/
#ifndef __ITRON3__
static void	mtx_check( ID id, char *str )
{
	ER result;
	T_RMTX rmtx;

	result = ref_mtx( id, &rmtx ),	DEBUG_PRINT( "%s : ref_mtx = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "htskid = %d  ", rmtx.htskid );
		DEBUG_PRINT( "wtskid = %d  ", rmtx.wtskid );
	}
	DEBUG_PRINT( "\n" );
}
static TASK	mtx_test1( VP_INT stacd )
{
	ER result;

	result = ploc_mtx( 1 ),			TESTCHECK( 15, "ploc_mtx", result, E_TMOUT );	mtx_check( 1, "mtx_test1" );
	result = tloc_mtx( 1, 200 ),	TESTCHECK( 16, "tloc_mtx", result, E_TMOUT );	mtx_check( 1, "mtx_test1" );
	result = loc_mtx( 1 ),			TESTCHECK( 17, "loc_mtx" , result, E_OK );		mtx_check( 1, "mtx_test1" );
	result = loc_mtx( 1 ),			TESTCHECK( 18, "loc_mtx" , result, E_ILUSE );	mtx_check( 1, "mtx_test1" );
	result = unl_mtx( 1 ),			TESTCHECK( 19, "unl_mtx" , result, E_OK );		mtx_check( 1, "mtx_test1" );
}
#endif
static TASK	mtx_test( VP_INT stacd )
{
#ifndef __ITRON3__
	ER result;
	static const T_CTSK	tsk1 = { TA_HLNG, NULL, mtx_test1, 20, 0, NULL };
	static const T_CMTX	mtx0 = { TA_TFIFO, 0 };

	DEBUG_PRINT( "================ mutex test =================\n" );

	result = cre_mtx( 0, &mtx0 ),	TESTCHECK(  1, "cre_mtx" , result, E_ID );
	result = cre_mtx( 1, NULL  ),	TESTCHECK(  2, "cre_mtx" , result, E_PAR );
	result = cre_mtx( 1, &mtx0 ),	TESTCHECK(  3, "cre_mtx" , result, E_OK );
	result = cre_mtx( 2, &mtx0 ),	TESTCHECK(  4, "cre_mtx" , result, E_OK );
	result = cre_mtx( 4, &mtx0 ),	TESTCHECK(  5, "cre_mtx" , result, E_OK );
	result = acre_mtx( &mtx0 ),		TESTCHECK(  6, "acre_mtx" , result, 3 );
	result = acre_mtx( NULL ),		TESTCHECK(  7, "acre_mtx" , result, E_PAR );

	result = del_mtx( 0 ),			TESTCHECK(  8, "del_mtx" , result, E_ID );
	result = del_mtx( 4 ),			TESTCHECK(  9, "del_mtx" , result, E_OK );
	result = del_mtx( 4 ),			TESTCHECK( 10, "del_mtx" , result, E_NOEXS );
	result = del_mtx( 5 ),			TESTCHECK( 11, "del_mtx" , result, E_NOEXS );
	result = del_mtx( 3 ),			TESTCHECK( 12, "del_mtx" , result, E_OK );

	mtx_check( 1, "mtx_test" );
	result = loc_mtx( 1 ),			TESTCHECK( 13, "loc_mtx", result, E_OK );	mtx_check( 1, "mtx_test" );
	result = unl_mtx( 1 ),			TESTCHECK( 14, "unl_mtx", result, E_OK );	mtx_check( 1, "mtx_test" );

	result = loc_mtx( 1 );
	result = cre_tsk( 61, &tsk1 );
	result = sta_tsk( 61, 0 );
	dly_tsk( T1s );
	mtx_check( 1, "mtx_test" );
	result = unl_mtx( 1 );
	dly_tsk( T1s );

	DEBUG_PRINT( "\n\n" );
#endif
}

/****************************************************************************/
// bZ[Wobt@̃eXg.
/****************************************************************************/
static void	mbf_check( ID id, char *str )
{
	ER result;
	T_RMBF rmbf;

	#ifdef __ITRON3__
	result = ref_mbf( &rmbf, id ),	DEBUG_PRINT( "%s : ref_mbf = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "exinf = %d  "  , rmbf.exinf   );
		DEBUG_PRINT( "wtsk = %d  "   , rmbf.wtsk    );
		DEBUG_PRINT( "stsk = %d  "   , rmbf.stsk    );
		DEBUG_PRINT( "msgsz = %d  "  , rmbf.msgsz   );
		DEBUG_PRINT( "frbufsz = %d  ", rmbf.frbufsz );
	}
	DEBUG_PRINT( "\n" );
	#else
	result = ref_mbf( id, &rmbf ),	DEBUG_PRINT( "%s : ref_mbf = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "stskid = %d  " , rmbf.stskid );
		DEBUG_PRINT( "rtskid = %d  " , rmbf.rtskid );
		DEBUG_PRINT( "smsgcnt = %d  ", rmbf.smsgcnt );
		DEBUG_PRINT( "fmbfsz = %d  " , rmbf.fmbfsz );
	}
	DEBUG_PRINT( "\n" );
	#endif
}
static TASK	mbf_test1( VP_INT stacd )
{
	ER result;
	INT len;
	unsigned char data[10];

	#ifdef __ITRON3__
	result = prcv_mbf( data, &len, 1 ),			TESTCHECK( 22, "prcv_mbf", result, E_TMOUT );	mbf_check( 1, "mbf_test1" );
	result = trcv_mbf( data, &len, 1, 200 ),	TESTCHECK( 23, "trcv_mbf", result, E_TMOUT );	mbf_check( 1, "mbf_test1" );
	result = rcv_mbf(  data, &len, 1 ),			TESTCHECK( 24, "rcv_mbf" , result, E_OK );		mbf_check( 1, "mbf_test1" );
	#else
	result = prcv_mbf( 1, data ),				TESTCHECK( 22, "prcv_mbf", result, E_TMOUT );	mbf_check( 1, "mbf_test1" );
	result = trcv_mbf( 1, data, 200 ),			TESTCHECK( 23, "trcv_mbf", result, E_TMOUT );	mbf_check( 1, "mbf_test1" );
	len    = rcv_mbf(  1, data ),				TESTCHECK( 24, "rcv_mbf" , len   , 3 );			mbf_check( 1, "mbf_test1" );
	#endif
	if( len > 0 ){
		DEBUG_PRINT( "len = %d data = %d %d %d\n", len, data[0], data[1], data[2] );
	}
	dly_tsk( T1s );
	#ifdef __ITRON3__
	result = rcv_mbf(  data, &len, 1 ),			TESTCHECK( 25, "rcv_mbf" , result, E_OK );		mbf_check( 1, "mbf_test1" );
	#else
	len    = rcv_mbf(  1, data ),				TESTCHECK( 25, "rcv_mbf" , len   , 3 );			mbf_check( 1, "mbf_test1" );
	#endif
	if( len > 0 ){
		DEBUG_PRINT( "len = %d data = %d %d %d\n", len, data[0], data[1], data[2] );
	}
}
static TASK	mbf_test( VP_INT stacd )
{
	ER result;
	INT len;
	unsigned char sdata[3];
	unsigned char rdata[10];

	#ifdef __ITRON3__
	static const T_CTSK	tsk1 = { NULL, TA_HLNG, mbf_test1, 20, 0 };
	static const T_CMBF	mbf0 = { NULL, TA_TFIFO,  0, 0 };
	static const T_CMBF	mbf1 = { NULL, TA_TFIFO, 10, 0 };
	static const T_CMBF	mbf2 = { NULL, TA_TFIFO, 10, 3 };
	static const T_CMBF	mbf3 = { NULL, TA_TFIFO,  0, 3 };
	#else
	static const T_CTSK	tsk1 = { TA_HLNG, NULL, mbf_test1, 20, 0, NULL };
	static const T_CMBF	mbf0 = { TA_TFIFO, 0, 0  };
	static const T_CMBF	mbf1 = { TA_TFIFO, 0, 10 };
	static const T_CMBF	mbf2 = { TA_TFIFO, 3, 10 };
	static const T_CMBF	mbf3 = { TA_TFIFO, 3, 0  };
	#endif

	DEBUG_PRINT( "================ message buffer test =================\n" );

	result = cre_mbf( 0, &mbf3 ),	TESTCHECK( 1, "cre_mbf" , result, E_ID  );
	result = cre_mbf( 1, NULL  ),	TESTCHECK( 2, "cre_mbf" , result, E_PAR );
	result = cre_mbf( 1, &mbf0 ),	TESTCHECK( 3, "cre_mbf" , result, E_PAR );
	result = cre_mbf( 1, &mbf1 ),	TESTCHECK( 4, "cre_mbf" , result, E_PAR );
	result = cre_mbf( 1, &mbf2 ),	TESTCHECK( 5, "cre_mbf" , result, E_OK  );
	result = cre_mbf( 1, &mbf2 ),	TESTCHECK( 6, "cre_mbf" , result, E_OBJ );
	result = cre_mbf( 2, &mbf3 ),	TESTCHECK( 7, "cre_mbf" , result, E_OK  );
	result = cre_mbf( 4, &mbf2 ),	TESTCHECK( 8, "cre_mbf" , result, E_OK  );
	#ifdef __ITRON4__
	result = acre_mbf( &mbf2 ),		TESTCHECK(  9, "acre_mbf" , result, 3 );
	result = acre_mbf( NULL  ),		TESTCHECK( 10, "acre_mbf" , result, E_PAR );
	#endif

	result = del_mbf( 0 ),	TESTCHECK( 11, "del_mbf" , result, E_ID );
	result = del_mbf( 4 ),	TESTCHECK( 12, "del_mbf" , result, E_OK );
	result = del_mbf( 4 ),	TESTCHECK( 13, "del_mbf" , result, E_NOEXS );
	result = del_mbf( 5 ),	TESTCHECK( 14, "del_mbf" , result, E_NOEXS );
	#ifdef __ITRON4__
	result = del_mbf( 3 ),	TESTCHECK( 15, "del_mbf" , result, E_OK );
	#endif

	mbf_check( 1, "mbf_test" );
	sdata[0] = 10;
	result = snd_mbf( 1, sdata, 1 ),	TESTCHECK( 16, "snd_mbf", result, E_OK );	mbf_check( 1, "mbf_test" );

	#ifdef __ITRON3__
	result = rcv_mbf( rdata, &len, 1 ),	TESTCHECK( 17, "rcv_mbf" , result, E_OK );	mbf_check( 1, "mbf_test" );
	#else
	len    = rcv_mbf( 1, rdata ),		TESTCHECK( 17, "rcv_mbf" , len   , 1 );		mbf_check( 1, "mbf_test" );
	#endif
	if( len > 0 ){
		DEBUG_PRINT( "len = %d rdata = %d %d %d\n", len, rdata[0], rdata[1], rdata[2] );
	}
	result = cre_tsk( 81, &tsk1 );
	result = sta_tsk( 81, 0 );
	dly_tsk( T1s );
	mbf_check( 1, "mbf_test" );

	sdata[0] = 110;
	sdata[1] = 111;
	sdata[2] = 112;
	result = snd_mbf( 1, sdata, 3 ),		TESTCHECK( 18, "snd_mbf", result, E_OK );	mbf_check( 1, "mbf_test" );

	sdata[0] = 100;
	sdata[1] = 101;
	sdata[2] = 102;
	result = snd_mbf( 1, sdata, 3 ),		TESTCHECK( 19, "snd_mbf", result, E_OK );	mbf_check( 1, "mbf_test" );

	sdata[0] = 90;
	sdata[1] = 91;
	sdata[2] = 92;
	result = psnd_mbf( 1, sdata, 3 ),		TESTCHECK( 20, "psnd_mbf", result, E_TMOUT );	mbf_check( 1, "mbf_test" );

	sdata[0] = 80;
	sdata[1] = 81;
	sdata[2] = 82;
	result = tsnd_mbf( 1, sdata, 3, 2000 ),	TESTCHECK( 21, "tsnd_mbf", result, E_OK );	mbf_check( 1, "mbf_test" );


	DEBUG_PRINT( "\n\n" );
}

/****************************************************************************/
// fu|[g̃eXg.
/****************************************************************************/
static void	por_check( ID id, char *str )
{
	ER result;
	T_RPOR rpor;

	#ifdef __ITRON3__
	result = ref_por( &rpor, id ),	DEBUG_PRINT( "%s : ref_por = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "exinf = %d  ", rpor.exinf );
		DEBUG_PRINT( "wtsk = %d  " , rpor.wtsk  );
		DEBUG_PRINT( "atsk = %d  " , rpor.atsk  );
	}
	DEBUG_PRINT( "\n" );
	#else
	result = ref_por( id, &rpor ),	DEBUG_PRINT( "%s : ref_por = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "ctskid = %d  ", rpor.ctskid );
		DEBUG_PRINT( "atskid = %d  ", rpor.atskid );
	}
	DEBUG_PRINT( "\n" );
	#endif
}
static TASK	por_test1( VP_INT stacd )
{
	ER result;
	INT len;
	#ifdef __ITRON3__
	RNO rdvno;
	#else
	RDVNO rdvno;
	#endif
	unsigned char msg[3];

	#ifdef __ITRON3__
	result = acp_por( &rdvno, msg, &len, 1, 0x01 ),	TESTCHECK( 19, "acp_por" , result, E_OK );		por_check( 1, "por_test1" );
	#else
	len    = acp_por( 1, 0x01, &rdvno, msg ),		TESTCHECK( 19, "acp_por" , len   , 3 );			por_check( 1, "por_test1" );

	{	T_RRDV rrdv;
		result = ref_rdv( rdvno, &rrdv ),			TESTCHECK( 20, "ref_rdv" , result, E_OK );		por_check( 1, "por_test1" );
		if( result == E_OK ){
			DEBUG_PRINT( "wtskid = %d\n", rrdv.wtskid );
		}
	}
	#endif
	if( len > 0 ){
		DEBUG_PRINT( "rdvno = %d len = %d msg = %d %d %d\n", rdvno, len, msg[0], msg[1], msg[2] );
	}
	#ifdef __ITRON3__
	result = pacp_por( &rdvno, msg, &len, 1, 0x01 ),		TESTCHECK( 21, "pacp_por", result, E_TMOUT );	por_check( 1, "por_test1" );
	result = tacp_por( &rdvno, msg, &len, 1, 0x01, 200 ),	TESTCHECK( 22, "tacp_por", result, E_TMOUT );	por_check( 1, "por_test1" );
	#else
	result = pacp_por( 1, 0x01, &rdvno, msg ),				TESTCHECK( 21, "pacp_por", result , E_TMOUT );	por_check( 1, "por_test1" );
	result = tacp_por( 1, 0x01, &rdvno, msg, 200 ),			TESTCHECK( 22, "tacp_por", result , E_TMOUT );	por_check( 1, "por_test1" );
	#endif

	msg[0] = 11;
	msg[1] = 12;
	msg[2] = 0;
	result = rpl_rdv( rdvno, msg, 2 ),	TESTCHECK( 23, "rpl_rdv" , result, E_OK );		por_check( 1, "por_test1" );

	#ifdef __ITRON3__
	result = acp_por( &rdvno, msg, &len, 1, 0x01 ),	TESTCHECK( 24, "acp_por" , result, E_OK );		por_check( 1, "por_test1" );
	#else
	len    = acp_por( 1, 0x01, &rdvno, msg ),		TESTCHECK( 24, "acp_por" , len   , 3 );			por_check( 1, "por_test1" );
	#endif
	if( len > 0 ){
		DEBUG_PRINT( "rdvno = %d len = %d msg = %d %d %d\n", rdvno, len, msg[0], msg[1], msg[2] );
	}
	msg[0] = 21;
	msg[1] = 22;
	msg[2] = 0;
	result = fwd_por( 1, 0x02, rdvno, msg, 2 ),		TESTCHECK( 25, "acp_por" , result, E_OK );		por_check( 1, "por_test1" );
}

static TASK	por_test2( VP_INT stacd )
{
	ER result;
	INT len;
	#ifdef __ITRON3__
	RNO rdvno;
	#else
	RDVNO rdvno;
	#endif
	unsigned char msg[3];

	#ifdef __ITRON3__
	result = acp_por( &rdvno, msg, &len, 1, 0x02 ),	TESTCHECK( 26, "acp_por" , result, E_OK );		por_check( 1, "por_test2" );
	#else
	len    = acp_por( 1, 0x02, &rdvno, msg ),		TESTCHECK( 26, "acp_por" , len   , 2 );			por_check( 1, "por_test2" );
	#endif
	if( len > 0 ){
		DEBUG_PRINT( "rdvno = %d len = %d msg = %d %d %d\n", rdvno, len, msg[0], msg[1], msg[2] );
	}
	msg[0] = 31;
	msg[1] = 32;
	msg[2] = 33;
	result = rpl_rdv( rdvno, msg, 3 ),	TESTCHECK( 27, "rpl_rdv" , result, E_OK );		por_check( 1, "por_test2" );
}
static TASK	por_test( VP_INT stacd )
{
	ER result;
	INT len;
	unsigned char msg[3];

	#ifdef __ITRON3__
	static const T_CTSK	tsk1 = { NULL, TA_HLNG, por_test1, 20, 0 };
	static const T_CTSK	tsk2 = { NULL, TA_HLNG, por_test2, 20, 0 };
	static const T_CPOR	por0 = { NULL, TA_TFIFO, 0, 0 };
	static const T_CPOR	por1 = { NULL, TA_TFIFO, 3, 0 };
	static const T_CPOR	por2 = { NULL, TA_TFIFO, 0, 3 };
	static const T_CPOR	por3 = { NULL, TA_TFIFO, 3, 3 };
	#else
	static const T_CTSK	tsk1 = { TA_HLNG, NULL, por_test1, 20, 0, NULL };
	static const T_CTSK	tsk2 = { TA_HLNG, NULL, por_test2, 20, 0, NULL };
	static const T_CPOR	por0 = { TA_TFIFO, 0, 0 };
	static const T_CPOR	por1 = { TA_TFIFO, 3, 0 };
	static const T_CPOR	por2 = { TA_TFIFO, 0, 3 };
	static const T_CPOR	por3 = { TA_TFIFO, 3, 3 };
	#endif

	DEBUG_PRINT( "================ rendezvous port test =================\n" );

	result = cre_por( 0, &por3 ),	TESTCHECK( 1, "cre_por" , result, E_ID  );
	result = cre_por( 1, NULL  ),	TESTCHECK( 2, "cre_por" , result, E_PAR );
	result = cre_por( 1, &por0 ),	TESTCHECK( 3, "cre_por" , result, E_PAR );
	result = cre_por( 1, &por1 ),	TESTCHECK( 4, "cre_por" , result, E_PAR );
	result = cre_por( 1, &por2 ),	TESTCHECK( 5, "cre_por" , result, E_PAR );
	result = cre_por( 1, &por3 ),	TESTCHECK( 6, "cre_por" , result, E_OK  );
	result = cre_por( 1, &por3 ),	TESTCHECK( 7, "cre_por" , result, E_OBJ );
	result = cre_por( 2, &por3 ),	TESTCHECK( 8, "cre_por" , result, E_OK  );
	result = cre_por( 4, &por3 ),	TESTCHECK( 9, "cre_por" , result, E_OK  );
	#ifdef __ITRON4__
	result = acre_por( &por3 ),		TESTCHECK( 10, "acre_por" , result, 3 );
	result = acre_por( NULL  ),		TESTCHECK( 11, "acre_por" , result, E_PAR );
	#endif

	result = del_por( 0 ),	TESTCHECK( 12, "del_por" , result, E_ID );
	result = del_por( 4 ),	TESTCHECK( 13, "del_por" , result, E_OK );
	result = del_por( 4 ),	TESTCHECK( 14, "del_por" , result, E_NOEXS );
	result = del_por( 5 ),	TESTCHECK( 15, "del_por" , result, E_NOEXS );
	#ifdef __ITRON4__
	result = del_por( 3 ),	TESTCHECK( 16, "del_por" , result, E_OK );
	#endif

	result = cre_tsk( 91, &tsk1 );
	result = sta_tsk( 91, 0 );

	result = cre_tsk( 92, &tsk2 );
	result = sta_tsk( 92, 0 );

	msg[0] = 1;
	msg[1] = 2;
	msg[2] = 3;
	#ifdef __ITRON3__
	result = cal_por( msg, &len, 1, 0x01, 3 ),	TESTCHECK( 17, "cal_por" , result, E_OK );	por_check( 1, "por_test" );
	#else
	len    = cal_por( 1, 0x01, msg, 3 ),		TESTCHECK( 17, "cal_por" , len   , 2 );		por_check( 1, "por_test" );
	#endif
	if( len > 0 ){
		DEBUG_PRINT( "len = %d msg = %d %d %d\n", len, msg[0], msg[1], msg[2] );
	}
	dly_tsk( T1s );

	msg[0] = 11;
	msg[1] = 12;
	msg[2] = 13;
	#ifdef __ITRON3__
	result = tcal_por( msg, &len, 1, 0x04, 3, 200 ),	TESTCHECK( 18, "tcal_por", result, E_TMOUT );	por_check( 1, "por_test" );
	#else
	result = tcal_por( 1, 0x04, msg, 3, 200 ),			TESTCHECK( 18, "tcal_por", result, E_TMOUT );	por_check( 1, "por_test" );
	#endif

	msg[0] = 41;
	msg[1] = 42;
	msg[2] = 43;
	#ifdef __ITRON3__
	result = cal_por( msg, &len, 1, 0x01, 3 ),	TESTCHECK( 28, "cal_por" , result, E_OK );	por_check( 1, "por_test" );
	#else
	len    = cal_por( 1, 0x01, msg, 3 ),		TESTCHECK( 28, "cal_por" , len   , 3 );		por_check( 1, "por_test" );
	#endif
	if( len > 0 ){
		DEBUG_PRINT( "len = %d msg = %d %d %d\n", len, msg[0], msg[1], msg[2] );
	}
	DEBUG_PRINT( "\n\n" );
}

/****************************************************************************/
// Œ蒷v[̃eXg.
/****************************************************************************/
static void	mpf_check( ID id, char *str )
{
	ER result;
	T_RMPF rmpf;

	#ifdef __ITRON3__
	result = ref_mpf( &rmpf, id ),	DEBUG_PRINT( "%s : ref_mpf = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "exinf = %d  " , rmpf.exinf  );
		DEBUG_PRINT( "wtsk  = %d  " , rmpf.wtsk   );
		DEBUG_PRINT( "frbcnt = %d  ", rmpf.frbcnt );
	}
	DEBUG_PRINT( "\n" );
	#else
	result = ref_mpf( id, &rmpf ),	DEBUG_PRINT( "%s : ref_mpf = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "wtskid = %d  " , rmpf.wtskid  );
		DEBUG_PRINT( "fblkcnt = %d  ", rmpf.fblkcnt );
	}
	DEBUG_PRINT( "\n" );
	#endif
}
static TASK	mpf_test1( VP_INT stacd )
{
	ER result;
	unsigned char *ptr1;

	#ifdef __ITRON3__
	result = pget_blf( (VP)&ptr1, 1 ),		TESTCHECK( 31, "pget_blf", result, E_TMOUT );	mpf_check( 1, "mpf_test1" );
	result = tget_blf( (VP)&ptr1, 1, 200 ),	TESTCHECK( 32, "tget_blf", result, E_TMOUT );	mpf_check( 1, "mpf_test1" );
	result = get_blf(  (VP)&ptr1, 1 ),		TESTCHECK( 33, "get_blf" , result, E_OK );		mpf_check( 1, "mpf_test1" );
	#else
	result = pget_blf( 1, (VP)&ptr1 ),		TESTCHECK( 31, "pget_blf", result, E_TMOUT );	mpf_check( 1, "mpf_test1" );
	result = tget_blf( 1, (VP)&ptr1, 200 ),	TESTCHECK( 32, "tget_blf", result, E_TMOUT );	mpf_check( 1, "mpf_test1" );
	result = get_blf(  1, (VP)&ptr1 ),		TESTCHECK( 33, "get_blf" , result, E_OK );		mpf_check( 1, "mpf_test1" );
	#endif
}

static TASK	mpf_test( VP_INT stacd )
{
	ER result;
	unsigned char *ptr1,*ptr2,*ptr3;

	#ifdef __ITRON3__
	static const T_CTSK	tsk1 = { NULL, TA_HLNG, mpf_test1, 30, 0 };
	static const T_CMPF	mpf0 = { NULL, TA_TFIFO, 0,  0 };
	static const T_CMPF	mpf1 = { NULL, TA_TFIFO, 3,  0 };
	static const T_CMPF	mpf2 = { NULL, TA_TFIFO, 3, 10 };

	DEBUG_PRINT( "================ fixed memory pool test =================\n" );

	result = cre_mpf( 0, &mpf2 ),	TESTCHECK(  1, "cre_mpf" , result, E_ID );
	result = cre_mpf( 1, NULL  ),	TESTCHECK(  2, "cre_mpf" , result, E_PAR );
	result = cre_mpf( 1, &mpf0 ),	TESTCHECK(  3, "cre_mpf" , result, E_PAR );
	result = cre_mpf( 1, &mpf1 ),	TESTCHECK(  4, "cre_mpf" , result, E_PAR );
	result = cre_mpf( 1, &mpf2 ),	TESTCHECK(  5, "cre_mpf" , result, E_OK );
	result = cre_mpf( 1, &mpf2 ),	TESTCHECK(  6, "cre_mpf" , result, E_OBJ );
	result = cre_mpf( 2, &mpf2 ),	TESTCHECK(  7, "cre_mpf" , result, E_OK );
	result = cre_mpf( 4, &mpf2 ),	TESTCHECK(  8, "cre_mpf" , result, E_OK );

	result = del_mpf( 0 ),			TESTCHECK( 11, "del_mpf" , result, E_ID );
	result = del_mpf( 4 ),			TESTCHECK( 12, "del_mpf" , result, E_OK );
	result = del_mpf( 4 ),			TESTCHECK( 13, "del_mpf" , result, E_NOEXS );
	result = del_mpf( 5 ),			TESTCHECK( 14, "del_mpf" , result, E_NOEXS );

	mpf_check( 1, "mpf_test" );
	result = get_blf( (VP)&ptr1, 1 ),	TESTCHECK( 16, "get_blf", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = get_blf( (VP)&ptr2, 1 ),	TESTCHECK( 17, "get_blf", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = rel_blf( 1, ptr1 ),		TESTCHECK( 18, "rel_blf", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = rel_blf( 1, ptr2 ),		TESTCHECK( 19, "rel_blf", result, E_OK );	mpf_check( 1, "mpf_test" );

	result = get_blf( (VP)&ptr1, 1 ),	TESTCHECK( 15, "get_blk", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = get_blf( (VP)&ptr2, 1 ),	TESTCHECK( 16, "get_blk", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = rel_blf( 1, ptr1 ),		TESTCHECK( 17, "rel_blk", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = rel_blf( 1, ptr2 ),		TESTCHECK( 18, "rel_blk", result, E_OK );	mpf_check( 1, "mpf_test" );

	result = get_blf( (VP)&ptr1, 1  ),	TESTCHECK( 19, "get_blk", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = get_blf( (VP)&ptr2, 1  ),	TESTCHECK( 20, "get_blk", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = rel_blf( 1, ptr2 ),		TESTCHECK( 21, "rel_blk", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = rel_blf( 1, ptr1 ),		TESTCHECK( 22, "rel_blk", result, E_OK );	mpf_check( 1, "mpf_test" );

	result = get_blf( (VP)&ptr1, 0 ),	TESTCHECK( 23, "get_blk", result, E_ID );
	result = get_blf( (VP)&ptr1, 3 ),	TESTCHECK( 24, "get_blk", result, E_NOEXS );
	result = get_blf( NULL     , 1 ),	TESTCHECK( 25, "get_blk", result, E_PAR );

	result = rel_blf( 0, (VP)&ptr1 ),	TESTCHECK( 26, "rel_blk", result, E_ID );
	result = rel_blf( 3, (VP)&ptr1 ),	TESTCHECK( 27, "rel_blk", result, E_NOEXS );
	result = rel_blf( 1, (VP)&ptr1 ),	TESTCHECK( 28, "rel_blk", result, E_OBJ );
	result = rel_blf( 1, NULL      ),	TESTCHECK( 29, "rel_blk", result, E_PAR );

	result = get_blf( (VP)&ptr1, 1 ),	TESTCHECK( 30, "tget_blf", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = get_blf( (VP)&ptr2, 1 ),	TESTCHECK( 31, "tget_blf", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = get_blf( (VP)&ptr3, 1 ),	mpf_check( 1, "mpf_test" );

	result = cre_tsk( 101, &tsk1 );
	result = sta_tsk( 101, 0 );
	dly_tsk( T1s );
	mpf_check( 1, "mpf_test" );
	result = rel_blk( 1, ptr1 );
	dly_tsk( T1s );
	del_tsk( 101 );
	mpf_check( 1, "mpf_test" );
	#else
	static const T_CTSK	tsk1 = { TA_HLNG, NULL, mpf_test1, 20, 0, NULL };
	static const T_CMPF	mpf0 = { TA_TFIFO, 0,  0, NULL };
	static const T_CMPF	mpf1 = { TA_TFIFO, 3,  0, NULL };
	static const T_CMPF	mpf2 = { TA_TFIFO, 3, 10, NULL };

	DEBUG_PRINT( "================ fixed memory pool test =================\n" );

	result = cre_mpf( 0, &mpf2 ),	TESTCHECK(  1, "cre_mpf" , result, E_ID );
	result = cre_mpf( 1, NULL  ),	TESTCHECK(  2, "cre_mpf" , result, E_PAR );
	result = cre_mpf( 1, &mpf0 ),	TESTCHECK(  3, "cre_mpf" , result, E_PAR );
	result = cre_mpf( 1, &mpf1 ),	TESTCHECK(  4, "cre_mpf" , result, E_PAR );
	result = cre_mpf( 1, &mpf2 ),	TESTCHECK(  5, "cre_mpf" , result, E_OK );
	result = cre_mpf( 1, &mpf2 ),	TESTCHECK(  6, "cre_mpf" , result, E_OBJ );
	result = cre_mpf( 2, &mpf2 ),	TESTCHECK(  7, "cre_mpf" , result, E_OK );
	result = cre_mpf( 4, &mpf2 ),	TESTCHECK(  8, "cre_mpf" , result, E_OK );
	result = acre_mpf( &mpf2 ),		TESTCHECK(  9, "acre_mpf" , result, 3 );
	result = acre_mpf( NULL ),		TESTCHECK( 10, "acre_mpf" , result, E_PAR );

	result = del_mpf( 0 ),			TESTCHECK( 11, "del_mpf" , result, E_ID );
	result = del_mpf( 4 ),			TESTCHECK( 12, "del_mpf" , result, E_OK );
	result = del_mpf( 4 ),			TESTCHECK( 13, "del_mpf" , result, E_NOEXS );
	result = del_mpf( 5 ),			TESTCHECK( 14, "del_mpf" , result, E_NOEXS );
	result = del_mpf( 3 ),			TESTCHECK( 15, "del_mpf" , result, E_OK );

	mpf_check( 1, "mpf_test" );
	result = get_blf( 1, (VP)&ptr1 ),	TESTCHECK( 16, "get_blf", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = get_blf( 1, (VP)&ptr2 ),	TESTCHECK( 17, "get_blf", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = rel_blf( 1, ptr1 ),		TESTCHECK( 18, "rel_blf", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = rel_blf( 1, ptr2 ),		TESTCHECK( 19, "rel_blf", result, E_OK );	mpf_check( 1, "mpf_test" );

	result = get_blf( 1, (VP)&ptr1 ),	TESTCHECK( 20, "get_blf", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = get_blf( 1, (VP)&ptr2 ),	TESTCHECK( 21, "get_blf", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = rel_blf( 1, ptr2 ),		TESTCHECK( 22, "rel_blf", result, E_OK );	mpf_check( 1, "mpf_test" );
	result = rel_blf( 1, ptr1 ),		TESTCHECK( 23, "rel_blf", result, E_OK );	mpf_check( 1, "mpf_test" );

	result = get_blf( 0, (VP)&ptr1 ),	TESTCHECK( 24, "get_blf", result, E_ID );
	result = get_blf( 3, (VP)&ptr1 ),	TESTCHECK( 25, "get_blf", result, E_NOEXS );
	result = get_blf( 1, NULL ),		TESTCHECK( 26, "get_blf", result, E_PAR );

	result = rel_blf( 0, (VP)&ptr1 ),	TESTCHECK( 27, "rel_blf", result, E_ID );
	result = rel_blf( 3, (VP)&ptr1 ),	TESTCHECK( 28, "rel_blf", result, E_NOEXS );
	result = rel_blf( 1, (VP)&ptr1 ),	TESTCHECK( 29, "rel_blf", result, E_OBJ );
	result = rel_blf( 1, NULL ),		TESTCHECK( 30, "rel_blf", result, E_PAR );

	result = get_blf( 1, (VP)&ptr1 ),	mpf_check( 1, "mpf_test" );
	result = get_blf( 1, (VP)&ptr2 ),	mpf_check( 1, "mpf_test" );
	result = get_blf( 1, (VP)&ptr3 ),	mpf_check( 1, "mpf_test" );

	result = cre_tsk( 91, &tsk1 );
	result = sta_tsk( 91, 0 );
	dly_tsk( T1s );
	mpf_check( 1, "mpf_test" );
	result = rel_blf( 1, ptr1 );
	dly_tsk( T1s );
	del_tsk( 91 );
	mpf_check( 1, "mpf_test" );
	#endif

	DEBUG_PRINT( "\n\n" );
}

/****************************************************************************/
// ϒv[̃eXg.
/****************************************************************************/
static void	mpl_check( ID id, char *str )
{
	ER result;
	T_RMPL rmpl;

	#ifdef __ITRON3__
	result = ref_mpl( &rmpl, id ),	DEBUG_PRINT( "%s : ref_mpl = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "exinf = %d  ", rmpl.exinf );
		DEBUG_PRINT( "wtsk  = %d  ", rmpl.wtsk  );
		DEBUG_PRINT( "frsz  = %d  ", rmpl.frsz  );
		DEBUG_PRINT( "maxsz = %d  ", rmpl.maxsz );
	}
	DEBUG_PRINT( "\n" );
	#else
	result = ref_mpl( id, &rmpl ),	DEBUG_PRINT( "%s : ref_mpl = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "wtskid = %d  ", rmpl.wtskid );
		DEBUG_PRINT( "fmplsz = %d  ", rmpl.fmplsz );
		DEBUG_PRINT( "fblksz = %d  ", rmpl.fblksz );
	}
	DEBUG_PRINT( "\n" );
	#endif
}
static TASK	mpl_test1( VP_INT stacd )
{
	ER result;
	unsigned char *ptr1;

	#ifdef __ITRON3__
	result = pget_blk( (VP)&ptr1, 1, 30 ),		TESTCHECK( 33, "pget_blk", result, E_TMOUT );	mpl_check( 1, "mpl_test1" );
	result = tget_blk( (VP)&ptr1, 1, 30, 200 ),	TESTCHECK( 34, "tget_blk", result, E_TMOUT );	mpl_check( 1, "mpl_test1" );
	result = get_blk(  (VP)&ptr1, 1, 30 ),		TESTCHECK( 35, "get_blk", result, E_OK );		mpl_check( 1, "mpl_test1" );
	#else
	result = pget_mpl( 1, 30, (VP)&ptr1 ),		TESTCHECK( 33, "pget_mpl", result, E_TMOUT );	mpl_check( 1, "mpl_test1" );
	result = tget_mpl( 1, 30, (VP)&ptr1, 200 ),	TESTCHECK( 34, "pget_mpl", result, E_TMOUT );	mpl_check( 1, "mpl_test1" );
	result = get_mpl(  1, 30, (VP)&ptr1 ),		TESTCHECK( 35, "get_mpl", result, E_OK );		mpl_check( 1, "mpl_test1" );
	#endif
}

static TASK	mpl_test( VP_INT stacd )
{
	ER result;
	unsigned char *ptr1,*ptr2;

	#ifdef __ITRON3__
	static const T_CTSK	tsk1 = { NULL, TA_HLNG, mpl_test1, 30, 0 };
	static const T_CMPL	mpl0 = { NULL, TA_TFIFO,   0 };
	static const T_CMPL	mpl1 = { NULL, TA_TFIFO, 100 };
	static const T_CMPL	mpl2 = { NULL, TA_TFIFO, 200 };

	DEBUG_PRINT( "================ valiable memory pool test =================\n" );

	result = cre_mpl( 0, &mpl1 ),	TESTCHECK( 1, "cre_mpl" , result, E_ID );
	result = cre_mpl( 1, NULL  ),	TESTCHECK( 2, "cre_mpl" , result, E_PAR );
	result = cre_mpl( 1, &mpl0 ),	TESTCHECK( 3, "cre_mpl" , result, E_PAR );
	result = cre_mpl( 1, &mpl1 ),	TESTCHECK( 4, "cre_mpl" , result, E_OK );
	result = cre_mpl( 1, &mpl2 ),	TESTCHECK( 5, "cre_mpl" , result, E_OBJ );
	result = cre_mpl( 2, &mpl2 ),	TESTCHECK( 6, "cre_mpl" , result, E_OK );
	result = cre_mpl( 4, &mpl2 ),	TESTCHECK( 7, "cre_mpl" , result, E_OK );

	result = del_mpl( 0 ),	TESTCHECK( 10, "del_mpl" , result, E_ID );
	result = del_mpl( 4 ),	TESTCHECK( 11, "del_mpl" , result, E_OK );
	result = del_mpl( 4 ),	TESTCHECK( 12, "del_mpl" , result, E_NOEXS );
	result = del_mpl( 5 ),	TESTCHECK( 13, "del_mpl" , result, E_NOEXS );

	mpl_check( 1, "mpl_test" );
	result = get_blk( (VP)&ptr1, 1, 30 ),	TESTCHECK( 15, "get_blk", result, E_OK );	mpl_check( 1, "mpl_test" );
	result = get_blk( (VP)&ptr2, 1, 30 ),	TESTCHECK( 16, "get_blk", result, E_OK );	mpl_check( 1, "mpl_test" );
	result = rel_blk( 1, ptr1 ),			TESTCHECK( 17, "rel_blk", result, E_OK );	mpl_check( 1, "mpl_test" );
	result = rel_blk( 1, ptr2 ),			TESTCHECK( 18, "rel_blk", result, E_OK );	mpl_check( 1, "mpl_test" );

	result = get_blk( (VP)&ptr1, 1, 30 ),	TESTCHECK( 19, "get_blk", result, E_OK );	mpl_check( 1, "mpl_test" );
	result = get_blk( (VP)&ptr2, 1, 30 ),	TESTCHECK( 20, "get_blk", result, E_OK );	mpl_check( 1, "mpl_test" );
	result = rel_blk( 1, ptr2 ),			TESTCHECK( 21, "rel_blk", result, E_OK );	mpl_check( 1, "mpl_test" );
	result = rel_blk( 1, ptr1 ),			TESTCHECK( 22, "rel_blk", result, E_OK );	mpl_check( 1, "mpl_test" );

	result = get_blk( (VP)&ptr1, 0, 30 ),	TESTCHECK( 23, "get_blk", result, E_ID );
	result = get_blk( (VP)&ptr1, 3, 30 ),	TESTCHECK( 24, "get_blk", result, E_NOEXS );
	result = get_blk( NULL     , 1, 30 ),		TESTCHECK( 25, "get_blk", result, E_PAR );

	result = rel_blk( 0, (VP)&ptr1 ),		TESTCHECK( 26, "rel_blk", result, E_ID );
	result = rel_blk( 3, (VP)&ptr1 ),		TESTCHECK( 27, "rel_blk", result, E_NOEXS );
	result = rel_blk( 1, (VP)&ptr1 ),		TESTCHECK( 28, "rel_blk", result, E_PAR );
	result = rel_blk( 1, NULL ),			TESTCHECK( 29, "rel_blk", result, E_PAR );

	result = tget_blk( (VP)&ptr1, 1, 40, 100 ),	TESTCHECK( 30, "tget_blk", result, E_OK );	mpl_check( 1, "mpl_test" );
	result = tget_blk( (VP)&ptr2, 1, 40, 100 ),	TESTCHECK( 31, "tget_blk", result, E_OK );	mpl_check( 1, "mpl_test" );

	result = cre_tsk( 101, &tsk1 );
	result = sta_tsk( 101, 0 );
	dly_tsk( T1s );
	mpl_check( 1, "mpl_test" );
	result = rel_blk( 1, ptr1 );
	dly_tsk( T1s );
	del_tsk( 101 );
	mpl_check( 1, "mpl_test" );
	#else
	static const T_CTSK	tsk1 = { TA_HLNG, NULL, mpl_test1, 20, 0, NULL };
	static const T_CMPL	mpl0 = { TA_TFIFO,   0, NULL };
	static const T_CMPL	mpl1 = { TA_TFIFO, 100, NULL };
	static const T_CMPL	mpl2 = { TA_TFIFO, 200, NULL };

	DEBUG_PRINT( "================ valiable memory pool test =================\n" );

	result = cre_mpl( 0, &mpl1 ),	TESTCHECK( 1, "cre_mpl" , result, E_ID );
	result = cre_mpl( 1, NULL  ),	TESTCHECK( 2, "cre_mpl" , result, E_PAR );
	result = cre_mpl( 1, &mpl0 ),	TESTCHECK( 3, "cre_mpl" , result, E_PAR );
	result = cre_mpl( 1, &mpl1 ),	TESTCHECK( 4, "cre_mpl" , result, E_OK );
	result = cre_mpl( 1, &mpl2 ),	TESTCHECK( 5, "cre_mpl" , result, E_OBJ );
	result = cre_mpl( 2, &mpl2 ),	TESTCHECK( 6, "cre_mpl" , result, E_OK );
	result = cre_mpl( 4, &mpl2 ),	TESTCHECK( 7, "cre_mpl" , result, E_OK );
	result = acre_mpl( &mpl2 ),		TESTCHECK( 8, "acre_mpl" , result, 3 );
	result = acre_mpl( NULL ),		TESTCHECK( 9, "acre_mpl" , result, E_PAR );

	result = del_mpl( 0 ),	TESTCHECK( 10, "del_mpl" , result, E_ID );
	result = del_mpl( 4 ),	TESTCHECK( 11, "del_mpl" , result, E_OK );
	result = del_mpl( 4 ),	TESTCHECK( 12, "del_mpl" , result, E_NOEXS );
	result = del_mpl( 5 ),	TESTCHECK( 13, "del_mpl" , result, E_NOEXS );
	result = del_mpl( 3 ),	TESTCHECK( 14, "del_mpl" , result, E_OK );

	mpl_check( 1, "mpl_test" );
	result = get_mpl( 1, 30, (VP)&ptr1 ),	TESTCHECK( 15, "get_mpl", result, E_OK );	mpl_check( 1, "mpl_test" );
	result = get_mpl( 1, 30, (VP)&ptr2 ),	TESTCHECK( 16, "get_mpl", result, E_OK );	mpl_check( 1, "mpl_test" );
	result = rel_blk( 1, ptr1 ),			TESTCHECK( 17, "rel_blk", result, E_OK );	mpl_check( 1, "mpl_test" );
	result = rel_blk( 1, ptr2 ),			TESTCHECK( 18, "rel_blk", result, E_OK );	mpl_check( 1, "mpl_test" );

	result = get_mpl( 1, 30, (VP)&ptr1 ),	TESTCHECK( 19, "get_mpl", result, E_OK );	mpl_check( 1, "mpl_test" );
	result = get_mpl( 1, 30, (VP)&ptr2 ),	TESTCHECK( 20, "get_mpl", result, E_OK );	mpl_check( 1, "mpl_test" );
	result = rel_blk( 1, ptr2 ),			TESTCHECK( 21, "rel_blk", result, E_OK );	mpl_check( 1, "mpl_test" );
	result = rel_blk( 1, ptr1 ),			TESTCHECK( 22, "rel_blk", result, E_OK );	mpl_check( 1, "mpl_test" );

	result = get_mpl( 0, 30, (VP)&ptr1 ),	TESTCHECK( 23, "get_mpl", result, E_ID );
	result = get_mpl( 3, 30, (VP)&ptr1 ),	TESTCHECK( 24, "get_mpl", result, E_NOEXS );
	result = get_mpl( 1, 30, NULL ),		TESTCHECK( 25, "get_mpl", result, E_PAR );

	result = rel_blk( 0, (VP)&ptr1 ),		TESTCHECK( 26, "rel_blk", result, E_ID );
	result = rel_blk( 3, (VP)&ptr1 ),		TESTCHECK( 27, "rel_blk", result, E_NOEXS );
	result = rel_blk( 1, (VP)&ptr1 ),		TESTCHECK( 28, "rel_blk", result, E_PAR );
	result = rel_blk( 1, NULL ),			TESTCHECK( 29, "rel_blk", result, E_PAR );

	result = tget_mpl( 1, 40, (VP)&ptr1, 100 ),	TESTCHECK( 30, "tget_mpl", result, E_OK );	mpl_check( 1, "mpl_test" );
	result = tget_mpl( 1, 40, (VP)&ptr2, 100 ),	TESTCHECK( 31, "tget_mpl", result, E_OK );	mpl_check( 1, "mpl_test" );

	result = cre_tsk( 101, &tsk1 );
	result = sta_tsk( 101, 0 );
	dly_tsk( T1s );
	mpl_check( 1, "mpl_test" );
	result = rel_blk( 1, ptr1 );
	dly_tsk( T1s );
	del_tsk( 101 );
	mpl_check( 1, "mpl_test" );
	#endif

	DEBUG_PRINT( "\n\n" );
}

/****************************************************************************/
// Nnh̃eXg.
/****************************************************************************/
static void	cyc_check( int no, char *str )
{
	ER result;
	T_RCYC rcyc;

	#ifdef __ITRON3__
	result = ref_cyc( &rcyc, no ),	DEBUG_PRINT( "%s : ref_cyc = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "exinf  = %d  "   , rcyc.exinf );
		DEBUG_PRINT( "lfttim = %d:%d  ", rcyc.lfttim.utime, rcyc.lfttim.ltime );
		DEBUG_PRINT( "cycact = %d  "   , rcyc.cycact );
	}
	DEBUG_PRINT( "\n" );
	#else
	result = ref_cyc( no, &rcyc ),	DEBUG_PRINT( "%s : ref_cyc = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "cycstat = %d  "   , rcyc.cycstat );
		DEBUG_PRINT( "lefttim = %d:%d  ", rcyc.lefttim.utime, rcyc.lefttim.ltime );
	}
	DEBUG_PRINT( "\n" );
	#endif
}
static void		get_system_time( void )
{
	ER result;
	SYSTIME	systime;
	systime.utime = 0;
	systime.ltime = 0;

	result = get_tim( &systime ),	DEBUG_PRINT( "get_tim = %d now time = %d %d\n", result, systime.utime, systime.ltime );
}

static TMRHDR	cyc_test1( void )
{
	DEBUG_PRINT( "=========== call cyc_test1\n" );
	get_system_time();
}

static TMRHDR	cyc_test2( void )
{
	DEBUG_PRINT( "=========== call cyc_test2\n" );
	get_system_time();
}

static TASK	cyc_test( VP_INT stacd )
{
	ER result;
	int i;

	#ifdef __ITRON3__
	static const T_DCYC	cyc1 = { NULL, TA_HLNG, cyc_test1, 1, {0, 300} };
	static const T_DCYC	cyc2 = { NULL, TA_HLNG, cyc_test2, 0, {0, 200} };
	#else
	static const T_CCYC	cyc1 = { TA_HLNG, NULL, cyc_test1, {0, 300}, {0, 0} };
	static const T_CCYC	cyc2 = { TA_HLNG, NULL, cyc_test2, {0, 200}, {0, 0} };
	#endif

	DEBUG_PRINT( "================ cycle timer test =================\n" );
	#ifdef __ITRON3__
	result = def_cyc( 0, &cyc1 ),	TESTCHECK( 1, "def_cyc", result, E_ID );
	result = def_cyc( 1, NULL  ),	TESTCHECK( 2, "def_cyc", result, E_PAR );
	result = def_cyc( 1, &cyc1 ),	TESTCHECK( 3, "def_cyc", result, E_OK );
	result = def_cyc( 1, &cyc1 ),	TESTCHECK( 4, "def_cyc", result, E_OK );
	result = def_cyc( 3, &cyc2 ),	TESTCHECK( 5, "def_cyc", result, E_OK );

	dly_tsk( T1s );
	result = act_cyc( 3, TCY_ON ),	TESTCHECK( 6, "act_cyc", result, E_OK );
	result = act_cyc( 1, TCY_OFF ),	TESTCHECK( 7, "act_cyc", result, E_OK );
	dly_tsk( T1s );
	cyc_check( 1, "cyc_test [1]" );
	cyc_check( 3, "cyc_test [3]" );

	result = act_cyc( 1, TCY_ON ),	TESTCHECK( 6, "act_cyc", result, E_OK );

	for( i = 0; i < 3; i++ ){
		dly_tsk( T1s );
		cyc_check( 1, "cyc_test [1]" );
		cyc_check( 3, "cyc_test [3]" );
	}
	result = act_cyc( 1, TCY_OFF );
	result = act_cyc( 3, TCY_OFF );

	#else
	result = cre_cyc( 0, &cyc1 ),	TESTCHECK( 1, "cre_cyc" , result, E_ID );
	result = cre_cyc( 1, NULL  ),	TESTCHECK( 2, "cre_cyc" , result, E_PAR );
	result = cre_cyc( 1, &cyc1 ),	TESTCHECK( 3, "cre_cyc" , result, E_OK );
	result = cre_cyc( 1, &cyc1 ),	TESTCHECK( 4, "cre_cyc" , result, E_OBJ );
	result = cre_cyc( 3, &cyc2 ),	TESTCHECK( 5, "cre_cyc" , result, E_OK );
	result = acre_cyc( &cyc2 ),		TESTCHECK( 6, "acre_cyc", result, 2    );
	result = acre_cyc( NULL ),		TESTCHECK( 7, "acre_cyc", result, E_PAR );

	result = del_cyc( 2 ),			TESTCHECK(  8, "del_cyc" , result, E_OK    );
	result = del_cyc( 0 ),			TESTCHECK(  9, "del_cyc" , result, E_ID    );
	result = del_cyc( 2 ),			TESTCHECK( 10, "del_cyc" , result, E_NOEXS );

	result = sta_cyc( 0 ),			TESTCHECK( 11, "sta_cyc" , result, E_ID );
	result = sta_cyc( 1 ),			TESTCHECK( 12, "sta_cyc" , result, E_OK );
	result = sta_cyc( 3 ),			TESTCHECK( 13, "sta_cyc" , result, E_OK );
	dly_tsk( T1s );
	cyc_check( 1, "cyc_test [1]" );
	cyc_check( 3, "cyc_test [3]" );

	result = stp_cyc( 0 ),			TESTCHECK( 14, "stp_cyc" , result, E_ID );
	result = stp_cyc( 2 ),			TESTCHECK( 15, "stp_cyc" , result, E_NOEXS );
	result = stp_cyc( 3 ),			TESTCHECK( 16, "stp_cyc" , result, E_OK );
	dly_tsk( T1s );
	cyc_check( 1, "cyc_test [1]" );
	cyc_check( 3, "cyc_test [3]" );

	result = sta_cyc( 3 ),			TESTCHECK( 17, "sta_cyc" , result, E_OK );

	for( i = 0; i < 3; i++ ){
		dly_tsk( T1s );
		cyc_check( 1, "cyc_test [1]" );
		cyc_check( 3, "cyc_test [3]" );
	}
	result = stp_cyc( 1 );
	result = stp_cyc( 3 );
	#endif
	DEBUG_PRINT( "\n\n" );
}

/****************************************************************************/
// A[nh̃eXg.
/****************************************************************************/
static void	alm_check( int no, char *str )
{
	ER result;
	T_RALM ralm;

	#ifdef __ITRON3__
	result = ref_alm( &ralm, no ),	DEBUG_PRINT( "%s : ref_alm = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "exinf  = %d  "   , ralm.exinf );
		DEBUG_PRINT( "lfttim = %d:%d  ", ralm.lfttim.utime, ralm.lfttim.ltime );
	}
	DEBUG_PRINT( "\n" );
	#else
	result = ref_alm( no, &ralm ),	DEBUG_PRINT( "%s : ref_alm = %d  ", str, result );
	if( result == E_OK ){
		DEBUG_PRINT( "almstat = %d  "   , ralm.almstat );
		DEBUG_PRINT( "lefttim = %d:%d  ", ralm.lefttim.utime, ralm.lefttim.ltime );
	}
	DEBUG_PRINT( "\n" );
	#endif
}
static INTHDR	alm_test1( void )
{
	DEBUG_PRINT( "=========== call alm_test1\n" );
	get_system_time();
	alm_check( 1, "alm_test1" );
}

static INTHDR	alm_test2( void )
{
	DEBUG_PRINT( "=========== call alm_test2\n" );
	get_system_time();
	alm_check( 3, "alm_test2" );
}

static TASK	alm_test( VP_INT stacd )
{
	SYSTIME	systime;
	ER result;
	int i;

	#ifdef __ITRON3__
	static const T_DALM	alm1 = { NULL, TA_HLNG, alm_test1, TTM_ABS, {0, 20000} };
	static const T_DALM	alm2 = { NULL, TA_HLNG, alm_test2, TTM_REL, {0, 20000} };
	#else
	static const T_CALM	alm1 = { TA_HLNG, NULL, alm_test1 };
	static const T_CALM	alm2 = { TA_HLNG, NULL, alm_test2 };
	RELTIM almtim;
	#endif

	DEBUG_PRINT( "================ alarm timer test =================\n" );

	systime.utime = 0;
	systime.ltime = 1000;
	result = set_tim( &systime ),	DEBUG_PRINT( "set_tim = %d\n", result );

	#ifdef __ITRON3__
	result = def_alm( 0, &alm1 ),	TESTCHECK( 1, "def_alm", result, E_ID );
	result = def_alm( 1, NULL  ),	TESTCHECK( 2, "def_alm", result, E_PAR );
	result = def_alm( 1, &alm1 ),	TESTCHECK( 3, "def_alm", result, E_OK );
	result = def_alm( 1, &alm1 ),	TESTCHECK( 4, "def_alm", result, E_OK );
	result = def_alm( 3, &alm2 ),	TESTCHECK( 5, "def_alm", result, E_OK );

	for( i = 0; i < 30; i++ ){
		dly_tsk( T1s );
		alm_check( 1, "alm_test [1]" );
		alm_check( 3, "alm_test [3]" );
	}

	#else
	result = cre_alm( 0, &alm1 ),	TESTCHECK( 1, "cre_alm" , result, E_ID );
	result = cre_alm( 1, NULL  ),	TESTCHECK( 2, "cre_alm" , result, E_PAR );
	result = cre_alm( 1, &alm1 ),	TESTCHECK( 3, "cre_alm" , result, E_OK );
	result = cre_alm( 1, &alm1 ),	TESTCHECK( 4, "cre_alm" , result, E_OBJ );
	result = cre_alm( 3, &alm2 ),	TESTCHECK( 5, "cre_alm" , result, E_OK );
	result = acre_alm( &alm2 ),		TESTCHECK( 6, "acre_alm", result, 2    );
	result = acre_alm( NULL ),		TESTCHECK( 7, "acre_alm", result, E_PAR );

	result = del_alm( 2 ),			TESTCHECK(  8, "del_alm" , result, E_OK    );
	result = del_alm( 0 ),			TESTCHECK(  9, "del_alm" , result, E_ID    );
	result = del_alm( 2 ),			TESTCHECK( 10, "del_alm" , result, E_NOEXS );

	almtim.utime = 0;
	almtim.ltime = 3000;
	result = sta_alm( 0, almtim ),	TESTCHECK( 11, "sta_alm" , result, E_ID );
	result = sta_alm( 1, almtim ),	TESTCHECK( 12, "sta_alm" , result, E_OK );

	almtim.utime = 0;
	almtim.ltime = 4000;
	result = sta_alm( 3, almtim ),	TESTCHECK( 13, "sta_alm" , result, E_OK );
	result = stp_alm( 0 ),			TESTCHECK( 14, "stp_alm" , result, E_ID );
	result = stp_alm( 2 ),			TESTCHECK( 15, "stp_alm" , result, E_NOEXS );
	result = stp_alm( 3 ),			TESTCHECK( 16, "stp_alm" , result, E_OK );

	for( i = 0; i < 5; i++ ){
		dly_tsk( T1s );
		alm_check( 1, "alm_test [1]" );
		alm_check( 3, "alm_test [3]" );
	}
	#endif

	DEBUG_PRINT( "\n\n" );
}

/****************************************************************************/
// 荞݃nh̃eXg.
/****************************************************************************/
static INTHDR	int_test1( void )
{
	DEBUG_PRINT( "=========== call int_test1\n" );
}

static INTHDR	int_test2( void )
{
	DEBUG_PRINT( "=========== call int_test2\n" );
}

static TASK	int_test( VP_INT stacd )
{
	ER result;
	int i;

	#ifdef __ITRON3__
	static const T_DINT	int1 = { TA_HLNG, int_test1 };
	static const T_DINT	int2 = { TA_HLNG, int_test2 };
	#else
	static const T_DINH	int1 = { TA_HLNG, int_test1 };
	static const T_DINH	int2 = { TA_HLNG, int_test2 };
	#endif

	DEBUG_PRINT( "================ interrupt test =================\n" );

	#ifdef __ITRON3__
	result = def_int( 0, &int1 ),	TESTCHECK( 1, "def_int" , result, E_ID );
	result = def_int( 1, &int1 ),	TESTCHECK( 2, "def_int" , result, E_OK );
	result = def_int( 3, &int2 ),	TESTCHECK( 3, "def_int" , result, E_OK );
	#else
	result = def_inh( 0, &int1 ),	TESTCHECK( 1, "def_inh" , result, E_ID );
	result = def_inh( 1, &int1 ),	TESTCHECK( 2, "def_inh" , result, E_OK );
	result = def_inh( 3, &int2 ),	TESTCHECK( 3, "def_inh" , result, E_OK );
	#endif

	for( i = 0; i < 4; i++ ){
		dly_tsk( T100ms );
		DEBUG_PRINT( "call intrrupt %d\n", i );
		request_interrupt( i );
	}
	result = ena_int( 0 ),	TESTCHECK( 4, "ena_int" , result, E_ID );
	result = ena_int( 3 ),	TESTCHECK( 5, "ena_int" , result, E_OK );
	for( i = 0; i < 4; i++ ){
		dly_tsk( T100ms );
		DEBUG_PRINT( "call intrrupt %d\n", i );
		request_interrupt( i );
	}
	for( i = 0; i < 4; i++ ){
		clear_interrupt_request( i );
	}
	result = ena_int( 1 );

	result = dis_int( 0 ),	TESTCHECK( 6, "dis_int" , result, E_ID );
	result = dis_int( 3 ),	TESTCHECK( 7, "dis_int" , result, E_OK );
	for( i = 0; i < 4; i++ ){
		dly_tsk( T100ms );
		DEBUG_PRINT( "call intrrupt %d\n", i );
		request_interrupt( i );
	}
	for( i = 0; i < 4; i++ ){
		clear_interrupt_request( i );
	}
	result = ena_int( 3 );

	result = loc_cpu(),		TESTCHECK( 8, "loc_cpu" , result, E_OK );
	for( i = 0; i < 4; i++ ){
		dly_tsk( T100ms );
		DEBUG_PRINT( "call intrrupt %d\n", i );
		request_interrupt( i );
	}
	result = unl_cpu(),		TESTCHECK( 9, "loc_cpu" , result, E_OK );
	for( i = 0; i < 4; i++ ){
		dly_tsk( T100ms );
		DEBUG_PRINT( "call intrrupt %d\n", i );
		request_interrupt( i );
	}
	DEBUG_PRINT( "\n\n" );
}

/* End of file */
