/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_alarm_handler.c
 *
 *	@brief	Windows iTRONT[rXR[ (A[nh).
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include "wi_alarm_handler.h"

/****************************************************************************
 *
 * [Jϐ`.
 *
 ****************************************************************************/
static WIHDR	*ObjList;		//!< A[nhXg̃|C^.

/****************************************************************************/
/*!
 *	@brief	A[nh̏.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_InitAlarmHadler( void )
{
	ObjList = NULL;
}

/****************************************************************************/
/*!
 *	@brief	A[nh̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_QuitAlarmHadler( void )
{
	WIHDR		*next_ptr;
	WIALMOBJ	*p = (WIALMOBJ *)ObjList;

	while( p ){
		next_ptr = p->Hdr.Next;

		//! A[nhIuWFNg\̂.
		SAFE_RELEASE( p );

		//! ̃A[nhIuWFNg\̂o.
		p = (WIALMOBJ *)next_ptr;
	}
}

/****************************************************************************/
/*!
 *	@brief	A[nh`.
 *
 *	@param	[in]	no		A[nhԍ.
 *	@param	[in]	obj		A[nh.IuWFNg\̂̃|C^.
 *	@param	[in]	ovr		TRUE = o^ςIDɏ㏑.
 *
 *	@retval	G[R[h.
 */
ER		wi_DefineAlarmHadler( INT no, const WIALMOBJ *obj, BOOL ovr )
{
	ER			ercd;
	WIALMOBJ	*p;

	p = (WIALMOBJ *)wi_GetObject( no, ObjList );
	if( p ){
		//! o^ς݃nhɏ㏑֎~̏ꍇ̓G[Iɂ.
		if( !ovr ){
			return E_OBJ;
		}
		//! ɓo^Ănhԍ̏ꍇ͓o^㏑.
		p->Attribute = obj->Attribute;
		p->AlmAdr    = obj->AlmAdr;
		p->TimeMode  = obj->TimeMode;
		p->AlmTime   = obj->AlmTime;
		p->ExtInfo   = obj->ExtInfo;
		p->Active    = obj->Active;
		return E_OK;
	}
	//! A[nhIuWFNg쐬.
	p = (WIALMOBJ *)wi_CreateObject( no, TMAX_MAXALM, sizeof(WIALMOBJ), obj, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgɃA[nhǉ.
	wi_AddObject( (WIHDR *)p, &ObjList );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	A[nh̍폜.
 *
 *	@param	[in]	no		A[nhԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_DeleteAlarmHadler( INT no )
{
	ER			ercd;
	WIALMOBJ	*p;

	//! A[nhԍ̃IuWFNg擾.
	p = (WIALMOBJ *)wi_FindObject( no, TMAX_MAXALM, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgYA[nh菜.
	wi_DelObject( (WIHDR *)p, &ObjList );

	//! A[nhIuWFNg\̂.
	SAFE_RELEASE( p );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	A[nh̋N.
 *
 *	@param	[in]	no		A[nhԍ.
 *	@param	[in]	almtim	N.
 *
 *	@retval	G[R[h.
 */
ER		wi_StartAlarmHadler( INT no, DWORDLONG almtim )
{
	ER			ercd;
	WIALMOBJ	*p;

	//! A[nhԍ̃IuWFNg擾.
	p = (WIALMOBJ *)wi_FindObject( no, TMAX_MAXALM, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! A[nh̋Nݎ̑ΎŃZbg.
	p->AlmTime = wi_GetSystemTime() + almtim;

	//! A[nh̓ԂuNvɂ.
	p->Active  = TRUE;

	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	A[nh̒~.
 *
 *	@param	[in]	no		A[nhԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_StopAlarmHadler( INT no )
{
	ER			ercd;
	WIALMOBJ	*p;

	//! A[nhԍ̃IuWFNg擾.
	p = (WIALMOBJ *)wi_FindObject( no, TMAX_MAXALM, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! A[nh̓Ԃu~vɂ.
	p->Active = FALSE;
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	A[nh̏ԎQ.
 *
 *	@param	[in]	no		A[nhԍ.
 *	@param	[out]	sts		A[nhԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_RefarenceAlarmHadler( INT no, WIALMSTAT *sts )
{
	ER			ercd;
	WIALMOBJ	*p;
	DWORDLONG	now_time;

	//! A[nhԍ̃IuWFNg擾.
	p = (WIALMOBJ *)wi_FindObject( no, TMAX_MAXALM, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! ݎ擾.
	now_time = wi_GetSystemTime();

	//! N܂ł̎ԂvZ.
	if( now_time >= p->AlmTime ){
		sts->LeftTime = 0;
	}else{
		sts->LeftTime = p->AlmTime - now_time;
	}
	//! A[nh̏Ԃ\̂ɃZbg.
	sts->Active  = p->Active;
	sts->ExtInfo = p->ExtInfo;
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	A[nh̎.
 *
 *	@param	[in]	now_time	ݎ.
 *
 *	@retval	Ȃ.
 */
void	wi_CallAlarmHandler( DWORDLONG now_time )
{
	WIALMOBJ *next_ptr;
	WIALMOBJ *p = (WIALMOBJ *)ObjList;
	while( p ){

		next_ptr = (WIALMOBJ *)p->Hdr.Next;

		if( now_time >= p->AlmTime ){
			if( p->Active ){
				if( p->AlmAdr ){
					p->AlmAdr();
				}
				p->Active = FALSE;
			}
			//! XgYA[nh菜.
			wi_DelObject( (WIHDR *)p, &ObjList );

			//! A[nhIuWFNg\̂.
			SAFE_RELEASE( p );
		}
		p = next_ptr;
	}
}

/* End of file */
