/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_common.c
 *
 *	@brief	Windows iTRONT[rXR[ (̑ʊ֐).
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include <process.h>
#include "wi_common.h"
#include "wi_task.h"
#include "wi_cycle_handler.h"
#include "wi_alarm_handler.h"

/****************************************************************************
 *
 * [J֐`.
 *
 ****************************************************************************/
static unsigned int __stdcall TimerTask( void* arg );

/****************************************************************************
 *
 * [Jϐ`.
 *
 ****************************************************************************/
static HANDLE		CommMutex;			//!< T[rXR[ŜŎgp~[ebNX̃nh.
static HANDLE		TimerThread;		//!< ^C}Xbh̃nh.
static BOOL			ExitFlag;			//!< TRUE = VXȅIv.
static DWORDLONG	SystemTime;			//!< VXe.

/****************************************************************************/
/*!
 *	@brief	ʊ֐̏.
 *
 *	@param	Ȃ.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
BOOL	wi_CommonInit( void )
{
	unsigned int tid;

	CommMutex   = NULL;
	TimerThread = NULL;
	ExitFlag    = FALSE;
	SystemTime  = 0;

	//! ~[ebNX쐬.
	CommMutex = CreateMutex( NULL, FALSE, NULL );
	if( !CommMutex ){
		return FALSE;
	}
	//! ^C}XbhN.
	TimerThread = (HANDLE)_beginthreadex( NULL, 0, &TimerTask, NULL, 0, &tid );

	//! ^XN̗Dxݒ肷.
	SetThreadPriority( TimerThread, THREAD_PRIORITY_ABOVE_NORMAL );

	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	ʊ֐̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_CommonQuit( void )
{
	ExitFlag = TRUE;

	if( TimerThread ){
		//! Xbh~̂mF.
		wi_DormantThread( TimerThread, 1000 );

		//! ^C}Xbh̃nh.
		CloseHandle( TimerThread );
	}

	//! 쐬~[ebNXN[Y.
	if( CommMutex ){
		CloseHandle( CommMutex );
		CommMutex = NULL;
	}
}

/****************************************************************************/
/*!
 *	@brief	~[ebNXbN.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_CommonLock( void )
{
	//! ~[ebNX̏Ll.
	if( CommMutex ){
		WaitForSingleObject( CommMutex, INFINITE );
	}
}

/****************************************************************************/
/*!
 *	@brief	~[ebNXAbN.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_CommonUnlock( void )
{
	//! ~[ebNX̏L.
	if( CommMutex ){
		ReleaseMutex( CommMutex );
	}
}

/****************************************************************************/
/*!
 *	@brief	Xbh~.
 *
 *	@param	[in]	hThread		Xbhnh.
 *	@param	[in]	wait_time	Xbh~̑҂.
 *
 *	@retval	Ȃ.
 */
void	wi_DormantThread( HANDLE hThread, DWORD wait_time )
{
	DWORD	i;
	DWORD	loop = (wait_time / 10) + 1;

	for( i = 0; i < loop; i++ ){
		//! Xbh̏IR[h擾.
		DWORD code;
		if( !GetExitCodeThread( hThread, &code ) ){
			TerminateThread( hThread, 0 );
			return;
		}
		//! Xbh~ĂꍇAI.
		if( code != STILL_ACTIVE ){
			return;
		}
		Sleep( 10 );
	}
	//! XbhIɏI.
	TerminateThread( hThread, 0 );
}

/****************************************************************************/
/*!
 *	@brief	VXe̐ݒ.
 *
 *	@param	[in]	stime	ݒ肷鎞.
 *
 *	@retval	Ȃ.
 */
void	wi_SetSystemTime( DWORDLONG stime )
{
	SystemTime = stime;
}

/****************************************************************************/
/*!
 *	@brief	VXe̎Q.
 *
 *	@param	Ȃ.
 *
 *	@retval	VXe.
 */
DWORDLONG	wi_GetSystemTime( void )
{
	return SystemTime;
}

/****************************************************************************/
/*!
 *	@brief	^XÑ^XNID擾.
 *
 *	@param	Ȃ.
 *
 *	@retval	^XÑ^XNID.
 */
ID		wi_GetTaskId( void )
{
	return wi_GetActiveTaskId();
}

/****************************************************************************/
/*!
 *	@brief	IuWFNgXgɃIuWFNgǉ.
 *
 *	@param	[in]	new_obj		ǉIuWFNg\̂̃|C^.
 *	@param	[out]	obj_list	IuWFNg\̃Xg̃|C^.
 *
 *	@retval	Ȃ.
 */
void	wi_AddObject( LPWIHDR new_obj, LPWIHDR *obj_list )
{
	LPWIHDR p = *obj_list;
	for( ; p && p->Next; p = p->Next ) ;

	if( !p ){
		*obj_list = new_obj;
	}else{
		p->Next = new_obj;
	}
}

/****************************************************************************/
/*!
 *	@brief	IuWFNgXgIuWFNg폜.
 *
 *	@param	[in]	del_obj		폜IuWFNg\̂̃|C^.
 *	@param	[out]	obj_list	IuWFNg\̃Xg̃|C^.
 *
 *	@retval	Ȃ.
 */
void	wi_DelObject( LPWIHDR del_obj, LPWIHDR *obj_list )
{
	if( *obj_list ){
		//! Xg̐擪̃IuWFNg폜IuWFNg̏ꍇ.
		if( *obj_list == del_obj ){
			*obj_list =  del_obj->Next;
		}else{
			LPWIHDR p;
			for( p = *obj_list; p->Next; p = p->Next ){
				//! vIuWFNgꍇAXg폜.
				if( p->Next == del_obj ){
					p->Next  = del_obj->Next;
					break;
				}
			}
		}
	}
}

/****************************************************************************/
/*!
 *	@brief	w肳ꂽʎq̃IuWFNg\̂o.
 *
 *	@param	[in]	id			IuWFNgʎq.
 *	@param	[out]	obj_list	IuWFNg\̃Xg̃|C^.
 *
 *	@retval	IuWFNg\̂̃|C^.
 */
void	*wi_GetObject( INT id, LPWIHDR obj_list )
{
	while( obj_list ){
		if( obj_list->Id == id ){
			return obj_list;
		}
		obj_list = obj_list->Next;
	}
	return NULL;
}

/****************************************************************************/
/*!
 *	@brief	IuWFNg쐬.
 *
 *	@param	[in]	id			IuWFNgIDԍ.
 *	@param	[in]	max_id		IuWFNgIDԍ̍ől.
 *	@param	[in]	size		IuWFNgIDԍ̍ől.
 *	@param	[in]	param		IuWFNg̃|C^.
 *	@param	[in]	obj_list	IuWFNgXg̃|C^.
 *	@param	[out]	ercd		G[R[hi[̈̃|C^.
 *
 *	@retval	쐬IuWFNg̃|C^.
 */
WIHDR	*wi_CreateObject( INT id, INT max_id, INT size, const void *param, WIHDR *obj_list, ER *ercd )
{
	WIHDR *p;

	//! sID̏ꍇ̓G[ɂ.
	if( id == 0 || id >= max_id ){
		*ercd = E_ID;
		return NULL;
	}
	//! ɐĂIuWFNg̏ꍇ̓G[ɂ.
	if( wi_GetObject( id, obj_list ) != NULL ){
		*ercd = E_OBJ;
		return NULL;
	}
	//! IuWFNg\̂mۂ.
	p = (WIHDR *)malloc( size );
	if( !p ){
		*ercd = E_NOMEM;
		return NULL;
	}
	//! IuWFNg̐ۑ.
	memcpy( p, param, size );
	p->Id = id;
	*ercd = E_OK;
	return p;
}

/****************************************************************************/
/*!
 *	@brief	w肵IDԍ̃IuWFNgXg猟.
 *
 *	@param	[in]	id			IuWFNgIDԍ.
 *	@param	[in]	max_id		IuWFNgIDԍ̍ől.
 *	@param	[in]	obj_list	IuWFNgXg̃|C^.
 *	@param	[out]	ercd		G[R[hi[̈̃|C^.
 *
 *	@retval	oIuWFNg̃|C^.
 */
WIHDR	*wi_FindObject( INT id, INT max_id, WIHDR *obj_list, ER *ercd )
{
	WIHDR *p;

	//! sID̏ꍇ̓G[ɂ.
	if( id == 0 || id >= max_id ){
		*ercd = E_ID;
		return NULL;
	}
	//! XgIuWFNg擾.
	p = (WIHDR *)wi_GetObject( id, obj_list );
	if( !p ){
		*ercd = E_NOEXS;
		return NULL;
	}
	*ercd = E_OK;
	return p;
}

/****************************************************************************/
/*!
 *	@brief	Oobt@̃JE^CNg.
 *
 *	@param	[in]	pos		Oobt@̃JE^.
 *	@param	[in]	size	Oobt@̃TCY.
 *
 *	@retval	CNg̃JE^l.
 */
DWORD	wi_IncRingPositon( DWORD pos, DWORD size )
{
	return ((pos + 1) >= size) ? 0 : (pos + 1);
}

/****************************************************************************/
/*!
 *	@brief	iTROÑ^C}ԂWindowsp^C}Ԃɕϊ.
 *
 *	@param	[in]	tmout		iTRONp^C}ݒ莞.
 *
 *	@retval	Windowsp^C}̎.
 */
DWORD	wi_CvtTimeOutValue( TMO tmout )
{
	switch( tmout ){
	  case TMO_POL : return 0;
	  case TMO_FEVR: return INFINITE;
	  default      : return tmout;
	}
}

/****************************************************************************/
/*!
 *	@brief	^C}^XN.
 *
 *	@param	[in]	arg		^XN\[X\̂̃|C^.
 *
 *	@retval	0Ԃ.
 */
static unsigned __stdcall TimerTask( void* arg )
{
	while( !ExitFlag ){

		DWORD btime,ntime,dtime;

		//! X[vÕ^CJE^擾.
		btime = GetTickCount();

		//! 莞ԃX[v.
//		timeBeginPeriod( 1 );
		Sleep( CYCLETIME );
//		timeEndPeriod ( 1 );

		//! X[ṽ^CJE^擾.
		ntime = GetTickCount();

		//! ۂɃX[vԂvZ.
		if( ntime >= btime ){
			dtime = ntime - btime;
		}else{
			dtime = btime - ntime;
		}
		//! VXeJEgAbv.
		SystemTime += dtime;

		//! NnhĂяo.
		wi_CycleTimer( SystemTime );

		//! A[nhĂяo.
		wi_CallAlarmHandler( SystemTime );
	}
	_endthreadex( 0 );
	return 0;
}

/* End of file */
