/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_data_queue.c
 *
 *	@brief	Windows iTRONT[rXR[ (f[^L[).
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include "wi_data_queue.h"

/****************************************************************************
 *
 * [Jϐ`.
 *
 ****************************************************************************/
static WIHDR	*ObjList;			//!< f[^L[Xg̃|C^.

/****************************************************************************/
/*!
 *	@brief	f[^L[̏.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_InitDataQueue( void )
{
	ObjList = NULL;
}

/****************************************************************************/
/*!
 *	@brief	f[^L[̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_QuitDataQueue( void )
{
	WIHDR		*next_ptr;
	WIDTQOBJ	*p = (WIDTQOBJ *)ObjList;

	while( p ){
		next_ptr = p->Hdr.Next;

		//! f[^L[obt@.
		SAFE_RELEASE( p->QueBuf );

		//! f[^L[IuWFNg\̂.
		SAFE_RELEASE( p );

		//! ̃f[^L[IuWFNg\̂o.
		p = (WIDTQOBJ *)next_ptr;
	}
}

/****************************************************************************/
/*!
 *	@brief	f[^L[̐.
 *
 *	@param	[in]	id		f[^L[IDԍ.
 *	@param	[in]	obj		f[^L[IuWFNg\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_CreateDataQueue( INT id, const WIDTQOBJ *obj )
{
	ER			ercd;
	WIDTQOBJ	*p;

	//! f[^L[IuWFNg쐬.
	p = (WIDTQOBJ *)wi_CreateObject( id, TMAX_MAXDTQ, sizeof(WIDTQOBJ), obj, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	if( p->QueSize > 0 ){
		//! obt@FULLׂ̈1]vɃobt@mۂ.
		p->QueSize++;

		//! f[^L[obt@mۂ.
		p->QueBuf = (DWORD *)malloc( sizeof(DWORD) * p->QueSize );
		if( !p->QueBuf ){
			SAFE_RELEASE( p );
			return E_NOMEM;
		}
		//! mۂf[^L[obt@NA.
		memset( p->QueBuf, 0, sizeof(DWORD) * p->QueSize );
	}
	p->GetPos = 0;
	p->PutPos = 0;

	//! XgɃf[^L[ǉ.
	wi_AddObject( (WIHDR *)p, &ObjList );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	f[^L[̍폜.
 *
 *	@param	[in]	id		f[^L[IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_DeleteDataQueue( INT id )
{
	ER			ercd;
	WIDTQOBJ	*p;

	//! f[^L[ID̃IuWFNg擾.
	p = (WIDTQOBJ *)wi_FindObject( id, TMAX_MAXDTQ, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgYf[^L[菜.
	wi_DelObject( (WIHDR *)p, &ObjList );

	//! ҂^XNL[.
	wi_WakeupDelResource( p->SndWaitQue );
	wi_WakeupDelResource( p->RcvWaitQue );

	//! f[^L[obt@.
	SAFE_RELEASE( p->QueBuf );

	//! f[^L[IuWFNg\̂.
	SAFE_RELEASE( p );
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	f[^L[ւ̑M.
 *
 *	@param	[in]	id		f[^L[IDԍ.
 *	@param	[in]	data	f[^L[ɑMf[^.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		wi_SendDataQueue( INT id, DWORD data, TMO tmout )
{
	WITSKOBJ	*tsk;
	WIDTQOBJ	*p;
	DWORD		pos;
	ER			ercd;

	//! f[^L[ID̃IuWFNg擾.
	p = (WIDTQOBJ *)wi_FindObject( id, TMAX_MAXDTQ, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! f[^L[obt@mۂĂȂꍇ.
	if( p->QueSize == 0 || !p->QueBuf ){

		if( p->RcvWaitQue ){
			tsk = (WITSKOBJ *)(p->RcvWaitQue);

			//! bZ[WM^XNɕۑ.
			tsk->Param[0] = (VP)data;

			//! bZ[W҂Ă^XNꍇ̓^XNN.
			wi_TaskWakeup( tsk->Hdr.Id, TTW_RDTQ, &(p->RcvWaitQue) );
			return E_OK;
		}else{
			//! bZ[W𑗐M^XN(^XN)ɕۑ.
			tsk = wi_GetTaskObject( TSK_SELF );
			if( tsk ){
				tsk->Param[0] = (VP)data;
			}
			//! M^XN܂Ń^XNX[v.
			ercd = wi_TaskWait( id, TTW_SDTQ, tmout, p->Attribute, &(p->SndWaitQue) );
			return ercd;
		}
	}
	pos = wi_IncRingPositon( p->PutPos, p->QueSize );
	if( pos == p->GetPos ){
		//! f[^L[obt@󂭂܂Ń^XNX[v.
		ercd = wi_TaskWait( id, TTW_SDTQ, tmout, p->Attribute, &(p->SndWaitQue) );
		if( ercd != E_OK ){
			return ercd;
		}
	}
	//! f[^L[ɑMf[^i[.
	p->QueBuf[p->PutPos] = data;

	//! f[^L[݈̏ʒuXV.
	p->PutPos = pos;

	//! f[^M҂Ă^XNꍇ̓^XNN.
	if( p->RcvWaitQue ){
		wi_TaskWakeup( p->RcvWaitQue->Id, TTW_RDTQ, &(p->RcvWaitQue) );
	}
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	f[^L[ւ̋M.
 *
 *	@param	[in]	id		f[^L[IDԍ.
 *	@param	[in]	data	f[^L[ɑMf[^.
 *
 *	@retval	G[R[h.
 */
ER		wi_ForceSendDataQueue( INT id, DWORD data )
{
	ER			ercd;
	WIDTQOBJ	*p;
	DWORD		pos;

	//! f[^L[ID̃IuWFNg擾.
	p = (WIDTQOBJ *)wi_FindObject( id, TMAX_MAXDTQ, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! f[^L[obt@mۂĂȂꍇ̓G[ɂ.
	if( p->QueSize == 0 ){
		return E_ILUSE;
	}
	//! f[^L[ɋ󂫂Ȃꍇ̓f[^L[̐擪f[^p.
	pos = wi_IncRingPositon( p->PutPos, p->QueSize );
	if( pos == p->GetPos ){
		p->GetPos = wi_IncRingPositon( p->GetPos, p->QueSize );
	}
	//! f[^L[̃f[^MĂяo.
	return wi_SendDataQueue( id, data, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	f[^L[̎M.
 *
 *	@param	[in]	id		f[^L[IDԍ.
 *	@param	[out]	data	f[^L[Mf[^i[̈̃|C^.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		wi_ReceiveDataQueue( INT id, DWORD *data, TMO tmout )
{
	ER			ercd;
	WIDTQOBJ	*p;
	WITSKOBJ	*tsk;

	//! f[^L[ID̃IuWFNg擾.
	p = (WIDTQOBJ *)wi_FindObject( id, TMAX_MAXDTQ, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! sȏꍇ̓G[ɂ.
	if( !data ){
		return E_PAR;
	}
	//! f[^L[obt@mۂĂȂꍇ.
	if( p->QueSize == 0 || !p->QueBuf ){

		if( p->SndWaitQue ){
			tsk = (WITSKOBJ *)(p->SndWaitQue);

			//! MbZ[Wo.
			*data = (DWORD)(tsk->Param[0]);

			//! bZ[WM҂Ă^XNN.
			wi_TaskWakeup( tsk->Hdr.Id, TTW_SDTQ, &(p->SndWaitQue) );
			return E_OK;
		}else{
			//! bZ[WM܂Ń^XNX[v.
			ercd = wi_TaskWait( id, TTW_RDTQ, tmout, p->Attribute, &(p->RcvWaitQue) );
			if( ercd == E_OK ){
				//! MbZ[Wo.
				tsk = wi_GetTaskObject( TSK_SELF );
				if( tsk ){
					*data = (DWORD)(tsk->Param[0]);
				}
			}
			return ercd;
		}
	}
	//! f[^L[Ƀf[^ꍇAf[^oďI.
	if( p->GetPos != p->PutPos ){

		//! f[^L[̐擪f[^o.
		*data = p->QueBuf[p->GetPos];

		//! f[^L[̓ǂݏoʒuXV.
		p->GetPos = wi_IncRingPositon( p->GetPos, p->QueSize );

		//! obt@󂭂̂҂Ă^XNꍇ̓^XNN.
		if( p->SndWaitQue ){
			wi_TaskWakeup( p->SndWaitQue->Id, TTW_SDTQ, &(p->SndWaitQue) );
		}
		return E_OK;
	}
	//! bZ[WM܂Ń^XNX[v.
	ercd = wi_TaskWait( id, TTW_RDTQ, tmout, p->Attribute, &(p->RcvWaitQue) );
	if( ercd == E_OK ){
		if( p->GetPos != p->PutPos ){
			//! f[^L[̐擪f[^o.
			*data = p->QueBuf[p->GetPos];

			//! f[^L[̓ǂݏoʒuXV.
			p->GetPos = wi_IncRingPositon( p->GetPos, p->QueSize );
		}
	}
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	f[^L[̏ԎQ.
 *
 *	@param	[in]	id		f[^L[IDԍ.
 *	@param	[out]	sts		f[^L[Ԃi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_RefarenceDataQueue( INT id, WIDTQSTAT *sts )
{
	ER			ercd;
	WIDTQOBJ	*p;
	DWORD		cnt;

	//! f[^L[ID̃IuWFNg擾.
	p = (WIDTQOBJ *)wi_FindObject( id, TMAX_MAXDTQ, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! f[^L[ɓĂf[^̌vZ.
	if( p->GetPos <= p->PutPos ){
		cnt = p->PutPos - p->GetPos;
	}else{
		cnt = (p->QueSize + p->PutPos) - p->GetPos;
	}
	//! f[^L[̏Ԃ\̂ɃZbg.
	sts->SndWaitId = wi_GetWaitTaskListFirstId( p->SndWaitQue );
	sts->RcvWaitId = wi_GetWaitTaskListFirstId( p->RcvWaitQue );
	sts->DataCnt   = cnt;
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	폜^XN҂s񂩂폜.
 *
 *	@param	[in]	id	폜^XNIDԍ.
 *
 *	@retval	Ȃ.
 */
void	wi_AllReleaseDataQueue( INT id )
{
	WIDTQOBJ *p;

	for( p = (WIDTQOBJ *)ObjList; p; p = (WIDTQOBJ *)p->Hdr.Next ){

		//! 폜^XN҂s񂩂폜.
		p->SndWaitQue = wi_DelWaitTaskList( id, p->SndWaitQue );
		p->SndWaitQue = wi_DelWaitTaskList( id, p->SndWaitQue );
	}
}

/* End of file */
