/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_event_flag.c
 *
 *	@brief	Windows iTRONT[rXR[ (CxgtO).
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include "wi_event_flag.h"

/****************************************************************************
 *
 * [Jϐ`.
 *
 ****************************************************************************/
static WIHDR		*ObjList;		//!< CxgtOXg̃|C^.

/****************************************************************************/
/*!
 *	@brief	CxgtOǗ̏.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_InitEvFlag( void )
{
	ObjList = NULL;
}

/****************************************************************************/
/*!
 *	@brief	CxgtOǗ̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_QuitEvFlag( void )
{
	WIHDR		*next_ptr;
	WIFLGOBJ	*p = (WIFLGOBJ *)ObjList;

	while( p ){
		next_ptr = p->Hdr.Next;

		//! CxgtOIuWFNg\̂.
		SAFE_RELEASE( p );

		//! ̃CxgtOIuWFNg\̂o.
		p = (WIFLGOBJ *)next_ptr;
	}
}

/****************************************************************************/
/*!
 *	@brief	CxgtO̐.
 *
 *	@param	[in]	id		CxgtOIDԍ.
 *	@param	[in]	obj		CxgtOIuWFNg\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_CreateEvFlag( INT id, WIFLGOBJ *obj )
{
	ER			ercd;
	WIFLGOBJ	*p;

	//! CxgtOIuWFNg쐬.
	p = (WIFLGOBJ *)wi_CreateObject( id, TMAX_MAXFLG, sizeof(WIFLGOBJ), obj, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgɃCxgtOǉ.
	wi_AddObject( (WIHDR *)p, &ObjList );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	CxgtO̍폜.
 *
 *	@param	[in]	id		CxgtOIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_DeleteEvFlag( INT id )
{
	ER			ercd;
	WIFLGOBJ	*p;

	//! CxgtOID̃IuWFNg擾.
	p = (WIFLGOBJ *)wi_FindObject( id, TMAX_MAXFLG, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgYCxgtO菜.
	wi_DelObject( (WIHDR *)p, &ObjList );

	//! ҂^XNL[.
	wi_WakeupDelResource( p->WaitQue );

	//! CxgtOIuWFNg\̂.
	SAFE_RELEASE( p );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	CxgtÕZbg.
 *
 *	@param	[in]	id		CxgtOIDԍ.
 *	@param	[in]	setptn	Zbgrbgp^[.
 *
 *	@retval	G[R[h.
 */
ER		wi_SetEvFlag( INT id, UINT setptn )
{
	ER			ercd;
	WIFLGOBJ	*p;
	WITSKOBJ	*tsk,*next_link;
	UINT		tsk_flg,event_mode;
	BOOL		event_on;

	//! CxgtOID̃IuWFNg擾.
	p = (WIFLGOBJ *)wi_FindObject( id, TMAX_MAXFLG, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! sȏꍇ̓G[ɂ.
	if( setptn == 0 ){
		return E_PAR;
	}
	//! w肳ꂽtOZbg.
	p->FlgVal |= setptn;

	tsk = (WITSKOBJ *)(p->WaitQue);
	while( tsk ){
		event_on   = FALSE;
		tsk_flg    = (UINT)tsk->Param[0];
		event_mode = (UINT)tsk->Param[1];

		if( event_mode & TWF_ORW ){
			//! OR҂̏ꍇAꂩ̃rbgv΃Cxg𔭍s.
			if( (tsk_flg & p->FlgVal) != 0 ){
				event_on = TRUE;
			}
		}else{
			//! AND҂̏ꍇASẴrbgv΃Cxg𔭍s.
			if( (tsk_flg & p->FlgVal) == tsk_flg ){
				event_on = TRUE;
			}
		}
		//! ̃Cxg҂^XNo.
		next_link = tsk->QueLink;

		if( event_on ){
			//! Cxg̃tOp^[^XNIuWFNgɕۑ.
			tsk->Param[2] = (VP)(p->FlgVal);

			//! tÕNAݒ肪Ăꍇ̓tONA.
			if( (event_mode & TWF_CLR) != 0 || (p->Attribute & TA_CLR) != 0 ){
				p->FlgVal = 0;
			}
			//! Cxg҂Ă^XNN.
			wi_TaskWakeup( tsk->Hdr.Id, TTW_FLG, &(p->WaitQue) );
		}
		tsk = next_link;
	}
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	CxgtÕNA.
 *
 *	@param	[in]	id		CxgtOIDԍ.
 *	@param	[in]	clrptn	NArbgp^[.
 *
 *	@retval	G[R[h.
 */
ER		wi_ClearEvFlag( INT id, UINT clrptn )
{
	ER			ercd;
	WIFLGOBJ	*p;

	//! CxgtOID̃IuWFNg擾.
	p = (WIFLGOBJ *)wi_FindObject( id, TMAX_MAXFLG, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! w肳ꂽtONA.
	p->FlgVal &= clrptn;

	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	CxgtO҂.
 *
 *	@param	[in]	id			CxgtOIDԍ.
 *	@param	[out]	flgptn		҂̃rbgp^[i[̈̃|C^.
 *	@param	[in]	waiptn		҂rbgp^[.
 *	@param	[in]	wfmode		҂[h.
 *	@param	[in]	tmout		^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		wi_WaitEvFlag( INT id, UINT *flgptn, UINT waiptn, UINT wfmode, TMO tmout )
{
	WITSKOBJ	*tsk;
	WIFLGOBJ	*p;
	ER			ercd;
	BOOL		event_on;

	//! sȏꍇ̓G[ɂ.
	if( !flgptn || waiptn == 0 ){
		return E_PAR;
	}
	//! CxgtOID̃IuWFNg擾.
	p = (WIFLGOBJ *)wi_FindObject( id, TMAX_MAXFLG, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	*flgptn  = 0;
	event_on = FALSE;
	if( wfmode & TWF_ORW ){
		//! OR҂̏ꍇAꂩ̃rbgv΁uCxgvɂ.
		if( (waiptn & p->FlgVal) != 0 ){
			event_on = TRUE;
		}
	}else{
		//! AND҂̏ꍇASẴrbgv΁uCxgvɂ.
		if( (waiptn & p->FlgVal) == waiptn ){
			event_on = TRUE;
		}
	}
	if( event_on ){
		//! Cxg̃tOp^[߂lɃZbg.
		*flgptn = p->FlgVal;

		//! tÕNAݒ肪Ăꍇ̓tONA.
		if( (wfmode & TWF_CLR) != 0 || (p->Attribute & TA_CLR) != 0 ){
			p->FlgVal = 0;
		}
		return E_OK;
	}
	//! ^XN̑҂ȂݒŁA҂sɑ̃^XNꍇ̓G[ɂ.
	if( (p->Attribute & TA_WMUL) == 0 && p->WaitQue ){
		return E_ILUSE;
	}
	//! ^XÑ^XNIuWFNg擾.
	tsk = wi_GetTaskObject( TSK_SELF );
	if( !tsk ){
		return E_CTX;
	}
	//! ҂tOp^[^XNIuWFNgɕۑ.
	tsk->Param[0] = (VP)waiptn;
	tsk->Param[1] = (VP)wfmode;
	tsk->Param[2] = 0;

	//! CxgtO܂Ń^XNX[v.
	ercd = wi_TaskWait( id, TTW_FLG, tmout, p->Attribute, &(p->WaitQue) );

	//! Cxg̃tOp^[߂lɃZbg.
	if( ercd == E_OK ){
		*flgptn = (UINT)(tsk->Param[2]);
	}
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CxgtOԂ̎Q.
 *
 *	@param	[in]	id		CxgtOIDԍ.
 *	@param	[in]	sts		CxgtOԂi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_RefarenceEvFlag( INT id, WIFLGSTAT *sts )
{
	ER			ercd;
	WIFLGOBJ	*p;

	//! CxgtOID̃IuWFNg擾.
	p = (WIFLGOBJ *)wi_FindObject( id, TMAX_MAXFLG, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! CxgtȌԂ\̂ɃZbg.
	sts->WaitId  = wi_GetWaitTaskListFirstId( p->WaitQue );
	sts->FlgVal  = p->FlgVal;
	sts->ExtInfo = p->ExtInfo;

	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	폜^XN҂s񂩂폜.
 *
 *	@param	[in]	id		폜^XNIDԍ.
 *
 *	@retval	Ȃ.
 */
void	wi_AllReleaseEvFlag( INT id )
{
	WIFLGOBJ *p;

	for( p = (WIFLGOBJ *)ObjList; p; p = (WIFLGOBJ *)p->Hdr.Next ){

		//! 폜^XN҂s񂩂폜.
		p->WaitQue = wi_DelWaitTaskList( id, p->WaitQue );
	}
}

/* End of file */
