/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_message_buffer.c
 *
 *	@brief	Windows iTRONT[rXR[ (bZ[Wobt@).
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include "wi_message_buffer.h"

/****************************************************************************
 *
 * [J֐`.
 *
 ****************************************************************************/
static void		RestoreMessageData( WIMBFOBJ *p );
static INT		GetNextMessageSize( WIMBFOBJ *p );
static INT		GetFreeSize( WIMBFOBJ *p );
static BOOL		PutMesageData( WIMBFOBJ *p, BYTE* msg, INT len );
static INT		GetMessageData( WIMBFOBJ *p, BYTE* msg );

/****************************************************************************
 *
 * [Jϐ`.
 *
 ****************************************************************************/
static WIHDR	*ObjList;		//!< bZ[Wobt@Xg̃|C^.

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̏.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_InitMsgBuffer( void )
{
	ObjList = NULL;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_QuitMsgBuffer( void )
{
	WIHDR		*next_ptr;
	WIMBFOBJ	*p = (WIMBFOBJ *)ObjList;

	while( p ){
		next_ptr = p->Hdr.Next;

		//! bZ[Wobt@.
		SAFE_RELEASE( p->MsgBuf );

		//! bZ[Wobt@IuWFNg\̂.
		SAFE_RELEASE( p );

		//! ̃bZ[Wobt@IuWFNg\̂o.
		p = (WIMBFOBJ *)next_ptr;
	}
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̐.
 *
 *	@param	[in]	id		bZ[Wobt@IDԍ.
 *	@param	[in]	obj		bZ[Wobt@IuWFNg\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_CreateMsgBuffer( INT id, const WIMBFOBJ *obj )
{
	ER			ercd;
	WIMBFOBJ	*p;

	//! sȈ̏ꍇ̓G[ɂ.
	if( obj->MaxMsg == 0 ){
		return E_PAR;
	}
	//! bZ[Wobt@IuWFNg쐬.
	p = (WIMBFOBJ *)wi_CreateObject( id, TMAX_MAXMBF, sizeof(WIMBFOBJ), obj, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! bZ[Wobt@mۂ.
	if( p->MsgSize > 0 ){
		p->MsgBuf = (BYTE *)malloc( p->MsgSize );
		if( !p->MsgBuf ){
			SAFE_RELEASE( p );
			return E_NOMEM;
		}
		//! mۂbZ[Wobt@NA.
		memset( p->MsgBuf, 0, p->MsgSize );
	}
	p->GetPos = 0;
	p->PutPos = 0;

	//! XgɃbZ[Wobt@ǉ.
	wi_AddObject( (WIHDR *)p, &ObjList );

	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̍폜.
 *
 *	@param	[in]	id		bZ[Wobt@IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_DeleteMsgBuffer( INT id )
{
	ER			ercd;
	WIMBFOBJ	*p;

	//! bZ[Wobt@ID̃IuWFNg擾.
	p = (WIMBFOBJ *)wi_FindObject( id, TMAX_MAXMBF, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgY郁bZ[Wobt@菜.
	wi_DelObject( (WIHDR *)p, &ObjList );

	//! ҂^XNL[.
	wi_WakeupDelResource( p->SndWaitQue );
	wi_WakeupDelResource( p->RcvWaitQue );

	//! bZ[Wobt@.
	SAFE_RELEASE( p->MsgBuf );

	//! bZ[Wobt@IuWFNg\̂.
	SAFE_RELEASE( p );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@ւ̑M.
 *
 *	@param	[in]	id		bZ[Wobt@IDԍ.
 *	@param	[in]	msg		bZ[W̃|C^.
 *	@param	[in]	size	bZ[W̃TCY.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		wi_SendMsgBuffer( INT id, VP msg, INT size, TMO tmout )
{
	ER			ercd;
	WIMBFOBJ	*p;
	WITSKOBJ	*tsk1,*tsk2;

	//! bZ[Wobt@ID̃IuWFNg擾.
	p = (WIMBFOBJ *)wi_FindObject( id, TMAX_MAXMBF, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! sȏꍇ̓G[ɂ.
	if( !msg || !size ){
		return E_PAR;
	}
	//! bZ[W҂Ă^XNꍇ.
	if( p->RcvWaitQue ){

		//! bZ[W҂Ă^XNɃbZ[Wn.
		tsk1 = (WITSKOBJ *)(p->RcvWaitQue);
		if( tsk1->Param[0] ){
			memcpy( tsk1->Param[0], msg, size );
			tsk1->Param[1] = (VP)size;
		}
		//! bZ[W҂Ă^XNN.
		wi_TaskWakeup( tsk1->Hdr.Id, TTW_RMBF, &(p->RcvWaitQue) );
		return E_OK;
	}
	//! ^XÑ^XNReLXgo.
	tsk1 = wi_GetTaskObject( TSK_SELF );

	//! ^XNReLXǧĂяȍꍇ̓G[ɂ.
	if( !tsk1 ){
		return E_CTX;
	}
	//! M҂̃^XNꍇ.
	if( p->SndWaitQue ){

		/*!
		 * ҂s񂪃^XNDx̏ꍇA҂s̐擪̃^XN̗Dx
		 * ̃^XN(^XN)̗Dx傫΁AbZ[Wobt@
		 * ҂s̃^XNɑMbZ[Wi[.
		 */
		if( p->SndAttr & TA_TPRI ){
			tsk2 = (WITSKOBJ *)(p->SndWaitQue);
			if( tsk1->TaskPri > tsk2->TaskPri ){
				if( PutMesageData( p, msg, size ) ){
					return E_OK;
				}
			}
		}
	}else{
		//! bZ[Wobt@̍ŌɑMbZ[Wi[.
		if( PutMesageData( p, msg, size ) ){
			return E_OK;
		}
	}
	//! ^XNReLXgɑMbZ[Wi[Ă.
	tsk1->Param[0] = msg;
	tsk1->Param[1] = (VP)size;

	//! obt@󂭂܂Ń^XNX[v.
	return wi_TaskWait( id, TTW_SMBF, tmout, p->SndAttr, &(p->SndWaitQue) );
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̎M.
 *
 *	@param	[in]	id		bZ[Wobt@IDԍ.
 *	@param	[out]	msg		bZ[Wi[̈̃|C^.
 *	@param	[out]	size	bZ[WTCYi[̈̃|C^.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		wi_ReceiveMsgBuffer( INT id, VP msg, INT *size, TMO tmout )
{
	ER			ercd;
	WIMBFOBJ	*p;
	WITSKOBJ	*tsk;

	//! bZ[Wobt@ID̃IuWFNg擾.
	p = (WIMBFOBJ *)wi_FindObject( id, TMAX_MAXMBF, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! sȏꍇ̓G[ɂ.
	if( !msg || !size ){
		return E_PAR;
	}
	//! bZ[Wobt@烁bZ[Wo.
	*size = GetMessageData( p, (BYTE *)msg );
	if( *size > 0 ){
		//! bZ[Wobt@󂢂̂őM҂Ă郁bZ[Wobt@ɏ.
		RestoreMessageData( p );
		return E_OK;
	}
	/*!
	 * bZ[WM҂Ă^XNꍇA
	 * bZ[WM^XN璼ڃbZ[W󂯎.
	 */
	if( p->SndWaitQue ){

		//! bZ[WM҂Ă^XÑReLXgo.
		tsk = (WITSKOBJ *)(p->SndWaitQue);

		if( tsk->Param[0] ){
			//! bZ[WM^XN璼ڃbZ[WRs[.
			memcpy( msg, tsk->Param[0], (INT)(tsk->Param[1]) );
			tsk->Param[0] = NULL;
			tsk->Param[1] = 0;

			/*!
			 * bZ[Wobt@ɏ߂邩Ȃ̂
			 * M҂Ă郁bZ[Wobt@ɏ.
			 */
			RestoreMessageData( p );

			return E_OK;
		}else{
			/*!
			 * MbZ[ŴɑM҂Ă^XNꍇA
			 * M҂Ă^XN͋N.
			 */
			wi_TaskWakeup( tsk->Hdr.Id, TTW_SMBF, &(p->SndWaitQue) );
			return E_SYS;
		}
	}
	//! ^XÑ^XNReLXgɃbZ[Wi[obt@̃|C^Zbg.
	tsk = wi_GetTaskObject( TSK_SELF );
	if( !tsk ){
		return E_CTX;
	}
	tsk->Param[0] = msg;
	tsk->Param[1] = 0;

	//! bZ[WM܂Ń^XNX[v.
	ercd = wi_TaskWait( id, TTW_RMBF, tmout, p->RcvAttr, &(p->RcvWaitQue) );
	if( ercd == E_OK ){
		*size = (INT)tsk->Param[1];
	}
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̏ԎQ.
 *
 *	@param	[in]	id		bZ[Wobt@IDԍ.
 *	@param	[out]	sts		bZ[Wobt@Ԃi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_RefarenceMsgBuffer( INT id, WIMBFSTAT *sts )
{
	ER			ercd;
	WIMBFOBJ	*p;

	//! bZ[Wobt@ID̃IuWFNg擾.
	p = (WIMBFOBJ *)wi_FindObject( id, TMAX_MAXMBF, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! bZ[Wobt@̏Ԃ\̂ɃZbg.
	sts->SndWaitId = wi_GetWaitTaskListFirstId( p->SndWaitQue );
	sts->RcvWaitId = wi_GetWaitTaskListFirstId( p->RcvWaitQue );
	sts->MsgSize   = GetNextMessageSize( p );
	sts->FreeSize  = GetFreeSize( p );
	sts->ExtInfo   = p->ExtInfo;
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	bZ[WM҂Ăf[^obt@ɏ.
 *
 *	@param	[in]	p		bZ[Wobt@IuWFNg̃|C^.
 *
 *	@retval	Ȃ.
 */
static void		RestoreMessageData( WIMBFOBJ *p )
{
	WITSKOBJ *tsk;

	tsk = (WITSKOBJ *)(p->SndWaitQue);
	while( tsk ){

		//! bZ[Wobt@ɏ߂Ȃꍇ͏Iɂ.
		if( tsk->Param[0] ){
			if( !PutMesageData( p, (BYTE *)(tsk->Param[0]), (INT)(tsk->Param[1]) ) ){
				break;
			}
		}
		//! bZ[W̑M҂Ă^XNN.
		wi_TaskWakeup( tsk->Hdr.Id, TTW_SMBF, NULL );

		//! ҂s񂩂玟̃^XNo.
		tsk = tsk->QueLink;
	}
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̐擪bZ[W̃TCY擾.
 *
 *	@param	[in]	p		bZ[Wobt@IuWFNg̃|C^.
 *
 *	@retval	bZ[Wobt@̐擪bZ[W̃TCY.
 */
static INT		GetNextMessageSize( WIMBFOBJ *p )
{
	INT i,pos;
	INT msg_size = 0;

	if( p->GetPos == p->PutPos || !p->MsgBuf ){
		msg_size = 0;
	}else{
		pos = p->GetPos;
		for( i = 0; i < 4; i++ ){
			//! bZ[W̃TCY1oCgÂo.
			msg_size = (msg_size << 8) + ((INT)p->MsgBuf[pos] & 0xFF);

			pos = wi_IncRingPositon( pos, p->MsgSize );
		}
	}
	return msg_size;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̋󂫗̈̃TCY擾.
 *
 *	@param	[in]	p		bZ[Wobt@IuWFNg̃|C^.
 *
 *	@retval	bZ[Wobt@̋󂫗̈̃TCY.
 */
static INT		GetFreeSize( WIMBFOBJ *p )
{
	INT free_size = 0;

	if( p->GetPos == p->PutPos ){
		if( !p->MsgBuf || p->MsgSize == 0 ){
			free_size = 0;
		}else{
			free_size = p->MsgSize - sizeof(DWORD);
		}
	}else{
		if( p->GetPos <= p->PutPos ){
			free_size = p->MsgSize - (p->PutPos - p->GetPos) - sizeof(DWORD);
		}else{
			free_size = (p->GetPos - p->PutPos) - sizeof(DWORD);
		}
	}
	if( free_size < 0 ){
		free_size = 0;
	}
	return free_size;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@ɃbZ[Wi[.
 *
 *	@param	[in]	p		bZ[Wobt@IuWFNg̃|C^.
 *	@param	[in]	msg		bZ[Wi[̈̃|C^.
 *	@param	[in]	len		bZ[W̃TCY.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static BOOL	PutMesageData( WIMBFOBJ *p, BYTE* msg, INT len )
{
	INT i;
	INT free_size;

	//! bZ[Wobt@ɋ󂫂Ȃꍇ͏I.
	free_size = GetFreeSize( p );
	if( free_size < len ){
		return FALSE;
	}
	/*!
	 * bZ[WTCY̓rŃOobt@܂ԂȂ̂
	 * bZ[WTCY1oCgÂobt@Ɋi[.
	 */
	for( i = 0; i < 4; i++ ){
		static int shift[4] = { 24, 16, 8, 0 };

		//! bZ[W̃TCY1oCgÂi[.
		p->MsgBuf[p->PutPos] = (BYTE)((((DWORD)len) >> shift[i]) & 0xFF);

		//! obt@݈̏ʒuXV.
		p->PutPos = wi_IncRingPositon( p->PutPos, p->MsgSize );
	}
	//! bZ[WOobt@܂Ԃꍇ2ɕăbZ[Wi[.
	if( (p->PutPos + len) > p->MsgSize ){
		DWORD size1,size2;

		//! Oobt@̍ŌɃbZ[W̐擪f[^Rs[.
		size1 = p->MsgSize - p->PutPos;
		memcpy( &p->MsgBuf[p->PutPos], msg, size1 );

		//! Oobt@̐擪Ɏc̃bZ[WRs[.
		size2 = len - size1;
		memcpy( p->MsgBuf, &msg[size1], size2 );

		//! obt@݈̏ʒuXV.
		p->PutPos = size2;
	}else{
		//! obt@ɃbZ[WRs[.
		memcpy( &p->MsgBuf[p->PutPos], msg, len );

		//! obt@݈̏ʒuXV.
		p->PutPos += len;
	}
	return (INT)len;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@烁bZ[Wo.
 *
 *	@param	[in]	p		bZ[Wobt@IuWFNg̃|C^.
 *	@param	[out]	msg		bZ[Wi[̈̃|C^.
 *
 *	@retval	obZ[W̃TCY.
 */
static INT	GetMessageData( WIMBFOBJ *p, BYTE* msg )
{
	int		i;
	DWORD	len;

	//! bZ[Wobt@Ƀf[^Ȃꍇ͏I.
	if( !p->MsgBuf || p->GetPos == p->PutPos ){
		return 0;
	}
	/*!
	 * bZ[WTCY̓rŃOobt@܂ԂȂ̂
	 * bZ[WTCY1oCgÂobt@o.
	 */
	len = 0;
	for( i = 0; i < 4; i++ ){
		//! bZ[W̃TCY1oCgÂo.
		len = (len << 8) + ((DWORD)p->MsgBuf[p->GetPos] & 0x000000FF);

		//! obt@̓ǂݏoʒuXV.
		p->GetPos = wi_IncRingPositon( p->GetPos, p->MsgSize );
	}
	//! bZ[WOobt@܂Ԃꍇ2ɕăbZ[Wo.
	if( (p->GetPos + len) > p->MsgSize ){
		DWORD size1,size2;

		//! Oobt@̍Ōォ烁bZ[W̐擪f[^Rs[.
		size1 = p->MsgSize - p->GetPos;
		memcpy( msg, &p->MsgBuf[p->GetPos], size1 );

		//! Oobt@̐擪c̃bZ[WRs[.
		size2 = len - size1;
		memcpy( &msg[size1], p->MsgBuf, size2 );

		//! obt@̓ǂݏoʒuXV.
		p->GetPos = size2;
	}else{
		//! obt@烁bZ[WRs[.
		memcpy( msg, &p->MsgBuf[p->GetPos], len );

		//! obt@̓ǂݏoʒuXV.
		p->GetPos += len;
	}
	return (INT)len;
}

/****************************************************************************/
/*!
 *	@brief	폜^XN҂s񂩂폜.
 *
 *	@param	[in]	id		폜^XNIDԍ.
 *
 *	@retval	Ȃ.
 */
void	wi_AllReleaseMsgBuffer( INT id )
{
	WIMBFOBJ *p;

	for( p = (WIMBFOBJ *)ObjList; p; p = (WIMBFOBJ *)p->Hdr.Next ){

		//! 폜^XN҂s񂩂폜.
		p->SndWaitQue = wi_DelWaitTaskList( id, p->SndWaitQue );
		p->RcvWaitQue = wi_DelWaitTaskList( id, p->RcvWaitQue );
	}
}

/* End of file */
