/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_mutex.c
 *
 *	@brief	Windows iTRONT[rXR[ (~[ebNX).
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include "wi_mutex.h"

/****************************************************************************
 *
 * [Jϐ`.
 *
 ****************************************************************************/
static WIHDR	*ObjList;			//!< ~[ebNXXg̃|C^.

/****************************************************************************/
/*!
 *	@brief	~[ebNX̏.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_InitMutex( void )
{
	ObjList = NULL;
}

/****************************************************************************/
/*!
 *	@brief	~[ebNX̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_QuitMutex( void )
{
	WIHDR		*next_ptr;
	WIMTXOBJ	*p = (WIMTXOBJ *)ObjList;

	while( p ){
		next_ptr = p->Hdr.Next;

		//! ~[ebNXIuWFNg\̂.
		SAFE_RELEASE( p );

		//! ̃~[ebNXIuWFNg\̂o.
		p = (WIMTXOBJ *)next_ptr;
	}
}

/****************************************************************************/
/*!
 *	@brief	~[ebNX̐.
 *
 *	@param	[in]	id		~[ebNXIDԍ.
 *	@param	[in]	obj		~[ebNXIuWFNg\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_CreateMutex( INT id, const WIMTXOBJ *obj )
{
	ER			ercd;
	WIMTXOBJ	*p;

	//! ~[ebNXIuWFNg쐬.
	p = (WIMTXOBJ *)wi_CreateObject( id, TMAX_MAXMTX, sizeof(WIMTXOBJ), obj, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgɃ~[ebNXǉ.
	wi_AddObject( (WIHDR *)p, &ObjList );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	~[ebNX̍폜.
 *
 *	@param	[in]	id		~[ebNXIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_DeleteMutex( INT id )
{
	ER			ercd;
	WIMTXOBJ	*p;

	//! ~[ebNXID̃IuWFNg擾.
	p = (WIMTXOBJ *)wi_FindObject( id, TMAX_MAXMTX, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgY~[ebNX菜.
	wi_DelObject( (WIHDR *)p, &ObjList );

	//! ҂^XNL[.
	wi_WakeupDelResource( p->WaitQue );

	//! ~[ebNXIuWFNg\̂.
	SAFE_RELEASE( p );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	~[ebNXbN.
 *
 *	@param	[in]	id		~[ebNXIDԍ.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		wi_LockMutex( INT id, TMO tmout )
{
	INT			tsk_id;
	ER			ercd;
	WIMTXOBJ	*p;

	//! ~[ebNXID̃IuWFNg擾.
	p = (WIMTXOBJ *)wi_FindObject( id, TMAX_MAXMTX, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! ReLXg̃^XNĂяoꂽꍇ̓G[ɂ.
	tsk_id = wi_GetActiveTaskId();
	if( tsk_id == 0 ){
		return E_CTX;
	}
	//! dbN̓G[ɂ.
	if( p->LockId == tsk_id ){
		return E_ILUSE;
	}
	//! ~[ebNXbNĂȂ΁AbNďI.
	if( p->LockId == 0 ){
		p->LockId  = tsk_id;
		return E_OK;
	}
	//! bN܂Ń^XNX[v.
	ercd = wi_TaskWait( id, TTW_MTX, tmout, p->Attribute, &(p->WaitQue) );
	if( ercd == E_OK ){
		p->LockId = tsk_id;
	}
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	~[ebNX̃bN.
 *
 *	@param	[in]	id		~[ebNXIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_UnlockMutex( INT id )
{
	ER			ercd;
	WIMTXOBJ	*p;

	//! ~[ebNXID̃IuWFNg擾.
	p = (WIMTXOBJ *)wi_FindObject( id, TMAX_MAXMTX, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! ~[ebNXbNĂ^XNƈႤꍇ̓G[ɂ.
	if( p->LockId != wi_GetActiveTaskId() ){
		return E_ILUSE;
	}
	p->LockId = 0;

	//! bN҂Ă^XNꍇ̓^XNN.
	if( p->WaitQue ){
		wi_TaskWakeup( p->WaitQue->Id, TTW_MTX, &(p->WaitQue) );
	}
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	~[ebNX̏ԎQ.
 *
 *	@param	[in]	id		~[ebNXIDԍ.
 *	@param	[in]	sts		~[ebNXԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_RefarenceMutex( INT id, WIMTXSTAT *sts )
{
	ER			ercd;
	WIMTXOBJ	*p;

	//! ~[ebNXID̃IuWFNg擾.
	p = (WIMTXOBJ *)wi_FindObject( id, TMAX_MAXMTX, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! ~[ebNX̏Ԃ\̂ɃZbg.
	sts->LockId = p->LockId;
	sts->WaitId = wi_GetWaitTaskListFirstId( p->WaitQue );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	폜^XN҂s񂩂폜.
 *
 *	@param	[in]	id		폜^XNIDԍ.
 *
 *	@retval	Ȃ.
 */
void	wi_AllReleaseMutex( INT id )
{
	WIMTXOBJ *p;

	for( p = (WIMTXOBJ *)ObjList; p; p = (WIMTXOBJ *)p->Hdr.Next ){

		//! 폜^XN҂s񂩂폜.
		p->WaitQue = wi_DelWaitTaskList( id, p->WaitQue );
	}
}

/* End of file */
