/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_task.c
 *
 *	@brief	Windows iTRONT[rXR[ (^XN@\).
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include <process.h>
#include "wi_task.h"
#include "wi_semaphore.h"
#include "wi_event_flag.h"
#include "wi_mail_box.h"
#include "wi_data_queue.h"
#include "wi_mutex.h"
#include "wi_message_buffer.h"
#include "wi_rendezvous_port.h"
#include "wi_fixed_mempool.h"
#include "wi_variable_mempool.h"

/****************************************************************************
 *
 * [J֐`.
 *
 ****************************************************************************/
static unsigned int __stdcall UserTask( void* arg );
static int			ConvertPriority( PRI tskpri );
static WITSKOBJ		*FindTaskObject( INT id, ER *ercd );

/****************************************************************************
 *
 * [Jϐ`.
 *
 ****************************************************************************/
static WIHDR		*ObjList;		//!< ^XNXg̃|C^.

/****************************************************************************/
/*!
 *	@brief	^XNǗ̏.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_InitTask( void )
{
	ObjList = NULL;
}

/****************************************************************************/
/*!
 *	@brief	^XNǗ̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_QuitTask( void )
{
	WITSKOBJ *p = (WITSKOBJ *)ObjList;
	while( p ){
		WIHDR *next_ptr;
		next_ptr = p->Hdr.Next;

		//! Cxgnh.
		if( p->hEvent ){
			CloseHandle( p->hEvent );
		}
		if( p->hThread ){
			//! Xbh~̂mF.
			wi_DormantThread( p->hThread, 10 );

			//! Xbhnh.
			CloseHandle( p->hThread );
		}
		//! ^XNIuWFNg.
		SAFE_RELEASE( p );

		//! ̃^XNIuWFNgo.
		p = (WITSKOBJ *)next_ptr;
	}
}

/****************************************************************************/
/*!
 *	@brief	^XN𐶐.
 *
 *	@param	[in]	id		^XNIDԍ.
 *	@param	[in]	obj		^XNIuWFNg\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER	wi_CreateTask( INT id, const WITSKOBJ *obj )
{
	ER			ercd;
	WITSKOBJ	*p;

	//! ^XNIuWFNg쐬.
	p = (WITSKOBJ *)wi_CreateObject( id, TMAX_MAXTSK, sizeof(WITSKOBJ), obj, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! sȏꍇ̓G[ɂ.
	if( !obj->TaskAdr || obj->InitPri == 0 ){
		return E_PAR;
	}
	//! ^XN̏Ԃux~vɂ.
	p->TaskState = TTS_DMT;

	//! Cxgnh쐬.
	p->hEvent = CreateEvent( NULL, FALSE, FALSE, NULL );
	if( !p->hEvent ){
		SAFE_RELEASE( p );
		return E_SYS;
	}
	//! XgɃ^XNǉ.
	wi_AddObject( (WIHDR *)p, &ObjList );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	[U[^XNN.
 *
 *	@param	[in]	arg		^XNIuWFNg\̂̃|C^.
 *
 *	@retval	0Ԃ.
 */
static unsigned __stdcall UserTask( void* arg )
{
	WITSKOBJ *p = (WITSKOBJ *)arg;
	if( p ){
		//! ^XN̏Ԃusvɂ.
		p->TaskState = TTS_RUN;

		//! [U[^XNĂяo.
		p->TaskAdr( p->StartCode );

		//! ^XN̏Ԃux~vɂ.
		p->TaskState = TTS_DMT;
	}
	_endthreadex( 0 );
	return 0;
}

/****************************************************************************/
/*!
 *	@brief	^XN̍폜.
 *
 *	@param	[in]	id		^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_DeleteTask( INT id )
{
	WITSKOBJ	*p      = (WITSKOBJ *)ObjList;
	WIHDR		**b_ptr = &ObjList;

	//! ^XN͍폜łȂ.
	if( id == TSK_SELF ){
		return E_OBJ;
	}
	//! sȃ^XNID̏ꍇ̓G[ɂ.
	if( id >= TMAX_MAXTSK ){
		return E_ID;
	}
	while( p ){
		//! w肳ꂽIDƈv^XNꍇA^XNN[Y.
		if( p->Hdr.Id == id ){

			//! Xbhx~ԂłȂꍇ͍폜Ȃ.
			if( p->TaskState != TTS_DMT ){
				return E_OBJ;
			}
			//! XgY^XN菜.
			*b_ptr = (WIHDR *)(p->Hdr.Next);

			if( p->hThread ){
				//! Xbh~Ă邱ƂmF.
				wi_DormantThread( p->hThread, 10 );

				//! Xbhnh.
				CloseHandle( p->hThread );
				 p->hThread = NULL;
			}
			//! Cxgnh.
			if( p->hEvent ){
				CloseHandle( p->hEvent );
				p->hEvent = NULL;
			}
			//! ҂s񂩂^XN폜.
			wi_AllReleaseSemaphore( id );
			wi_AllReleaseEvFlag( id );
			wi_AllReleaseMailBox( id );
			wi_AllReleaseDataQueue( id );
			wi_AllReleaseMutex( id );
			wi_AllReleaseMsgBuffer( id );
			wi_AllReleaseRendPort( id );

			//! v[lubNԋp.
			wi_AllReleaseFixedMemPool( id );
			wi_AllReleaseVarMemPool( id );

			//! ^XN\̂.
			SAFE_RELEASE( p );
			return E_OK;
		}
		//! Xg玟̃^XNo.
		b_ptr = &(p->Hdr.Next);
		p     = (WITSKOBJ *)(p->Hdr.Next);
	}
	return E_NOEXS;
}

/****************************************************************************/
/*!
 *	@brief	^XN̋N.
 *
 *	@param	[in]	id			^XNIDԍ.
 *	@param	[in]	start_code	^XNNR[h.
 *	@param	[in]	exist_stcd	TRUE = ^XNNR[h.
 *
 *	@retval	G[R[h.
 */
ER		wi_StartTask( INT id, DWORD start_code, BOOL exist_stcd )
{
	WITSKOBJ *p;

	//! ^XNID̃IuWFNg擾.
	p = wi_GetTaskObject( id );
	if( !p ){
		return E_ID;
	}
	if( p->hThread ){
		//! XbhIĂ邩ǂ𒲂ׂ.
		DWORD code;
		if( !GetExitCodeThread( p->hThread, &code ) ){
			return E_SYS;
		}
		//! XbhN̏ꍇ.
		if( code == STILL_ACTIVE ){
			if( !exist_stcd ){
				//! act_tsk(),iact_tsk()̌Ăяȍꍇ͋Nv񐔂JEgAbv.
				if( p->ActiveCnt + 1 > TMAX_ACTCNT ){
					return E_QOVR;
				}
				//! Nv񐔂JEgAbv.
				p->ActiveCnt++;
				return E_OK;
			}else{
				//! sta_tsk()̌Ăяȍꍇ̓G[ɂ.
				return E_OBJ;
			}
		}
		//! x~̃Xbh̃XbhnhN[Y.
		CloseHandle( p->hThread );
		p->hThread = NULL;
	}
	p->SuspendCnt = 0;
	p->WakeupCnt  = 0;
	p->ActiveCnt  = 0;

	if( exist_stcd ){
		//! sta_tsk()̌Ăяȍꍇ͈̋NR[hgp.
		p->StartCode = start_code;
	}else{
		//! act_tsk(),iact_tsk()̌Ăяȍꍇcre_tsk()̊gNR[hƂ.
		p->StartCode = (DWORD)p->ExtInfo;
	}

	//! ^XN̏Ԃus\ԁvɂ.
	p->TaskState = TTS_RDY;

	//! Xbhx~ԂŋN.
	p->hThread = (HANDLE)_beginthreadex( NULL, 0, &UserTask, p, CREATE_SUSPENDED, &(p->ThreadId) );

	//! Xbh̗Dxݒ肷.
	SetThreadPriority( p->hThread, ConvertPriority( p->InitPri ) );

	//! Xbh̋x~Ԃ.
	if( ResumeThread( p->hThread ) == -1 ){
		return E_SYS;
	}
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	^XNNṽLZ.
 *
 *	@param	[in]	id		^XNIDԍ.
 *
 *	@retval	L[COĂNv񐔂܂̓G[R[h.
 */
int		wi_CancelStartReq( INT id )
{
	int			cnt;
	ER			ercd;
	WITSKOBJ	*p;

	//! ^XNID̃IuWFNg擾.
	p = FindTaskObject( id, &ercd );
	if( !p ){
		return ercd;
	}
	//! Nv񐔂o.
	cnt = p->ActiveCnt;

	//! Nv񐔂NA.
	p->ActiveCnt = 0;

	return cnt;
}

/****************************************************************************/
/*!
 *	@brief	^XN̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_ExitTask( void )
{
	WITSKOBJ *p;

	wi_CommonLock();

	//! ^XÑ^XNIuWFNg擾.
	p = wi_GetTaskObject( TSK_SELF );
	if( p ){
		p->TaskState = TTS_DMT;
	}
	wi_CommonUnlock();

	_endthreadex( 0 );
}

/****************************************************************************/
/*!
 *	@brief	^XN̏Iƍ폜.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_ExpendTask( void )
{
	WITSKOBJ *p;

	wi_CommonLock();

	//! ^XÑ^XNIuWFNg擾.
	p = wi_GetTaskObject( TSK_SELF );
	if( p ){
		p->TaskState = TTS_DMT;
		p->Hdr.Id    = -1;

		//! 폜}[N̕t^XNVXeǗ^XNoRō폜.
		wi_DeleteTaskReq( p->Hdr.Id );
	}
	wi_CommonUnlock();

	_endthreadex( 0 );
}

/****************************************************************************/
/*!
 *	@brief	^XN̋I.
 *
 *	@param	[in]	id		^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_TermTask( INT id )
{
	ER			ercd;
	WITSKOBJ	*p;

	//! ^XNID̃IuWFNg擾.
	p = FindTaskObject( id, &ercd );
	if( !p ){
		return ercd;
	}
	//! XbhI.
	if( p->hThread ){
		TerminateThread( p->hThread, 0 );
	}
	p->TaskState = TTS_DMT;

	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	^XNDx̕ύX.
 *
 *	@param	[in]	id			^XNIDԍ.
 *	@param	[in]	priority	^XNDx.
 *
 *	@retval	G[R[h.
 */
ER		wi_ChangeTaskPriority( INT id, PRI priority )
{
	int			curpri,newpri;
	ER			ercd;
	WITSKOBJ	*p;

	//! ^XNID̃IuWFNg擾.
	p = FindTaskObject( id, &ercd );
	if( !p ){
		return ercd;
	}
	if( !p->hThread ){
		return E_OBJ;
	}
	//! sȃ^XNDx̏ꍇ̓G[ɂ.
	if( priority == 0 ){
		return E_PAR;
	}
	p->TaskPri = priority;

	//! ݂̃Xbh̑ΗD揇ʒl擾.
	curpri = GetThreadPriority( p->hThread );

	//! ύX^XNDxXbh̑ΗD揇ʒlɕϊ.
	newpri = ConvertPriority( priority );

	//! Xbh̑ΗD揇ʒlύXꍇAXbh̃vCIeBύX.
	if( curpri != newpri ){
		SetThreadPriority( p->hThread, newpri );
	}
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	^XNDx̎Q.
 *
 *	@param	[in]	id			^XNIDԍ.
 *	@param	[in]	priority	݂̃^XNDxi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_RefarenceTaskPriority( INT id, PRI *priority )
{
	ER			ercd;
	WITSKOBJ	*p;

	//! ^XNID̃IuWFNg擾.
	p = FindTaskObject( id, &ercd );
	if( !p ){
		return ercd;
	}
	//! sȏꍇ̓G[ɂ.
	if( !priority ){
		return E_PAR;
	}
	//! ^XN̗Dx߂lɃZbg.
	*priority = p->TaskPri;

	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	^XN̏ԎQ.
 *
 *	@param	[in]	id		^XNIDԍ.
 *	@param	[in]	sts		^XNԂi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_RefarenceTask( INT id, WITSKSTAT *sts )
{
	ER			ercd;
	WITSKOBJ	*p;

	//! ^XNID̃IuWFNg擾.
	p = FindTaskObject( id, &ercd );
	if( !p ){
		return ercd;
	}
	//! ^XN̏Ԃ\̂ɃZbg.
	sts->ExtInfo    = p->ExtInfo;
	sts->TaskPri    = p->TaskPri;
	sts->TaskState  = p->TaskState;
	sts->EventType  = p->EventType;
	sts->WaitId     = p->WaitId;
	sts->WakeupCnt  = p->WakeupCnt;
	sts->SuspendCnt = p->SuspendCnt;
	sts->TaskAtr    = p->TaskAtr;
	sts->TaskAdr    = p->TaskAdr;
	sts->InitPri    = p->InitPri;
	sts->StackSize  = p->StackSize;
	sts->ActiveCnt  = p->ActiveCnt;
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	N҂.
 *
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		wi_SleepTask( TMO tmout )
{
	ER			ercd;
	WITSKOBJ	*p;

	//! ^XÑ^XNIuWFNg擾.
	p = FindTaskObject( TSK_SELF, &ercd );
	if( !p ){
		return E_OBJ;
	}
	if( !p->hThread ){
		return E_OBJ;
	}
	//! NvJE^܂Ăꍇ̓Cxg҂ȂŐIɂ.
	if( p->WakeupCnt > 0 ){
		p->WakeupCnt--;
		return E_OK;
	}
	//! Cxg҂.
	return wi_TaskWait( p->Hdr.Id, TTW_SLP, tmout, 0, NULL );
}

/****************************************************************************/
/*!
 *	@brief	^XN̋N.
 *
 *	@param	[in]	id		^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_WakeupTask( INT id )
{
	ER ercd;

	//! w肳ꂽ^XNɑ΂ăCxg𔭍s.
	ercd = wi_TaskWakeup( id, TTW_SLP, NULL );

	//! w肳ꂽ^XNslp_tsk()ŃCxg҂ĂȂꍇ͋NvJE^+1.
	if( ercd == E_OACV ){
		WITSKOBJ *p = wi_GetTaskObject( id );
		if( p ){
			p->WakeupCnt++;
		}
	}
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	^XN̋Nv𖳌.
 *
 *	@param	[in]	id			^XNIDԍ.
 *	@param	[in]	p_wupcnt	L[COĂNv񐔂i[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_CancelWakeup( INT id, INT *p_wupcnt )
{
	ER			ercd;
	WITSKOBJ	*p;

	//! ^XNID̃IuWFNg擾.
	p = FindTaskObject( id, &ercd );
	if( !p ){
		return ercd;
	}
	if( !p->hThread ){
		return E_OBJ;
	}
	//! Nv񐔂߂lɊi[.
	if( p_wupcnt ){
		*p_wupcnt = p->WakeupCnt;
	}
	//! ^XN̋Nv񐔂NA.
	p->WakeupCnt = 0;

	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	҂Ԃ̋.
 *
 *	@param	[in]	id		^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_ReleaseWait( INT id )
{
	ER			ercd;
	WITSKOBJ	*p;

	//! ^XNw肳ꂽꍇ̓G[ɂ.
	if( id == TSK_SELF ){
		return E_OBJ;
	}
	//! ^XNID̃IuWFNg擾.
	p = FindTaskObject( id, &ercd );
	if( !p ){
		return ercd;
	}
	if( !p->hThread ){
		return E_OBJ;
	}
	//! Cxg҂ĂȂꍇ̓G[ɂ.
	if( p->EventType == 0 ){
		return E_OBJ;
	}
	//! ҂Ԃ̋tOZbgăCxg𔭍s.
	p->RelRes = TRUE;
	if( !SetEvent( p->hEvent ) ){
		return E_SYS;
	}
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	҂Ԃւ̈ڍs.
 *
 *	@param	[in]	id		^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_SuspendTask( INT id )
{
	DWORD		cnt;
	ER			ercd;
	WITSKOBJ	*p;

	//! ^XNID̃IuWFNg擾.
	p = FindTaskObject( id, &ercd );
	if( !p ){
		return ercd;
	}
	if( !p->hThread ){
		return E_OBJ;
	}
	//! Xbh̎s𒆒f.
	cnt = SuspendThread( p->hThread );
	if( cnt == -1 ){
		return E_SYS;
	}
	p->TaskState = TTS_SUS;

	//! Xbh̒fJE^+1.
	p->SuspendCnt = cnt + 1;

	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	҂Ԃ̍ĊJ.
 *
 *	@param	[in]	id		^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_ResumeTask( INT id )
{
	DWORD		cnt;
	ER			ercd;
	WITSKOBJ	*p;

	//! ^XNID̃IuWFNg擾.
	p = FindTaskObject( id, &ercd );
	if( !p ){
		return ercd;
	}
	if( !p->hThread ){
		return E_OBJ;
	}
	//! Xbh̎sĊJ.
	cnt = ResumeThread( p->hThread );
	if( cnt == -1 ){
		return E_SYS;
	}
	//! XbhĊJƂɃXe[^Xu^XNsvɖ߂.
	if( cnt == 1 ){
		if( p->EventType == 0 ){
			p->TaskState = TTS_RUN;
		}else{
			p->TaskState = TTS_WAI;
		}
	}
	//! XbhfĂȂꍇ̓G[ɂ.
	if( cnt == 0 ){
		p->SuspendCnt = 0;
		return E_OBJ;
	}
	//! Xbh̒fJE^-1.
	p->SuspendCnt = cnt - 1;
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	҂Ԃ̋ĊJ.
 *
 *	@param	[in]	id		^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_ForceResumeTask( INT id )
{
	DWORD		cnt;
	ER			ercd;
	WITSKOBJ	*p;

	//! ^XNID̃IuWFNg擾.
	p = FindTaskObject( id, &ercd );
	if( !p ){
		return ercd;
	}
	if( !p->hThread ){
		return E_OBJ;
	}
	//! Xbh̃W[Ԃ܂ŌJԂ.
	do {
		cnt = ResumeThread( p->hThread );
	} while( cnt > 1 );

	if( cnt == -1 ){
		return E_SYS;
	}
	//! XbhĊJƂɃXe[^Xu^XNsvɖ߂.
	if( p->EventType == 0 ){
		p->TaskState = TTS_RUN;
	}else{
		p->TaskState = TTS_WAI;
	}
	//! Xbh̒fJE^NA.
	p->SuspendCnt = 0;
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	^XN̒x.
 *
 *	@param	[in]	dlytim	x.
 *
 *	@retval	G[R[h.
 */
ER		wi_DelayTask( TMO dlytim )
{
	ER			ercd;
	WITSKOBJ	*p;

	//! sȏꍇ̓G[ɂ.
	if( dlytim == TMO_FEVR ){
		return E_PAR;
	}
	//! ^XÑ^XNIuWFNg擾.
	p = FindTaskObject( TSK_SELF, &ercd );
	if( !p || !p->hThread ){
		return E_CTX;
	}
	//! Cxg҂Ń^CAEg.
	ercd = wi_TaskWait( p->Hdr.Id, TTW_DLY, dlytim, 0, NULL );
	if( ercd == E_TMOUT ){
		ercd  = E_OK;
	}
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	w肳ꂽ^XNID̃IuWFNgo.
 *
 *	@param	[in]	id		^XNIDԍ.
 *
 *	@retval	^XNIuWFNg\̂̃|C^.
 */
WITSKOBJ	*wi_GetTaskObject( INT id )
{
	//! ^XÑIuWFNg擾.
	if( id == TSK_SELF ){
		DWORD		tid = GetCurrentThreadId();
		WITSKOBJ	*p  = (WITSKOBJ *)ObjList;
		while( p ){
			if( p->ThreadId == tid ){
				return p;
			}
			p = (WITSKOBJ *)(p->Hdr.Next);
		}
		return NULL;
	}
	//! w肳ꂽ^XNID̃IuWFNg擾.
	return (WITSKOBJ *)wi_GetObject( id, ObjList );
}

/****************************************************************************/
/*!
 *	@brief	w肳ꂽ^XNID̃IuWFNgo.
 *
 *	@param	[in]	id		^XNIDԍ.
 *	@param	[in]	ercd	G[R[hi[̈̃|C^.
 *
 *	@retval	^XNIuWFNg\̂̃|C^.
 */
static WITSKOBJ	*FindTaskObject( INT id, ER *ercd )
{
	WITSKOBJ *p;

	//! ^XNID̃IuWFNg擾.
	p = wi_GetTaskObject( id );
	if( !p ){
		*ercd = (id == TSK_SELF || id >= TMAX_MAXTSK) ? E_ID : E_NOEXS;
		return NULL;
	}
	*ercd = E_OK;
	return p;
}

/****************************************************************************/
/*!
 *	@brief	^XNDxWindowsXbh̑ΗD揇ʒlɕύX.
 *
 *	@param	[in]	tskpri	^XNDx.
 *
 *	@retval	Xbh̑ΗD揇ʒl.
 */
static int		ConvertPriority( PRI tskpri )
{
	if( tskpri < 10 ){
		return THREAD_PRIORITY_ABOVE_NORMAL;
	}else
	if( tskpri < 50 ){
		return THREAD_PRIORITY_NORMAL;
	}else
	if( tskpri < 100 ){
		return THREAD_PRIORITY_BELOW_NORMAL;
	}
	return THREAD_PRIORITY_LOWEST;
}

/****************************************************************************/
/*!
 *	@brief	^XÑ^XNID擾.
 *
 *	@param	Ȃ.
 *
 *	@retval	^XÑ^XNID.
 */
DWORD	wi_GetActiveTaskId( void )
{
	DWORD		tid = GetCurrentThreadId();
	WITSKOBJ	*p  = (WITSKOBJ *)ObjList;
	while( p ){
		if( p->ThreadId == tid ){
			return p->Hdr.Id;
		}
		p = (WITSKOBJ *)(p->Hdr.Next);
	}
	return 0;
}

/****************************************************************************/
/*!
 *	@brief	^XNCxg҂ɂ.
 *
 *	@param	[in]	wid		҂IuWFNgID.
 *	@param	[in]	type	Cxg.
 *	@param	[in]	tmout	^CAEgݒ.
 *	@param	[in]	pri		IuWFNg̑.
 *	@param	[out]	que		҂s̐擪̃^XNIuWFNg̃|C^̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_TaskWait( INT wid, INT type, TMO tmout, ATR pri, WIHDR **que )
{
	DWORD		ret_code;
	ER			ercd;
	WITSKOBJ	*tsk;

	//! |[Ȍꍇ̓^CAEgŏI.
	if( tmout == TMO_POL ){
		return E_TMOUT;
	}
	//! ^XÑ^XNIuWFNg擾.
	tsk = FindTaskObject( TSK_SELF, &ercd );
	if( !tsk ){
		return E_CTX;
	}
	//! Cxgnh쐬ĂȂꍇ̓G[ɂ.
	if( !tsk->hEvent ){
		return E_NOEXS;
	}
	//! ̃IuWFNgCxg҂Ăꍇ͏Iɂ.
	if( tsk->EventType != 0 ){
		return E_OACV;
	}
	//! Cxgnhugpvɂ.
	tsk->EventType = type;
	tsk->WaitId    = wid;
	tsk->QueLink   = NULL;
	tsk->TaskState = TTS_WAI;

	//! ^XN҂sɒǉ.
	if( que ){
		*que = wi_AddWaitTaskList( TSK_SELF, pri, *que );
	}
	//! ~[ebNXU.
	wi_CommonUnlock();

	//! Cxg̔҂.
	ret_code = WaitForSingleObject( tsk->hEvent, wi_CvtTimeOutValue( tmout ) );

	//! ēx~[ebNX|.
	wi_CommonLock();

	//! ^XN҂s񂩂폜.
	if( que ){
		*que = wi_DelWaitTaskList( TSK_SELF, *que );
	}
	//! Cxgnhugpvɖ߂.
	tsk->EventType = 0;
	tsk->WaitId    = 0;
	tsk->QueLink   = NULL;
	tsk->TaskState = TTS_RUN;

	switch( ret_code ){
	case WAIT_OBJECT_0:
		if( tsk->DelRes ){
			ercd = E_DLT;
		}else
		if( tsk->RelRes ){
			ercd = E_RLWAI;
		}else{
			ercd = E_OK;
		}
		break;

	case WAIT_TIMEOUT:
		ercd = E_TMOUT;
		break;

	default:
		ercd = E_SYS;
		break;
	}
	tsk->DelRes = FALSE;
	tsk->RelRes = FALSE;
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Cxg҂Ă^XNN.
 *
 *	@param	[in]	id		^XNIDԍ.
 *	@param	[in]	type	Cxg.
 *	@param	[out]	que		҂s̐擪̃^XNIuWFNg̃|C^̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_TaskWakeup( INT id, INT type, WIHDR **que )
{
	ER			ercd;
	WITSKOBJ	*tsk;

	//! ^XNID̃IuWFNg擾.
	tsk = FindTaskObject( id, &ercd );
	if( !tsk ){
		return ercd;
	}
	//! Cxgnh쐬ĂȂꍇ̓G[ɂ.
	if( !tsk->hEvent ){
		return E_NOEXS;
	}
	//! Cxg҂ĂȂꍇ̓G[ɂ.
	if( tsk->EventType == 0 ){
		return E_OACV;
	}
	//! ^XNx~̏ꍇ̓G[ɂ.
	if( tsk->TaskState == TTS_DMT ){
		return E_OBJ;
	}
	//! ̃IuWFNgCxg҂Ăꍇ̓G[ɂ.
	if( tsk->EventType != type ){
		return E_OACV;
	}
	//! Cxg𔭍s.
	if( !SetEvent( tsk->hEvent ) ){
		return E_SYS;
	}
	//! N^XN҂s񂩂폜.
	if( que ){
		*que = wi_DelWaitTaskList( id, *que );
	}
	//! Cxgnhugpvɖ߂.
	tsk->EventType = 0;
	tsk->WaitId    = 0;
	tsk->QueLink   = NULL;

	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	҂sɃ^XNǉ.
 *
 *	@param	[in]	id		^XNIDԍ.
 *	@param	[in]	pri		IuWFNg̑.
 *	@param	[in]	que		҂s̐擪̃^XNIuWFNg̃|C^.
 *
 *	@retval	҂s̐擪̃^XNIuWFNg̃|C^.
 */
WIHDR	*wi_AddWaitTaskList( INT id, ATR pri, WIHDR *que )
{
	ER			ercd;
	WITSKOBJ	*add_tsk,*que_tsk;

	//! w肳ꂽ^XÑ^XNIuWFNg擾.
	add_tsk = FindTaskObject( id, &ercd );
	if( !add_tsk ){
		return que;
	}
	//! ҂sɃ^XNȂꍇ́Ã^XN҂s̐擪ɂ.
	if( !que ){
		return (WIHDR *)add_tsk;
	}
	if( pri & TA_TPRI ){
		/*!
		 * ҂s̐擪^XNw肳ꂽ^XN̕Dxꍇ
		 * w肳ꂽ^XN҂s̐擪ɂ.
		 */
		que_tsk = (WITSKOBJ *)que;
		if( que_tsk->TaskPri > add_tsk->TaskPri ){
			add_tsk->QueLink = que_tsk;
			return (WIHDR *)add_tsk;
		}
		/*!
		 * ҂s񒆂̃^XN̗Dxw肳ꂽ^XN̗DxȂƂ
		 * w肳ꂽ^XN}.
		 */
		while( que_tsk->QueLink ){
			if( que_tsk->QueLink->TaskPri > add_tsk->TaskPri ){
				add_tsk->QueLink = que_tsk->QueLink;
				break;
			}
			que_tsk = que_tsk->QueLink;
		}
		que_tsk->QueLink = add_tsk;
	}else{
		//! FIFȌꍇA҂s̍ŌɃ^XNǉ.
		que_tsk = (WITSKOBJ *)que;
		while( que_tsk->QueLink ){
			que_tsk = que_tsk->QueLink;
		}
		que_tsk->QueLink = add_tsk;
	}
	return que;
}

/****************************************************************************/
/*!
 *	@brief	҂s񂩂^XN폜.
 *
 *	@param	[in]	id		^XNIDԍ.
 *	@param	[in]	que		҂s̐擪̃^XNIuWFNg̃|C^.
 *
 *	@retval	҂s̐擪̃^XNIuWFNg̃|C^.
 */
WIHDR	*wi_DelWaitTaskList( INT id, WIHDR *que )
{
	ER			ercd;
	WITSKOBJ	*del_tsk,*que_tsk;

	//! ҂sɃ^XNȂꍇȂ.
	if( !que ){
		return NULL;
	}
	//! ^XNIuWFNg擾.
	del_tsk = FindTaskObject( id, &ercd );
	if( !del_tsk ){
		return que;
	}
	/*!
	 * ҂s̐擪w肳ꂽ^XN̏ꍇ͑҂s̐擪^XN폜.
	 * (߂l͎̃^XNIuWFNg̃|C^ƂȂ.)
	 */
	que_tsk = (WITSKOBJ *)que;
	if( que_tsk->Hdr.Id == del_tsk->Hdr.Id ){
		WIHDR *wk        = (WIHDR *)del_tsk->QueLink;
		del_tsk->QueLink = NULL;
		return wk;
	}
	/*!
	 * ҂s񂩂w肳ꂽ^XN폜.
	 * (҂s̐擪̃^XN͕ςȂ.)
	 */
	while( que_tsk->QueLink ){
		if( que_tsk->QueLink->Hdr.Id == del_tsk->Hdr.Id ){
			que_tsk->QueLink = del_tsk->QueLink;
			del_tsk->QueLink = NULL;
			break;
		}
		que_tsk = que_tsk->QueLink;
	}
	return que;
}

/****************************************************************************/
/*!
 *	@brief	҂s̐擪̃^XNIDԍ擾.
 *
 *	@param	[in]	que		҂s̐擪̃^XNIuWFNg̃|C^.
 *
 *	@retval	҂s̐擪̃^XNIDԍ.
 */
DWORD	wi_GetWaitTaskListFirstId( WIHDR *que )
{
	//! ҂sɃ^XNȂꍇȂ.
	if( !que ){
		return 0;
	}
	//! ҂s̐擪̃^XÑ^XNIDԍԂ.
	return que->Id;
}

/****************************************************************************/
/*!
 *	@brief	\[X폜Ƃɑ҂sɂ^XN.
 *
 *	@param	[in]	que		҂s̐擪̃^XNIuWFNg̃|C^.
 *
 *	@retval	Ȃ.
 */
void	wi_WakeupDelResource( WIHDR *que )
{
	WITSKOBJ *p;

	p = (WITSKOBJ *)que;
	while( p ){
		//! Cxgnhugpvɖ߂.
		p->EventType = 0;
		p->WaitId    = 0;
		if( p->hThread && p->hEvent ){
			//! \[X폜邱ƂtOZbgăCxg𔭍s.
			p->DelRes = TRUE;
			SetEvent( p->hEvent );
		}
		//! ҂s񂩂玟̃^XNIuWFNgo.
		p = p->QueLink;

		//! ҂L[^XN폜.
		p->QueLink = NULL;
	}
}

/* End of file */
