/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	win_itron4.c
 *
 *	@brief	iTRON(Ver4.0)̃T[rXR[.
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <stdio.h>
#include "kprintf.h"
#include "wi_config.h"

#ifdef	__ITRON4__
#include "win_itron4.h"
#include "wi_task.h"
#include "wi_semaphore.h"
#include "wi_event_flag.h"
#include "wi_data_queue.h"
#include "wi_mail_box.h"
#include "wi_mutex.h"
#include "wi_message_buffer.h"
#include "wi_rendezvous_port.h"
#include "wi_fixed_mempool.h"
#include "wi_variable_mempool.h"
#include "wi_cycle_handler.h"
#include "wi_alarm_handler.h"
#include "wi_systemmgr.h"
#include "wi_interrupt.h"

/***************************************
 *
 * ^XNǗ@\.
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	^XN̐.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *	@param	[in]	pk_ctsk	^XN\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_tsk( ID tskid, const T_CTSK *pk_ctsk )
{
	ER			ercd;
	WITSKOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_ctsk ){
		return E_PAR;
	}
	//! ^XNRs[.
	memset( &obj, 0, sizeof(WITSKOBJ) );
	obj.TaskAtr   = pk_ctsk->tskatr;
	obj.TaskAdr   = pk_ctsk->task;
	obj.TaskPri   = pk_ctsk->itskpri;
	obj.InitPri   = pk_ctsk->itskpri;
	obj.StackSize = pk_ctsk->stksz;
	obj.ExtInfo   = pk_ctsk->exinf;

	wi_CommonLock();

	//! ^XN𐶐.
	ercd = wi_CreateTask( (DWORD)tskid, &obj );

	//! TA_ACTݒ肳Ăꍇ̓^XNN.
	if( ercd == E_OK && (pk_ctsk->tskatr & TA_ACT) != 0 ){
		wi_StartTask( (DWORD)tskid, 0, FALSE );
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̐ (IDԍt).
 *
 *	@param	[in]	pk_ctsk	^XN\̂̃|C^.
 *
 *	@retval	^XÑ^XNID܂̓G[R[h.
 */
ER_ID	acre_tsk( const T_CTSK *pk_ctsk )
{
	ER_ID		ercd;
	DWORD		tskid;
	WITSKOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_ctsk ){
		return E_PAR;
	}
	//! ^XNRs[.
	memset( &obj, 0, sizeof(WITSKOBJ) );
	obj.TaskAtr   = pk_ctsk->tskatr;
	obj.TaskAdr   = pk_ctsk->task;
	obj.TaskPri   = pk_ctsk->itskpri;
	obj.InitPri   = pk_ctsk->itskpri;
	obj.StackSize = pk_ctsk->stksz;
	obj.ExtInfo   = pk_ctsk->exinf;

	wi_CommonLock();
	for( tskid = 1; tskid < TMAX_MAXTSK; tskid++ ){

		//! ^XN𐶐.
		ercd = wi_CreateTask( tskid, &obj );
		if( ercd == E_OK ){

			//! ߂l𐶐^XNIDԍɂ.
			ercd = (ER_ID)tskid;

			//! TA_ACTݒ肳Ăꍇ̓^XNN.
			if( (pk_ctsk->tskatr & TA_ACT) != 0 ){
				wi_StartTask( tskid, 0, FALSE );
			}
			break;
		}
	}
	if( ercd == E_OBJ ){
		ercd = E_NOID;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̍폜.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_tsk( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ^XN폜.
	ercd = wi_DeleteTask( tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̋N.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		act_tsk( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ^XNN.
	ercd = wi_StartTask( tskid, 0, FALSE );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̋N (^XNReLXǧďop).
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		iact_tsk( ID tskid )
{
	return act_tsk( tskid );
}

/****************************************************************************/
/*!
 *	@brief	^XNNṽLZ.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER_UINT		can_act( ID tskid )
{
	ER_UINT ercd;

	wi_CommonLock();

	//! ^XN̋NvLZ.
	ercd = (ER_UINT)wi_CancelStartReq( tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̋N.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *	@param	[in]	stacd	^XNNR[h.
 *
 *	@retval	G[R[h.
 */
ER		sta_tsk( ID tskid, VP_INT stacd )
{
	ER ercd;

	wi_CommonLock();

	//! ^XNN.
	ercd = wi_StartTask( tskid, (DWORD)stacd, TRUE );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	ext_tsk( void )
{
	//! ^XNI.
	wi_ExitTask();
}

/****************************************************************************/
/*!
 *	@brief	^XN̏Iƍ폜.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	exd_tsk( void )
{
	//! ^XNIăReLXg폜.
	wi_ExpendTask();
}

/****************************************************************************/
/*!
 *	@brief	^XN̋I.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		ter_tsk( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ^XNI.
	ercd = wi_TermTask( tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XNDx̕ύX.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *	@param	[in]	tskpri	^XNDx.
 *
 *	@retval	G[R[h.
 */
ER		chg_pri( ID tskid, PRI tskpri )
{
	ER ercd;

	wi_CommonLock();

	//! ^XN̗DxύX.
	ercd = wi_ChangeTaskPriority( tskid, tskpri );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XNDx̎Q.
 *
 *	@param	[in]	tskid		^XNIDԍ.
 *	@param	[out]	p_tskpri	݂̃^XNDxi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		get_pri( ID tskid, PRI *p_tskpri )
{
	ER ercd;

	wi_CommonLock();

	//! ^XN̗Dx擾.
	ercd = wi_RefarenceTaskPriority( tskid, p_tskpri );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̏ԎQ.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *	@param	[out]	pk_rtsk	^XNԂi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_tsk( ID tskid, T_RTSK *pk_rtsk )
{
	ER			ercd;
	WITSKSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rtsk ){
		return E_PAR;
	}
	wi_CommonLock();

	//! 擾^XN̗̂߂lƂč\̂ɃZbg.
	ercd = wi_RefarenceTask( tskid, &sts );
	if( ercd == E_OK ){
		pk_rtsk->tskstat = sts.TaskState;
		pk_rtsk->tskpri  = sts.TaskPri;
		pk_rtsk->tskbpri = sts.TaskPri;
		pk_rtsk->tskwait = sts.EventType;
		pk_rtsk->wobjid  = sts.WaitId;
		pk_rtsk->lefttmo = 0;
		pk_rtsk->actcnt  = sts.ActiveCnt;
		pk_rtsk->wupcnt  = sts.WakeupCnt;
		pk_rtsk->suscnt  = sts.SuspendCnt;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̏ԎQ (ȈՔ).
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *	@param	[out]	pk_rtst	^XNԂi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_tst( ID tskid, T_RTST *pk_rtst )
{
	ER			ercd;
	WITSKSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rtst ){
		return E_PAR;
	}
	wi_CommonLock();

	//! ^XN̏ԂȈՎQƂ.
	ercd = wi_RefarenceTask( tskid, &sts );

	//! 擾^XN̗̂߂lƂč\̂ɃZbg.
	if( ercd == E_OK ){
		pk_rtst->tskstat = sts.TaskState;
		pk_rtst->tskwait = sts.WaitId;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * ^XNt@\.
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	N҂(^CAEgȂ).
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		slp_tsk( void )
{
	//! ^CAEgȂŃ^XNN҂ɂ.
	return tslp_tsk( TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	N҂(^CAEg).
 *
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		tslp_tsk( TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! ^XNN҂ɂ.
	ercd = wi_SleepTask( tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̋N.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wup_tsk( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ^XNN.
	ercd = wi_WakeupTask( tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̋N (^XNReLXǧďop).
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		iwup_tsk( ID tskid )
{
	return wup_tsk( tskid );
}

/****************************************************************************/
/*!
 *	@brief	^XN̋Nv𖳌.
 *
 *	@param	[in]	tskid		^XNIDԍ.
 *
 *	@retval	L[COĂNv񐔂܂̓G[R[h.
 */
ER_UINT		can_wup( ID tskid )
{
	ER	ercd;
	INT	wupcnt;

	wi_CommonLock();

	//! ^XNւ̋NvNA.
	ercd = wi_CancelWakeup( tskid, &wupcnt );
	if( ercd == E_OK ){
		ercd = wupcnt;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	҂Ԃ̋.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		rel_wai( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ^XN̑҂ԂIɉ.
	ercd = wi_ReleaseWait( tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	҂Ԃ̋ (^XNReLXǧďop).
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		irel_wai( ID tskid )
{
	return rel_wai( tskid );
}

/****************************************************************************/
/*!
 *	@brief	҂Ԃւ̈ڍs.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		sus_tsk( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ^XN𒆒f(҂)ɂ.
	ercd = wi_SuspendTask( tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	҂Ԃ̍ĊJ.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		rsm_tsk( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ^XN҂ԂĊJ.
	ercd = wi_ResumeTask( tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	҂Ԃ̋ĊJ.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		frsm_tsk( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ҂Ă^XNIɍĊJ.
	ercd = wi_ForceResumeTask( tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̒x.
 *
 *	@param	[in]	dlytim	x.
 *
 *	@retval	G[R[h.
 */
ER		dly_tsk( RELTIM dlytim )
{
	ER	ercd;

	wi_CommonLock();

	ercd = wi_DelayTask( (TMO)(dlytim.ltime) );

	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * ^XNO@\.
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	^XNO̒`.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *	@param	[in]	pk_dtex	^XNO`p\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		def_tex( ID tskid, T_DTEX *pk_dtex )
{
	return E_NOSPT;
}

/****************************************************************************/
/*!
 *	@brief	^XNO̗v.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *	@param	[in]	pk_dtex	v^XNO̗Ov.
 *
 *	@retval	G[R[h.
 */
ER		ras_tex( ID tskid, TEXPTN rasptn )
{
	return E_NOSPT;
}

/****************************************************************************/
/*!
 *	@brief	^XNO̗v (^XNReLXǧďop).
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *	@param	[in]	pk_dtex	v^XNO̗Ov.
 *
 *	@retval	G[R[h.
 */
ER		iras_tex( ID tskid, TEXPTN rasptn )
{
	return E_NOSPT;
}

/****************************************************************************/
/*!
 *	@brief	^XNŐ֎~.
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		dis_tex( void )
{
	return E_NOSPT;
}

/****************************************************************************/
/*!
 *	@brief	^XNŐ.
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		ena_tex( void )
{
	return E_NOSPT;
}

/****************************************************************************/
/*!
 *	@brief	^XNO֎~Ԃ̎Q.
 *
 *	@param	Ȃ.
 *
 *	@retval	TRUE = ^XNO֎~ / FALSE = ^XNO.
 */
INT		sns_tex( void )
{
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	^XNȌԎQ.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *	@param	[out]	pk_rtex	^XNOԂi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_tex( ID tskid, T_RTEX *pk_rtex )
{
	return E_NOSPT;
}


/***************************************
 *
 * ʐM@\ (Z}tH).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	Z}tH̐.
 *
 *	@param	[in]	semid	Z}tHIDԍ.
 *	@param	[in]	pk_csem	Z}tH\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_sem( ID semid, const T_CSEM *pk_csem )
{
	ER			ercd;
	WISEMOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_csem ){
		return E_PAR;
	}
	//! Z}tHRs[.
	memset( &obj, 0, sizeof(WISEMOBJ) );
	obj.Attribute = pk_csem->sematr;
	obj.SemCnt    = pk_csem->isemcnt;
	obj.MaxCnt    = pk_csem->maxsem;

	wi_CommonLock();

	//! Z}tH𐶐.
	ercd = wi_CreateSemaphore( semid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̐ (IDԍt).
 *
 *	@param	[in]	pk_csem	Z}tH\̂̃|C^.
 *
 *	@retval	Z}tHIDԍ܂̓G[R[h.
 */
ER_ID	acre_sem( const T_CSEM *pk_csem )
{
	ID			semid;
	ER_ID		ercd;
	WISEMOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_csem ){
		return E_PAR;
	}
	//! Z}tHRs[.
	memset( &obj, 0, sizeof(WISEMOBJ) );
	obj.Attribute = pk_csem->sematr;
	obj.SemCnt    = pk_csem->isemcnt;
	obj.MaxCnt    = pk_csem->maxsem;

	wi_CommonLock();

	for( semid = 1; semid < TMAX_MAXSEM; semid++ ){

		//! Z}tH𐶐.
		ercd = wi_CreateSemaphore( semid, &obj );
		if( ercd == E_OK ){
			ercd  = semid;
			break;
		}
	}
	if( ercd == E_OBJ ){
		ercd  = E_NOID;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̍폜.
 *
 *	@param	[in]	semid	Z}tHIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_sem( ID semid )
{
	ER ercd;

	wi_CommonLock();

	//! Z}tH폜.
	ercd = wi_DeleteSemaphore( semid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̕ԋp.
 *
 *	@param	[in]	semid	Z}tHIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		sig_sem( ID semid )
{
	ER ercd;

	wi_CommonLock();

	//! Z}tH̎ԋp.
	ercd = wi_SignalSemaphore( semid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̕ԋp (^XNReLXǧďop).
 *
 *	@param	[in]	semid	Z}tHIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		isig_sem( ID semid )
{
	//! ^XNReLXgZ}tH̎.
	return sig_sem( semid );
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̊l (^CAEgȂ).
 *
 *	@param	[in]	semid	Z}tHIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wai_sem( ID semid )
{
	//! ^CAEgȂŃZ}tHl.
	return twai_sem( semid, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̊l (|[O).
 *
 *	@param	[in]	semid	Z}tHIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		pol_sem( ID semid )
{
	//! l҂ȂŃZ}tHl.
	return twai_sem( semid, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̊l (^CAEg).
 *
 *	@param	[in]	semid	Z}tHIDԍ.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		twai_sem( ID semid, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! Z}tH̎l.
	ercd = wi_WaitSemaphore( semid, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Z}tHԂ̎Q.
 *
 *	@param	[in]	semid	Z}tHIDԍ.
 *	@param	[out]	pk_rsem	Z}tHԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_sem( ID semid, T_RSEM *pk_rsem )
{
	ER			ercd;
	WISEMSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rsem ){
		return E_PAR;
	}
	wi_CommonLock();

	//! Z}tH̏Ԃ擾.
	ercd = wi_RefarenceSemaphore( semid, &sts );
	if( ercd == E_OK ){
		pk_rsem->wtskid = sts.WaitId;
		pk_rsem->semcnt = sts.SemCnt;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * ʐM@\ (CxgtO).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	CxgtO̐.
 *
 *	@param	[in]	flgid	CxgtOIDԍ.
 *	@param	[in]	pk_cflg	CxgtO\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_flg( ID flgid, const T_CFLG *pk_cflg )
{
	ER			ercd;
	WIFLGOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cflg ){
		return E_PAR;
	}
	//! CxgtORs[.
	memset( &obj, 0, sizeof(WIFLGOBJ) );
	obj.Attribute = pk_cflg->flgatr;
	obj.FlgVal    = (UINT)pk_cflg->iflgptn;

	wi_CommonLock();

	//! CxgtO𐶐.
	ercd = wi_CreateEvFlag( flgid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CxgtO̐ (IDԍt).
 *
 *	@param	[in]	pk_cflg	CxgtO\̂̃|C^.
 *
 *	@retval	CxgtOIDԍ܂̓G[R[h.
 */
ER_ID	acre_flg( const T_CFLG *pk_cflg )
{
	ID			flgid;
	ER_ID		ercd;
	WIFLGOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cflg ){
		return E_PAR;
	}
	//! CxgtORs[.
	memset( &obj, 0, sizeof(WIFLGOBJ) );
	obj.Attribute = pk_cflg->flgatr;
	obj.FlgVal    = (UINT)pk_cflg->iflgptn;

	wi_CommonLock();
	for( flgid = 1; flgid < TMAX_MAXFLG; flgid++ ){

		//! CxgtO𐶐.
		ercd = wi_CreateEvFlag( flgid, &obj );
		if( ercd == E_OK ){
			ercd = (ER_ID)flgid;
			break;
		}
	}
	if( ercd == E_OBJ ){
		ercd  = E_NOID;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CxgtO̍폜.
 *
 *	@param	[in]	flgid	CxgtOIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_flg( ID flgid )
{
	ER ercd;

	wi_CommonLock();

	//! CxgtO폜.
	ercd = wi_DeleteEvFlag( flgid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CxgtÕZbg.
 *
 *	@param	[in]	flgid	CxgtOIDԍ.
 *	@param	[in]	setptn	Zbgrbgp^[.
 *
 *	@retval	G[R[h.
 */
ER		set_flg( ID flgid, FLGPTN setptn )
{
	ER ercd;

	wi_CommonLock();

	//! CxgtOZbg.
	ercd = wi_SetEvFlag( flgid, (UINT)setptn );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CxgtÕZbg (^XNReLXǧďop).
 *
 *	@param	[in]	flgid	CxgtOIDԍ.
 *	@param	[in]	setptn	Zbgrbgp^[.
 *
 *	@retval	G[R[h.
 */
ER		iset_flg( ID flgid, FLGPTN setptn )
{
	//! CxgtOZbg.
	return set_flg( flgid, setptn );
}

/****************************************************************************/
/*!
 *	@brief	CxgtÕNA.
 *
 *	@param	[in]	flgid	CxgtOIDԍ.
 *	@param	[in]	clrptn	NArbgp^[.
 *
 *	@retval	G[R[h.
 */
ER		clr_flg( ID flgid, FLGPTN clrptn )
{
	ER ercd;

	wi_CommonLock();

	//! CxgtONA.
	ercd = wi_ClearEvFlag( flgid, (UINT)clrptn );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CxgtO҂ (^CAEgȂ).
 *
 *	@param	[in]	flgid		CxgtOIDԍ.
 *	@param	[in]	waiptn		҂rbgp^[.
 *	@param	[in]	wfmode		҂[h.
 *	@param	[out]	p_flgptn	҂̃rbgp^[i[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wai_flg( ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn )
{
	//! ^CAEgȂŃCxg҂.
	return twai_flg( flgid, waiptn, wfmode, p_flgptn, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	CxgtO҂ (|[O).
 *
 *	@param	[in]	flgid		CxgtOIDԍ.
 *	@param	[in]	waiptn		҂rbgp^[.
 *	@param	[in]	wfmode		҂[h.
 *	@param	[out]	p_flgptn	҂̃rbgp^[i[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		pol_flg( ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn )
{
	//! CxgĂ邩ǂ𒲂ׂ.
	return twai_flg( flgid, waiptn, wfmode, p_flgptn, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	CxgtO҂ (^CAEg).
 *
 *	@param	[in]	flgid		CxgtOIDԍ.
 *	@param	[in]	waiptn		҂rbgp^[.
 *	@param	[in]	wfmode		҂[h.
 *	@param	[out]	p_flgptn	҂̃rbgp^[i[̈̃|C^.
 *	@param	[in]	tmout		^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		twai_flg( ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! Cxg҂.
	ercd = wi_WaitEvFlag( flgid, p_flgptn, waiptn, wfmode & ~TWF_CLR, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CxgtOԂ̎Q.
 *
 *	@param	[in]	flgid	CxgtOIDԍ.
 *	@param	[out]	pk_rflg	CxgtOԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_flg( ID flgid, T_RFLG *pk_rflg )
{
	ER			ercd;
	WIFLGSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rflg ){
		return E_PAR;
	}
	wi_CommonLock();

	//! CxgtȌԂ擾.
	ercd = wi_RefarenceEvFlag( flgid, &sts );
	if( ercd == E_OK ){
		pk_rflg->wtskid = sts.WaitId;
		pk_rflg->flgptn = (FLGPTN)sts.FlgVal;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * ʐM@\ (f[^L[).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	f[^L[̐.
 *
 *	@param	[in]	dtqid	f[^L[IDԍ.
 *	@param	[in]	pk_cdtq	f[^L[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_dtq( ID dtqid, const T_CDTQ *pk_cdtq )
{
	ER			ercd;
	WIDTQOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cdtq ){
		return E_PAR;
	}
	//! f[^L[Rs[.
	memset( &obj, 0, sizeof(WIDTQOBJ) );
	obj.Attribute = pk_cdtq->dtqatr;
	obj.QueSize   = pk_cdtq->dtqcnt;

	wi_CommonLock();

	//! f[^L[𐶐.
	ercd = wi_CreateDataQueue( (DWORD)dtqid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	f[^L[̐ (IDԍt).
 *
 *	@param	[in]	pk_cdtq	f[^L[\̂̃|C^.
 *
 *	@retval	f[^L[̃f[^L[ID܂̓G[R[h.
 */
ER_ID	acre_dtq( const T_CDTQ *pk_cdtq )
{
	ID			dtqid;
	ER			ercd;
	WIDTQOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cdtq ){
		return E_PAR;
	}
	//! f[^L[Rs[.
	memset( &obj, 0, sizeof(WIDTQOBJ) );
	obj.Attribute = pk_cdtq->dtqatr;
	obj.QueSize   = pk_cdtq->dtqcnt;

	wi_CommonLock();

	for( dtqid = 1; dtqid < TMAX_MAXDTQ; dtqid++ ){
		//! f[^L[𐶐.
		ercd = wi_CreateDataQueue( dtqid, &obj );
		if( ercd == E_OK ){
			ercd  = dtqid;
			break;
		}
	}
	if( ercd == E_OBJ ){
		ercd  = E_NOID;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	f[^L[̍폜.
 *
 *	@param	[in]	dtqid	f[^L[IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_dtq( ID dtqid )
{
	ER ercd;

	wi_CommonLock();

	//! f[^L[폜.
	ercd = wi_DeleteDataQueue( dtqid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	f[^L[ւ̑M (^CAEgȂ).
 *
 *	@param	[in]	dtqid	f[^L[IDԍ.
 *	@param	[in]	data	f[^L[ɑMf[^.
 *
 *	@retval	G[R[h.
 */
ER		snd_dtq( ID dtqid, VP_INT data )
{
	//! ^CAEgȂŃf[^L[փf[^𑗐M.
	return tsnd_dtq( dtqid, data, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	f[^L[ւ̑M (|[O).
 *
 *	@param	[in]	dtqid	f[^L[IDԍ.
 *	@param	[in]	data	f[^L[ɑMf[^.
 *
 *	@retval	G[R[h.
 */
ER		psnd_dtq( ID dtqid, VP_INT data )
{
	//! M҂ȂŃf[^L[փf[^𑗐M.
	return tsnd_dtq( dtqid, data, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	f[^L[ւ̑M (^XNReLXǧďop).
 *
 *	@param	[in]	dtqid	f[^L[IDԍ.
 *	@param	[in]	data	f[^L[ɑMf[^.
 *
 *	@retval	G[R[h.
 */
ER		ipsnd_dtq( ID dtqid, VP_INT data )
{
	//! f[^L[փf[^𑗐M.
	return psnd_dtq( dtqid, data );
}

/****************************************************************************/
/*!
 *	@brief	f[^L[ւ̑M (^CAEg).
 *
 *	@param	[in]	dtqid	f[^L[IDԍ.
 *	@param	[in]	data	f[^L[ɑMf[^.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		tsnd_dtq( ID dtqid, VP_INT data, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! f[^L[փf[^𑗐M.
	ercd = wi_SendDataQueue( dtqid, (DWORD)data, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	f[^L[֋M.
 *
 *	@param	[in]	dtqid	f[^L[IDԍ.
 *	@param	[in]	data	f[^L[ɑMf[^.
 *
 *	@retval	G[R[h.
 */
ER		fsnd_dtq( ID dtqid, VP_INT data )
{
	ER ercd;

	wi_CommonLock();

	//! f[^L[փf[^M.
	ercd = wi_ForceSendDataQueue( dtqid, (DWORD)data );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	f[^L[֋M (^XNReLXǧďop).
 *
 *	@param	[in]	dtqid	f[^L[IDԍ.
 *	@param	[in]	data	f[^L[ɑMf[^.
 *
 *	@retval	G[R[h.
 */
ER		ifsnd_dtq( ID dtqid, VP_INT data )
{
	//! f[^L[փf[^M.
	return fsnd_dtq( dtqid, data );
}

/****************************************************************************/
/*!
 *	@brief	f[^L[̎M (^CAEgȂ).
 *
 *	@param	[in]	dtqid	f[^L[IDԍ.
 *	@param	[out]	p_data	f[^L[Mf[^i[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		rcv_dtq( ID dtqid, VP_INT *p_data )
{
	//! ^CAEgȂŃf[^L[f[^M.
	return trcv_dtq( dtqid, p_data, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	f[^L[̎M (|[O).
 *
 *	@param	[in]	dtqid	f[^L[IDԍ.
 *	@param	[out]	p_data	f[^L[Mf[^i[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		prcv_dtq( ID dtqid, VP_INT *p_data )
{
	//! f[^M҂ȂŃf[^L[f[^M.
	return trcv_dtq( dtqid, p_data, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	f[^L[̎M (^CAEg).
 *
 *	@param	[in]	dtqid	f[^L[IDԍ.
 *	@param	[out]	p_data	f[^L[Mf[^i[̈̃|C^.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		trcv_dtq( ID dtqid, VP_INT *p_data, TMO tmout )
{
	ER		ercd;
	DWORD	data;

	//! sȏꍇ̓G[ɂ.
	if( !p_data ){
		return E_PAR;
	}
	wi_CommonLock();

	//! f[^L[f[^M.
	ercd = wi_ReceiveDataQueue( dtqid, &data, tmout );
	if( ercd == E_OK ){
		*p_data = (VP_INT)data;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	f[^L[̏ԎQ.
 *
 *	@param	[in]	dtqid	f[^L[IDԍ.
 *	@param	[out]	pk_rdtq	f[^L[Ԃi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_dtq( ID dtqid, T_RDTQ *pk_rdtq )
{
	ER			ercd;
	WIDTQSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rdtq ){
		return E_PAR;
	}
	wi_CommonLock();

	//! f[^L[̏Ԃ擾.
	ercd = wi_RefarenceDataQueue( dtqid, &sts );
	if( ercd == E_OK ){
		pk_rdtq->stskid  = sts.SndWaitId;
		pk_rdtq->rtskid  = sts.RcvWaitId;
		pk_rdtq->sdtqcnt = sts.DataCnt;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * ʐM@\ ([{bNX).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	[{bNX̐.
 *
 *	@param	[in]	mbxid	[{bNXIDԍ.
 *	@param	[in]	pk_cmbx	[{bNX\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_mbx( ID mbxid, const T_CMBX *pk_cmbx )
{
	ER			ercd;
	WIMBXOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cmbx ){
		return E_PAR;
	}
	//! [{bNXRs[.
	memset( &obj, 0, sizeof(WIMBXOBJ) );
	obj.Attribute   = pk_cmbx->mbxatr;
	obj.MaxPriority = pk_cmbx->maxmpri;

	wi_CommonLock();

	//! [{bNX𐶐.
	ercd = wi_CreateMailBox( mbxid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̐ (IDԍt).
 *
 *	@param	[in]	pk_cmbx	[{bNX\̂̃|C^.
 *
 *	@retval	[{bNX̃[{bNXID܂̓G[R[h.
 */
ER_ID	acre_mbx( const T_CMBX *pk_cmbx )
{
	ID			mbxid;
	ER			ercd;
	WIMBXOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cmbx ){
		return E_PAR;
	}
	//! [{bNXRs[.
	memset( &obj, 0, sizeof(WIMBXOBJ) );
	obj.Attribute   = pk_cmbx->mbxatr;
	obj.MaxPriority = pk_cmbx->maxmpri;

	wi_CommonLock();

	for( mbxid = 1; mbxid < TMAX_MAXMBX; mbxid++ ){
		//! [{bNX𐶐.
		ercd = wi_CreateMailBox( mbxid, &obj );
		if( ercd == E_OK ){
			ercd = mbxid;
			break;
		}
	}
	if( ercd == E_OBJ ){
		ercd  = E_NOID;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̍폜.
 *
 *	@param	[in]	mbxid	[{bNXIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_mbx( ID mbxid )
{
	ER ercd;

	wi_CommonLock();

	//! [{bNX폜.
	ercd = wi_DeleteMailBox( mbxid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	[{bNXւ̑M.
 *
 *	@param	[in]	mbxid	[{bNXIDԍ.
 *	@param	[in]	pk_msg	bZ[WpPbg̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		snd_msg( ID mbxid, T_MSG *pk_msg )
{
	ER ercd;

	wi_CommonLock();

	//! [{bNXփbZ[W𑗐M.
	ercd = wi_SendMailBox( mbxid, pk_msg );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̎M (^CAEgȂ).
 *
 *	@param	[in]	mbxid	[{bNXIDԍ.
 *	@param	[out]	ppk_msg	bZ[WpPbg̃AhXi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		rcv_msg( ID mbxid, T_MSG **ppk_msg )
{
	//! ^CAEgȂŃ[{bNX烁bZ[WM.
	return trcv_msg( mbxid, ppk_msg, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̎M (|[O).
 *
 *	@param	[in]	mbxid	[{bNXIDԍ.
 *	@param	[out]	ppk_msg	bZ[WpPbg̃AhXi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		prcv_msg( ID mbxid, T_MSG **ppk_msg )
{
	//! M҂ȂŃ[{bNX烁bZ[WM.
	return trcv_msg( mbxid, ppk_msg, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̎M (^CAEg).
 *
 *	@param	[in]	mbxid	[{bNXIDԍ.
 *	@param	[out]	ppk_msg	bZ[WpPbg̃AhXi[̈̃|C^.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		trcv_msg( ID mbxid, T_MSG **ppk_msg, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! [{bNX烁bZ[WM.
	ercd = wi_ReceiveMailBox( mbxid, ppk_msg, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̏ԎQ.
 *
 *	@param	[in]	mbxid	[{bNXIDԍ.
 *	@param	[out]	pk_rmbx	[{bNXԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_mbx( ID mbxid, T_RMBX *pk_rmbx )
{
	ER			ercd;
	WIMBXSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rmbx ){
		return E_PAR;
	}
	wi_CommonLock();

	//! [{bNX̏Ԃ擾.
	ercd = wi_RefarenceMailBox( mbxid, &sts );
	if( ercd == E_OK ){
		pk_rmbx->wtskid = sts.WaitId;
		pk_rmbx->pk_msg = sts.NextMsg;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * gʐM@\ (~[ebNX).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	~[ebNX̐.
 *
 *	@param	[in]	mtxid	~[ebNXIDԍ.
 *	@param	[in]	pk_cmtx	~[ebNX\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_mtx( ID mtxid, const T_CMTX *pk_cmtx )
{
	ER			ercd;
	WIMTXOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cmtx ){
		return E_PAR;
	}
	//! ~[ebNXRs[.
	memset( &obj, 0, sizeof(WIMTXOBJ) );
	obj.Attribute = pk_cmtx->mtxatr;
	obj.CeilPri   = pk_cmtx->ceilpri;

	wi_CommonLock();

	//! ~[ebNX𐶐.
	ercd = wi_CreateMutex( mtxid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	~[ebNX̐ (IDԍt).
 *
 *	@param	[in]	pk_cmtx	~[ebNX\̂̃|C^.
 *
 *	@retval	~[ebNXIDԍ܂̓G[R[h.
 */
ER_ID	acre_mtx( const T_CMTX *pk_cmtx )
{
	ID			mtxid;
	ER			ercd;
	WIMTXOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cmtx ){
		return E_PAR;
	}
	//! ~[ebNXRs[.
	memset( &obj, 0, sizeof(WIMTXOBJ) );
	obj.Attribute = pk_cmtx->mtxatr;
	obj.CeilPri   = pk_cmtx->ceilpri;

	wi_CommonLock();

	for( mtxid = 1; mtxid < TMAX_MAXMTX; mtxid++ ){
		//! ~[ebNX𐶐.
		ercd = wi_CreateMutex( mtxid, &obj );
		if( ercd == E_OK ){
			ercd  = mtxid;
			break;
		}
	}
	if( ercd == E_OBJ ){
		ercd  = E_NOID;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	~[ebNX̍폜.
 *
 *	@param	[in]	mtxid	~[ebNXIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_mtx( ID mtxid )
{
	ER ercd;

	wi_CommonLock();

	//! ~[ebNX폜.
	ercd = wi_DeleteMutex( mtxid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	~[ebNX̃bN (^CAEgȂ).
 *
 *	@param	[in]	mtxid	~[ebNXIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		loc_mtx( ID mtxid )
{
	//! ^CAEgȂŃ~[ebNXbN.
	return tloc_mtx( mtxid, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	~[ebNX̃bN (|[O).
 *
 *	@param	[in]	mtxid	~[ebNXIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		ploc_mtx( ID mtxid )
{
	//! ~[ebNXbNł邩ǂׂ.
	return tloc_mtx( mtxid, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	~[ebNX̃bN (^CAEg).
 *
 *	@param	[in]	mtxid	~[ebNXIDԍ.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		tloc_mtx( ID mtxid, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! ~[ebNXbN.
	ercd = wi_LockMutex( mtxid, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	~[ebNX̃bN.
 *
 *	@param	[in]	mtxid	~[ebNXIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		unl_mtx( ID mtxid )
{
	ER ercd;

	wi_CommonLock();

	//! ~[ebNX̃bN.
	ercd = wi_UnlockMutex( mtxid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	~[ebNX̏ԎQ.
 *
 *	@param	[in]	mtxid	~[ebNXIDԍ.
 *	@param	[out]	pk_rmbx	~[ebNXԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_mtx( ID mtxid, T_RMTX *pk_rmtx )
{
	ER			ercd;
	WIMTXSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rmtx ){
		return E_PAR;
	}
	wi_CommonLock();

	//! ~[ebNX̏Ԃ擾.
	ercd = wi_RefarenceMutex( mtxid, &sts );
	if( ercd == E_OK ){
		pk_rmtx->htskid = sts.LockId;
		pk_rmtx->wtskid = sts.WaitId;
	}
	wi_CommonUnlock();
	return E_OK;
}

/***************************************
 *
 * gʐM@\ (bZ[Wobt@).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̐.
 *
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *	@param	[in]	pk_cmbf	bZ[Wobt@\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_mbf( ID mbfid, const T_CMBF *pk_cmbf )
{
	ER			ercd;
	WIMBFOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cmbf ){
		return E_PAR;
	}
	//! bZ[Wobt@Rs[.
	memset( &obj, 0, sizeof(WIMBFOBJ) );
	obj.SndAttr = pk_cmbf->mbfatr;
	obj.RcvAttr = pk_cmbf->mbfatr & ~TA_TPRI;
	obj.MsgSize = pk_cmbf->mbfsz;
	obj.MaxMsg  = pk_cmbf->maxmsz;

	wi_CommonLock();

	//! bZ[Wobt@𐶐.
	ercd = wi_CreateMsgBuffer( mbfid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̐ (IDԍt).
 *
 *	@param	[in]	pk_cmbf	bZ[Wobt@\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER_ID	acre_mbf( const T_CMBF *pk_cmbf )
{
	ID			mbfid;
	ER			ercd;
	WIMBFOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cmbf ){
		return E_PAR;
	}
	//! bZ[Wobt@Rs[.
	memset( &obj, 0, sizeof(WIMBFOBJ) );
	obj.SndAttr = pk_cmbf->mbfatr;
	obj.RcvAttr = pk_cmbf->mbfatr & ~TA_TPRI;
	obj.MsgSize = pk_cmbf->mbfsz;
	obj.MaxMsg  = pk_cmbf->maxmsz;

	wi_CommonLock();

	for( mbfid = 1; mbfid < TMAX_MAXMBF; mbfid++ ){
		//! bZ[Wobt@𐶐.
		ercd = wi_CreateMsgBuffer( mbfid, &obj );
		if( ercd == E_OK ){
			ercd  = mbfid;
			break;
		}
	}
	if( ercd == E_OBJ ){
		ercd  = E_NOID;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̍폜.
 *
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_mbf( ID mbfid )
{
	ER ercd;

	wi_CommonLock();

	//! bZ[Wobt@폜.
	ercd = wi_DeleteMsgBuffer( mbfid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@ւ̑M (^CAEgȂ).
 *
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *	@param	[in]	msg		bZ[W̃|C^.
 *	@param	[in]	msgsz	bZ[W̃TCY.
 *
 *	@retval	G[R[h.
 */
ER		snd_mbf( ID mbfid, VP msg, UINT msgsz )
{
	//! ^CAEgȂŃbZ[Wobt@փbZ[W𑗐M.
	return tsnd_mbf( mbfid, msg, msgsz, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@ւ̑M (|[O).
 *
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *	@param	[in]	msg		bZ[W̃|C^.
 *	@param	[in]	msgsz	bZ[W̃TCY.
 *
 *	@retval	G[R[h.
 */
ER		psnd_mbf( ID mbfid, VP msg, UINT msgsz )
{
	//! M҂ȂŃbZ[Wobt@փbZ[W𑗐M.
	return tsnd_mbf( mbfid, msg, msgsz, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@ւ̑M (^CAEg).
 *
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *	@param	[in]	msg		bZ[W̃|C^.
 *	@param	[in]	msgsz	bZ[W̃TCY.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		tsnd_mbf( ID mbfid, VP msg, UINT msgsz, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! bZ[Wobt@փbZ[W𑗐M.
	ercd = wi_SendMsgBuffer( mbfid, msg, msgsz, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̎M (^CAEgȂ).
 *
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *	@param	[out]	msg		bZ[Wi[̈̃|C^.
 *
 *	@retval	bZ[WTCY܂̓G[R[h.
 */
ER_UINT	rcv_mbf( ID mbfid, VP msg )
{
	//! ^CAEgȂŃbZ[Wobt@烁bZ[WM.
	return trcv_mbf( mbfid, msg, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̎M (|[O).
 *
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *	@param	[out]	msg		bZ[Wi[̈̃|C^.
 *
 *	@retval	bZ[WTCY܂̓G[R[h.
 */
ER_UINT	prcv_mbf( ID mbfid, VP msg )
{
	//! M҂ȂŃbZ[Wobt@烁bZ[WM.
	return trcv_mbf( mbfid, msg, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̎M (^CAEg).
 *
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *	@param	[out]	msg		bZ[Wi[̈̃|C^.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	bZ[WTCY܂̓G[R[h.
 */
ER_UINT	trcv_mbf( ID mbfid, VP msg, TMO tmout )
{
	ER		ercd;
	INT		size;

	wi_CommonLock();

	//! bZ[Wobt@烁bZ[WM.
	ercd = wi_ReceiveMsgBuffer( mbfid, msg, &size, tmout );
	if( ercd == E_OK ){
		ercd  = size;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̏ԎQ.
 *
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *	@param	[out]	pk_rmbf	bZ[Wobt@Ԃi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_mbf( ID mbfid, T_RMBF *pk_rmbf )
{
	ER			ercd;
	WIMBFSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rmbf ){
		return E_PAR;
	}
	wi_CommonLock();

	//! bZ[Wobt@̏Ԃ擾.
	ercd = wi_RefarenceMsgBuffer( mbfid, &sts );
	if( ercd == E_OK ){
		pk_rmbf->rtskid  = sts.RcvWaitId;
		pk_rmbf->stskid  = sts.SndWaitId;
		pk_rmbf->smsgcnt = sts.MsgSize;
		pk_rmbf->fmbfsz  = sts.FreeSize;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * gʐM@\ (fu|[g).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	fu|[g̐.
 *
 *	@param	[in]	porid	fu|[gIDԍ.
 *	@param	[in]	pk_cpor	fu|[g\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_por( ID porid, const T_CPOR *pk_cpor )
{
	ER			ercd;
	WIPOROBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cpor ){
		return E_PAR;
	}
	//! fu|[gRs[.
	memset( &obj, 0, sizeof(WIPOROBJ) );
	obj.Attribute = pk_cpor->poratr;
	obj.MaxCalMsg = pk_cpor->maxcmsz;
	obj.MaxRepMsg = pk_cpor->maxrmsz;

	wi_CommonLock();

	//! fu|[g𐶐.
	ercd = wi_CreateRendPort( porid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fu|[g̐ (IDԍt).
 *
 *	@param	[in]	pk_cpor	fu|[g\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER_ID	acre_por( const T_CPOR *pk_cpor )
{
	ID			porid;
	ER			ercd;
	WIPOROBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cpor ){
		return E_PAR;
	}
	//! fu|[gRs[.
	memset( &obj, 0, sizeof(WIPOROBJ) );
	obj.Attribute = pk_cpor->poratr;
	obj.MaxCalMsg = pk_cpor->maxcmsz;
	obj.MaxRepMsg = pk_cpor->maxrmsz;

	wi_CommonLock();

	for( porid = 1; porid < TMAX_MAXPOR; porid++ ){
		//! fu|[g𐶐.
		ercd = wi_CreateRendPort( porid, &obj );
		if( ercd == E_OK ){
			ercd  = porid;
			break;
		}
	}
	if( ercd == E_OBJ ){
		ercd  = E_NOID;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fu|[g̍폜.
 *
 *	@param	[in]	porid	fu|[gIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_por( ID porid )
{
	ER ercd;

	wi_CommonLock();

	//! fu|[g폜.
	ercd = wi_DeleteRendPort( porid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fuĂяo (^CAEgȂ).
 *
 *	@param	[in]	porid		fu|[gIDԍ.
 *	@param	[in]	calptn		ĂяoĨrbgp^[.
 *	@param	[in]	msg			bZ[W̃AhX.
 *	@param	[in]	cmsgsz		ĂяobZ[W̃TCY.
 *
 *	@retval	bZ[W̃TCY܂̓G[R[h.
 */
ER_UINT	cal_por( ID porid, RDVPTN calptn, VP msg, UINT cmsgsz )
{
	//! ^CAEgȂŃfuĂяo.
	return tcal_por( porid, calptn, msg, cmsgsz, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	fuĂяo (^CAEg).
 *
 *	@param	[in]	porid		fu|[gIDԍ.
 *	@param	[in]	calptn		ĂяoĨrbgp^[.
 *	@param	[in]	msg			bZ[W̃AhX.
 *	@param	[in]	cmsgsz		ĂяobZ[W̃TCY.
 *	@param	[in]	tmout		^CAEgݒ.
 *
 *	@retval	bZ[W̃TCY܂̓G[R[h.
 */
ER_UINT	tcal_por( ID porid, RDVPTN calptn, VP msg, UINT cmsgsz, TMO tmout )
{
	ER	ercd;
	INT	size;

	wi_CommonLock();

	//! fuĂяo.
	ercd = wi_CallRendPort( porid, calptn, msg, cmsgsz, &size, tmout );
	if( ercd == E_OK ){
		ercd  = size;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fu󂯕t (^CAEgȂ).
 *
 *	@param	[in]	porid		fu|[gIDԍ.
 *	@param	[in]	acpptn		󂯕tĨrbgp^[.
 *	@param	[out]	p_rdvno		fuԍi[̈̃|C^.
 *	@param	[out]	msg			ĂяobZ[Wi[̈̃|C^.
 *
 *	@retval	ĂяobZ[W̃TCY܂̓G[R[h.
 */
ER_UINT	acp_por( ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg )
{
	//! ^CAEgȂŃfu󂯕t.
	return tacp_por( porid, acpptn, p_rdvno, msg, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	fu󂯕t (|[O).
 *
 *	@param	[in]	porid		fu|[gIDԍ.
 *	@param	[in]	acpptn		󂯕tĨrbgp^[.
 *	@param	[out]	p_rdvno		fuԍi[̈̃|C^.
 *	@param	[out]	msg			ĂяobZ[Wi[̈̃|C^.
 *
 *	@retval	ĂяobZ[W̃TCY܂̓G[R[h.
 */
ER_UINT	pacp_por( ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg )
{
	//! Ăяo҂ȂŃfu󂯕t.
	return tacp_por( porid, acpptn, p_rdvno, msg, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	fu󂯕t (^CAEg).
 *
 *	@param	[in]	porid		fu|[gIDԍ.
 *	@param	[in]	acpptn		󂯕tĨrbgp^[.
 *	@param	[out]	p_rdvno		fuԍi[̈̃|C^.
 *	@param	[out]	msg			ĂяobZ[Wi[̈̃|C^.
 *	@param	[in]	tmout		^CAEgݒ.
 *
 *	@retval	ĂяobZ[W̃TCY܂̓G[R[h.
 */
ER_UINT	tacp_por( ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg, TMO tmout )
{
	ER	ercd;
	INT	size;

	wi_CommonLock();

	//! fu󂯕t.
	ercd = wi_AcceptRendPort( porid, acpptn, p_rdvno, msg, &size, tmout );
	if( ercd == E_OK ){
		ercd  = size;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fủ
 *
 *	@param	[in]	porid		fu|[gIDԍ.
 *	@param	[in]	calptn		󂯕tĨrbgp^[.
 *	@param	[in]	rdvno		fuԍ.
 *	@param	[in]	msg			ĂяobZ[W̃|C^.
 *	@param	[in]	cmsgsz		ĂяobZ[W̃TCY.
 *
 *	@retval	G[R[h.
 */
ER		fwd_por( ID porid, RDVPTN calptn, RDVNO rdvno, VP msg, UINT cmsgsz )
{
	ER ercd;

	wi_CommonLock();

	//! fu𑼂̃fu|[gɉ񑗂.
	ercd = wi_FowardRendPort( porid, calptn, rdvno, msg, cmsgsz );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fȕI.
 *
 *	@param	[in]	rdvno		fuԍ.
 *	@param	[in]	msg			ԓbZ[W̃|C^.
 *	@param	[in]	cmsgsz		ԓbZ[W̃TCY.
 *
 *	@retval	G[R[h.
 */
ER		rpl_rdv( RDVNO rdvno, VP msg, UINT cmsgsz )
{
	ER ercd;

	wi_CommonLock();

	//! fȕIʒm.
	ercd = wi_ReplayRendPort( rdvno, msg, cmsgsz );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fu|[g̏ԎQ.
 *
 *	@param	[in]	porid	fu|[gIDԍ.
 *	@param	[out]	pk_rpor	fu|[gԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_por( ID porid, T_RPOR *pk_rpor )
{
	ER			ercd;
	WIPORSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rpor ){
		return E_PAR;
	}
	wi_CommonLock();

	//! fu|[g̏Ԃ擾.
	ercd = wi_RefarenceRendPort( porid, &sts );
	if( ercd == E_OK ){
		pk_rpor->ctskid = sts.CalWaitId;
		pk_rpor->atskid = sts.AcpWaitId;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fuԂ̎Q.
 *
 *	@param	[in]	rdvno	fuԍ.
 *	@param	[out]	pk_rrdv	fuԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_rdv( RDVNO rdvno, T_RRDV *pk_rrdv )
{
	ER			ercd;
	WIRDVSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rrdv ){
		return E_PAR;
	}
	wi_CommonLock();

	//! fuԂ擾.
	ercd = wi_RefarenceRendStat( rdvno, &sts );
	if( ercd == E_OK ){
		pk_rrdv->wtskid = sts.WaitId;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * v[Ǘ@\ (Œ蒷v[).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	Œ蒷v[̐.
 *
 *	@param	[in]	mpfid	v[IDԍ.
 *	@param	[in]	pk_cmpf	v[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_mpf( ID mpfid, const T_CMPF *pk_cmpf )
{
	ER			ercd;
	WIMPFOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cmpf ){
		return E_PAR;
	}
	//! Œ蒷v[Rs[.
	memset( &obj, 0, sizeof(WIMPFOBJ) );
	obj.Attribute = pk_cmpf->mpfatr;
	obj.BlockCnt  = pk_cmpf->blkcnt;
	obj.BlockSize = pk_cmpf->blfsz;

	wi_CommonLock();

	//! Œ蒷v[𐶐.
	ercd = wi_CreateFixedMemPool( mpfid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷v[̐ (IDԍt).
 *
 *	@param	[in]	pk_cmpf	v[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		acre_mpf( const T_CMPF *pk_cmpf )
{
	ID			mpfid;
	ER			ercd;
	WIMPFOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cmpf ){
		return E_PAR;
	}
	//! Œ蒷v[Rs[.
	memset( &obj, 0, sizeof(WIMPFOBJ) );
	obj.Attribute = pk_cmpf->mpfatr;
	obj.BlockCnt  = pk_cmpf->blkcnt;
	obj.BlockSize = pk_cmpf->blfsz;

	wi_CommonLock();

	for( mpfid = 1; mpfid < TMAX_MAXMPF; mpfid++ ){
		//! Œ蒷v[𐶐.
		ercd = wi_CreateFixedMemPool( mpfid, &obj );
		if( ercd == E_OK ){
			ercd  = mpfid;
			break;
		}
	}
	if( ercd == E_OBJ ){
		ercd  = E_NOID;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷v[̍폜.
 *
 *	@param	[in]	mpfid	v[IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_mpf( ID mpfid )
{
	ER ercd;

	wi_CommonLock();

	//! Œ蒷v[폜.
	ercd = wi_DeleteFixedMemPool( mpfid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷ubN̊l (^CAEgȂ).
 *
 *	@param	[in]	mpfid	v[IDԍ.
 *	@param	[out]	p_blf	ubÑAhXi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		get_blf(ID mpfid, VP *p_blf )
{
	//! ^CAEgȂŌŒ蒷ubNl.
	return tget_blf( mpfid, p_blf, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷ubN̊l (|[O).
 *
 *	@param	[in]	mpfid	v[IDԍ.
 *	@param	[out]	p_blf	ubÑAhXi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		pget_blf(ID mpfid, VP *p_blf )
{
	//! l҂ȂŌŒ蒷ubNl.
	return tget_blf( mpfid, p_blf, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷ubN̊l (^CAEg).
 *
 *	@param	[in]	mpfid	v[IDԍ.
 *	@param	[out]	p_blf	ubÑAhXi[̈̃|C^.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		tget_blf(ID mpfid, VP *p_blf, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! Œ蒷ubNl.
	ercd = wi_GetFixedMemPool( mpfid, p_blf, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷ubN̕ԋp.
 *
 *	@param	[in]	mpfid	v[IDԍ.
 *	@param	[in]	blf		ԋp郁ubÑAhX.
 *
 *	@retval	G[R[h.
 */
ER		rel_blf( ID mpfid, VP blf )
{
	ER ercd;

	wi_CommonLock();

	//! Œ蒷ubNԋp.
	ercd = wi_ReleaseFixedMemPool( mpfid, blf );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷v[̎Q.
 *
 *	@param	[in]	mpfid	v[IDԍ.
 *	@param	[out]	pk_rmpf	v[Ԃi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_mpf( ID mpfid , T_RMPF *pk_rmpf )
{
	ER			ercd;
	WIMPFSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rmpf ){
		return E_PAR;
	}
	wi_CommonLock();

	//! Œ蒷v[̏Ԃ擾.
	ercd = wi_RefarenceFixedMemPool( mpfid, &sts );
	if( ercd == E_OK ){
		pk_rmpf->wtskid  = sts.WaitId;
		pk_rmpf->fblkcnt = sts.FreeBlock;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * v[Ǘ@\ (ϒv[).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	ϒv[̐.
 *
 *	@param	[in]	mplid	v[IDԍ.
 *	@param	[in]	pk_cmpl	v[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_mpl( ID mplid, const T_CMPL *pk_cmpl )
{
	ER			ercd;
	WIMPLOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cmpl ){
		return E_PAR;
	}
	//! ϒv[Rs[.
	memset( &obj, 0, sizeof(WIMPLOBJ) );
	obj.Attribute = pk_cmpl->mplatr;
	obj.MemSize   = pk_cmpl->mplsz;

	wi_CommonLock();

	//! ϒv[𐶐.
	ercd = wi_CreateVarMemPool( mplid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	ϒv[̐ (IDԍt).
 *
 *	@param	[in]	pk_cmpl	v[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		acre_mpl( const T_CMPL *pk_cmpl )
{
	ID			mplid;
	ER			ercd;
	WIMPLOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cmpl ){
		return E_PAR;
	}
	//! ϒv[Rs[.
	memset( &obj, 0, sizeof(WIMPLOBJ) );
	obj.Attribute = pk_cmpl->mplatr;
	obj.MemSize   = pk_cmpl->mplsz;

	wi_CommonLock();

	for( mplid = 1; mplid < TMAX_MAXMPL; mplid++ ){
		//! ϒv[𐶐.
		ercd = wi_CreateVarMemPool( mplid, &obj );
		if( ercd == E_OK ){
			ercd  = mplid;
			break;
		}
	}
	if( ercd == E_OBJ ){
		ercd  = E_NOID;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	ϒv[̍폜.
 *
 *	@param	[in]	mpfid	v[IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_mpl( ID mplid )
{
	ER ercd;

	wi_CommonLock();

	//! ϒv[폜.
	ercd = wi_DeleteVarMemPool( mplid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	ϒubN̊l (^CAEgȂ).
 *
 *	@param	[in]	mplid	v[IDԍ.
 *	@param	[in]	blksz	ubÑTCY.
 *	@param	[in]	p_blk	ubÑAhXi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		get_mpl( ID mplid, UINT blksz, VP *p_blk )
{
	//! ^CAEgȂŉϒubNl.
	return tget_mpl( mplid, blksz, p_blk, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	ϒubN̊l (|[O).
 *
 *	@param	[in]	mplid	v[IDԍ.
 *	@param	[in]	blksz	ubÑTCY.
 *	@param	[in]	p_blk	ubÑAhXi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		pget_mpl( ID mplid, UINT blksz, VP *p_blk )
{
	//! l҂ȂŉϒubNl.
	return tget_mpl( mplid, blksz, p_blk, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	ϒubN̊l (^CAEg).
 *
 *	@param	[in]	mplid	v[IDԍ.
 *	@param	[in]	blksz	ubÑTCY.
 *	@param	[in]	p_blk	ubÑAhXi[̈̃|C^.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		tget_mpl( ID mplid, UINT blksz, VP *p_blk, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! ϒubNl.
	ercd = wi_GetVarMemPool( mplid, p_blk, blksz, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	ϒubN̕ԋp.
 *
 *	@param	[in]	mplid	v[IDԍ.
 *	@param	[in]	blk		ԋp郁ubÑAhX.
 *
 *	@retval	G[R[h.
 */
ER		rel_blk( ID mplid, VP blk )
{
	ER ercd;

	wi_CommonLock();

	//! ϒubNԋp.
	ercd = wi_ReleaseVarMemPool( mplid, blk );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	ϒv[̎Q.
 *
 *	@param	[in]	mpfid	v[IDԍ.
 *	@param	[out]	pk_rmpl	v[Ԃi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_mpl( ID mpfid, T_RMPL *pk_rmpl )
{
	ER			ercd;
	WIMPLSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rmpl ){
		return E_PAR;
	}
	wi_CommonLock();

	//! ϒv[̏Ԃ擾.
	ercd = wi_RefarenceVarMemPool( mpfid, &sts );
	if( ercd == E_OK ){
		pk_rmpl->wtskid = sts.WaitId;
		pk_rmpl->fmplsz = sts.TotalFreeSize;
		pk_rmpl->fblksz = sts.MaxFreeSize;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * ԊǗ@\.
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	VXe̐ݒ.
 *
 *	@param	[in]	pk_tim		ݒ肷鎞i[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		set_tim( const SYSTIME *pk_tim )
{
	if( !pk_tim ){
		return E_PAR;
	}
	wi_CommonLock();

	//! VXeݒ肷.
	wi_SetSystemTime( ((DWORDLONG)(pk_tim->utime) << 32) + (DWORDLONG)(pk_tim->ltime) );

	wi_CommonUnlock();
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	VXe̎Q.
 *
 *	@param	[in]	pk_tim		VXei[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		get_tim( SYSTIME *pk_tim )
{
	DWORDLONG sys_time;

	if( !pk_tim ){
		return E_PAR;
	}
	wi_CommonLock();

	//! VXeQƂ.
	sys_time      = wi_GetSystemTime();
	pk_tim->utime = (short)(sys_time >> 32 & 0x0000FFFF);
	pk_tim->ltime = (long )(sys_time       & 0xFFFFFFFF);

	wi_CommonUnlock();
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	^CeBbN̋.
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		isig_tim( void )
{
	return E_NOSPT;
}

/***************************************
 *
 * ԊǗ@\ (nh).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	nh̐.
 *
 *	@param	[in]	cycid	nhIDԍ.
 *	@param	[in]	pk_ccyc	nh\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_cyc( ID cycid, const T_CCYC *pk_ccyc )
{
	ER			ercd;
	WICYCOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_ccyc ){
		return E_PAR;
	}
	//! nh`Rs[.
	memset( &obj, 0, sizeof(WICYCOBJ) );
	obj.Attribute = pk_ccyc->cycatr;
	obj.CycAdr    = pk_ccyc->cychdr;
	obj.Active    = (pk_ccyc->cycatr & TA_STA) ? TRUE : FALSE;
	obj.ExtInfo   = pk_ccyc->exinf;
	obj.CycleTime = ((DWORDLONG)(pk_ccyc->cyctim.utime) << 32) + (DWORDLONG)(pk_ccyc->cyctim.ltime);
	obj.CyclePhs  = ((DWORDLONG)(pk_ccyc->cycphs.utime) << 32) + (DWORDLONG)(pk_ccyc->cycphs.ltime);

	wi_CommonLock();

	//! nho^.
	ercd = wi_DefineCycleHadler( cycid, &obj, FALSE );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	nh̐ (IDԍt).
 *
 *	@param	[in]	pk_ccyc	nh\̂̃|C^.
 *
 *	@retval	nh̃nhID܂̓G[R[h.
 */
ER		acre_cyc( const T_CCYC *pk_ccyc )
{
	ER_ID		ercd;
	ID			cycid;
	WICYCOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_ccyc ){
		return E_PAR;
	}
	//! nh`Rs[.
	memset( &obj, 0, sizeof(WICYCOBJ) );
	obj.Attribute = pk_ccyc->cycatr;
	obj.CycAdr    = pk_ccyc->cychdr;
	obj.Active    = (pk_ccyc->cycatr & TA_STA) ? TRUE : FALSE;
	obj.ExtInfo   = pk_ccyc->exinf;
	obj.CycleTime = ((DWORDLONG)(pk_ccyc->cyctim.utime) << 32) + (DWORDLONG)(pk_ccyc->cyctim.ltime);
	obj.CyclePhs  = ((DWORDLONG)(pk_ccyc->cycphs.utime) << 32) + (DWORDLONG)(pk_ccyc->cycphs.ltime);

	wi_CommonLock();

	for( cycid = 1; cycid < TMAX_MAXCYC; cycid++ ){

		//! nho^.
		ercd = wi_DefineCycleHadler( cycid, &obj, FALSE );
		if( ercd == E_OK ){
			ercd = cycid;
			break;
		}
	}
	if( ercd == E_OBJ ){
		ercd  = E_NOID;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	nh̍폜.
 *
 *	@param	[in]	cycid	nhIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_cyc( ID cycid )
{
	ER ercd;

	wi_CommonLock();

	//! nh폜.
	ercd = wi_DeleteCycleHadler( cycid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	nh̋N.
 *
 *	@param	[in]	cycid	nhIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		sta_cyc( ID cycid )
{
	ER ercd;

	wi_CommonLock();

	//! nhN.
	ercd = wi_ActionCycleHadler( cycid, TRUE, FALSE );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	nh̒~.
 *
 *	@param	[in]	cycid	nhIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		stp_cyc( ID cycid )
{
	ER ercd;

	wi_CommonLock();

	//! nh~.
	ercd = wi_ActionCycleHadler( cycid, FALSE, FALSE );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	nh̏ԎQ.
 *
 *	@param	[in]	cycid	nhIDԍ.
 *	@param	[out]	pk_rcyc	nhԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_cyc( ID cycid, T_RCYC *pk_rcyc )
{
	ER			ercd;
	WICYCSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rcyc ){
		return E_PAR;
	}
	wi_CommonLock();

	//! nh̏Ԃ擾.
	ercd = wi_RefarenceCycleHadler( cycid, &sts );
	if( ercd == E_OK ){
		pk_rcyc->cycstat       = sts.Active ? TCYC_STA : TCYC_STP;
		pk_rcyc->lefttim.utime = (short)(sts.LeftTime >> 32 & 0x0000FFFF);
		pk_rcyc->lefttim.ltime = (long )(sts.LeftTime       & 0xFFFFFFFF);
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * ԊǗ@\ (A[nh).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	A[nh̐.
 *
 *	@param	[in]	almid	A[nhIDԍ.
 *	@param	[in]	pk_calm	A[nh\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_alm( ID almid, const T_CALM *pk_calm )
{
	ER			ercd;
	WIALMOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_calm ){
		return E_PAR;
	}
	//! A[nho^Rs[.
	memset( &obj, 0, sizeof(WIALMOBJ) );
	obj.Attribute = pk_calm->almatr;
	obj.ExtInfo   = pk_calm->exinf;
	obj.AlmAdr    = pk_calm->almhdr;

	wi_CommonLock();

	//! A[nho^.
	ercd = wi_DefineAlarmHadler( almid, &obj, FALSE );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	A[nh̐ (IDԍt).
 *
 *	@param	[in]	pk_calm	A[nh\̂̃|C^.
 *
 *	@retval	A[nh̃nhID܂̓G[R[h.
 */
ER_ID	acre_alm( const T_CALM *pk_calm )
{
	ER_ID		ercd;
	ID			almid;
	WIALMOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_calm ){
		return E_PAR;
	}
	//! A[nho^Rs[.
	memset( &obj, 0, sizeof(WIALMOBJ) );
	obj.Attribute = pk_calm->almatr;
	obj.ExtInfo   = pk_calm->exinf;
	obj.AlmAdr    = pk_calm->almhdr;

	wi_CommonLock();

	for( almid = 1; almid < TMAX_MAXALM; almid++ ){

		//! A[nho^.
		ercd = wi_DefineAlarmHadler( almid, &obj, FALSE );
		if( ercd == E_OK ){
			ercd  = almid;
			break;
		}
	}
	if( ercd == E_OBJ ){
		ercd  = E_NOID;
	}
	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	A[nh̍폜.
 *
 *	@param	[in]	almid	A[nhIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_alm( ID almid )
{
	ER ercd;

	wi_CommonLock();

	//! A[nh폜.
	ercd = wi_DeleteAlarmHadler( almid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	A[nh̋N.
 *
 *	@param	[in]	almid	A[nhIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		sta_alm( ID almid, RELTIM almtim )
{
	ER ercd;

	wi_CommonLock();

	//! A[nhN.
	ercd = wi_StartAlarmHadler( almid, ((DWORDLONG)(almtim.utime) << 32) + (DWORDLONG)(almtim.ltime) );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	A[nh̒~.
 *
 *	@param	[in]	almid	A[nhIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		stp_alm( ID almid )
{
	ER ercd;

	wi_CommonLock();

	//! A[nh~.
	ercd = wi_StopAlarmHadler( almid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	A[nh̏ԎQ.
 *
 *	@param	[in]	almid	A[nhIDԍ.
 *	@param	[out]	pk_ralm	A[nhԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_alm( ID almid, T_RALM *pk_ralm )
{
	ER			ercd;
	WIALMSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_ralm ){
		return E_PAR;
	}
	wi_CommonLock();

	//! A[nh̏Ԃ擾.
	ercd = wi_RefarenceAlarmHadler( almid, &sts );
	if( ercd == E_OK ){
		pk_ralm->almstat       = sts.Active ? TALM_STA : TALM_STP;
		pk_ralm->lefttim.utime = (short)(sts.LeftTime >> 32 & 0x0000FFFF);
		pk_ralm->lefttim.ltime = (long )(sts.LeftTime       & 0xFFFFFFFF);
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * 荞݊Ǘ@\.
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	荞݃nh̒`.
 *
 *	@param	[in]	intno		荞݃nhԍ.
 *	@param	[in]	pk_dinh		荞݃nh`\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		def_inh( INTNO intno, const T_DINH *pk_dinh )
{
	ER			ercd;
	WIINTOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_dinh ){
		return E_PAR;
	}
	//! 荞݃nh`Rs[.
	memset( &obj, 0, sizeof(WIINTOBJ) );
	obj.Attribute = pk_dinh->inhatr;
	obj.IntrAdr   = pk_dinh->inthdr;

	wi_CommonLock();

	//! 荞݃nho^.
	ercd = wi_DefineIntrruptHander( intno, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	荞݂̋֎~.
 *
 *	@param	[in]	intno		荞݃nhԍ.
 *
 *	@retval	G[R[h.
 */
ER		dis_int( INTNO intno )
{
	ER ercd;

	wi_CommonLock();

	//! 荞݂֎~.
	ercd = wi_DisableIntrrupt( intno );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	荞݂̋.
 *
 *	@param	[in]	intno		荞݃nhԍ.
 *
 *	@retval	G[R[h.
 */
ER		ena_int( INTNO intno )
{
	ER ercd;

	wi_CommonLock();

	//! 荞݂.
	ercd = wi_EnableIntrrupt( intno );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CPUbNԂւ̈ڍs.
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		loc_cpu( void )
{
	ER ercd;

	wi_CommonLock();

	//! CPUbN.
	ercd = wi_LockCPU();

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CPUbNԂ̉.
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		unl_cpu( void )
{
	ER ercd;

	wi_CommonLock();

	//! CPŨbN.
	ercd = wi_UnLockCPU();

	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * VXeԊǗ@\.
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	^XN̗D揇ʂ̉].
 *
 *	@param	[in]	tskpri	D揇ʂ]Dx.
 *
 *	@retval	G[R[h.
 */
ER		rot_rdq( PRI tskpri )
{
	ER ercd;

	wi_CommonLock();

	//! ^XN̗D揇ʂ].
	ercd = wi_RotateTaskPriority( tskpri );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	sԂ̃^XNID̎Q.
 *
 *	@param	[out]	p_tskid		^XNIDԍi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		get_tid( ID *p_tskid )
{
	ER ercd;

	wi_CommonLock();

	//! sԂɂ^XNID擾.
	ercd = wi_GetTid( p_tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fBXpb`̋֎~.
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		dis_dsp( void )
{
	ER ercd;

	wi_CommonLock();

	//! ^XÑfBXpb`֎~.
	ercd = wi_DisabledDispatch();

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fBXpb`̋.
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		ena_dsp( void )
{
	ER ercd;

	wi_CommonLock();

	//! ^XÑfBXpb`.
	ercd = wi_EnabledDispatch();

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	VXeԂ̎Q.
 *
 *	@param	[out]	pk_rsys		VXeԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_sys( T_RSYS *pk_rsys )
{
	ER ercd;

	wi_CommonLock();

	//! VXe擾.
	ercd = wi_GetSystemInfo( pk_rsys );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	o[W̎Q.
 *
 *	@param	[out]	pk_rver		o[Wi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		get_ver( T_RVER *pk_rver )
{
	ER ercd;

	wi_CommonLock();

	//! o[W擾.
	ercd = wi_GetVersion( pk_rver );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	RtBO[V̎Q.
 *
 *	@param	[out]	pk_rcfg		RtBO[Vi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_cfg( T_RCFG *pk_rcfg )
{
	ER ercd;

	wi_CommonLock();

	//! RtBO[V擾.
	ercd = wi_GetConfigInfo( pk_rcfg );

	wi_CommonUnlock();
	return ercd;
}

#endif	// __ITRON4__

/* End of file */
